<?php

function zm_get_report_total($data){
	global $wpdb;
	
	$conditions = '';
	
	$txn_time = zm_isset($data['zm_txn_time']) ? $data['zm_txn_time'] : false;
	$product = zm_isset($data['zm_product']) ? $data['zm_product'] : false;
	$currency = zm_isset($data['zm_txn_currency']) ? $data['zm_txn_currency'] : false;
	$status = isset($data['zm_txn_status']) ? $data['zm_txn_status'] : false;
	
	if ($txn_time){
		if ($txn_date = zm_time_condition('T1.txn_date', $txn_time))
			$conditions .= ' WHERE '.$txn_date;
	}else{
		if ($txn_date = zm_time_condition('T1.txn_date', '7daysago'))
			$conditions .= ' WHERE '.$txn_date;
	}
	
	if ($product){
		if ($product != 'all'){
			$conditions .= $conditions ? ' AND T1.product_id='.$product : ' WHERE T1.product_id='.$product;
		}
	}
	
	if ($currency){
		$conditions .= $conditions ? ' AND T1.currency="'.$currency.'"' : ' WHERE T1.currency="'.$currency.'"';
	}
	
	if ($status != 'all'){
		$conditions .= $conditions ? ' AND T1.status='.$status : ' WHERE T1.status='.$status;
	}

	
	$query = "SELECT  SUM(IF(T1.status = 4, 0, T1.amount)) as profits, SUM(IF(T1.status = 4, T1.amount, 0)) as refunded
	FROM {$wpdb->prefix}zm_payments AS T1
							LEFT JOIN `{$wpdb->prefix}zm_products` AS T2 ON T1.product_id=T2.ID
							LEFT JOIN `{$wpdb->prefix}zm_members` AS T3 ON T1.member_id=T3.ID ".$conditions;
						
	//die($query);
	return $wpdb->get_row($query);
}

function zm_get_count($db, $data=false, $type=''){
	global $wpdb;
	
	switch ($db) {
		case 'product':
			$conditions = '';
			$id = $data;
			if ($txn_time = zm_isset($id['zm_cre_time'])){
				if ($txn_date = zm_time_condition('date', $txn_time, $id['zm_from'], $id['zm_to']))
					$conditions .= ' WHERE '.$txn_date;
			}
			
			if ($product = zm_isset($id['zm_product'])){
				if ($product != 'all'){
					$conditions .= $conditions ? ' AND title LIKE "%'.$product.'%"' : ' WHERE title LIKE "%'.$product.'%"';
				}
			}
			
			if ($type = zm_isset($id['zm_ptype'])){
				if ($type != 'all'){
					$conditions .= $conditions ? ' AND type="'.$type.'"' : ' WHERE type="'.$type.'"';
				}
			}
			
			$query = "SELECT COUNT(*) FROM {$wpdb->prefix}zm_products".$conditions;
			$data = $wpdb->get_var($query);
			break;
		
		case 'member':
			if($data == 'today' || $data == 'yesterday'){
				$local_time = date('Y-m-d', strtotime($data));
	            $from       = strtotime($local_time . ' 00:00:00');
	            $to         = strtotime($local_time . ' 23:59:59');
	            $condition  = ' BETWEEN ' . $from . ' AND ' . $to;
				
				$data = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}zm_members WHERE date".$condition);
			}else{
				$id = $data;
				$conditions = '';
				if ($txn_time = zm_isset($id['zm_reg_time'])){
					if ($txn_date = zm_time_condition('date', $txn_time, $id['zm_from'], $id['zm_to']))
						$conditions .= ' WHERE '.$txn_date;
				}
				
				if ($email = zm_isset($id['zm_email'])){
					if ($email != 'all'){
						$conditions .= $conditions ? ' AND email LIKE "%'.$email.'%"' : ' WHERE email LIKE "%'.$email.'%"';
					}
				}
				
				if ($username = zm_isset($id['zm_username'])){
					if ($username != 'all'){
						$conditions .= $conditions ? ' AND username LIKE "%'.$username.'%"' : ' WHERE username LIKE "%'.$username.'%"';
					}
				}
				
				if ($lock = zm_isset($id['zm_lock'])){
					if ($lock != 'all'){
						$lock = ($lock == 2) ? 0 : $lock;
						$conditions .= $conditions ? ' AND status = '.$lock : ' WHERE status = '.$lock;
					}
				}
				
				if ($status = zm_isset($id['zm_status'])){
					if ($status != 'all'){
						if ($status == 1){
							$payments = zm_get_all('payment', '', 'paying');
						
							if ($payments){
								$ids = '';
								foreach ($payments as $payment){
									$ids .= $ids ? ', '.$payment->member_id : $payment->member_id;
								}
								
								$conditions .= $conditions ? ' AND ID IN ('.$ids.')' : ' WHERE ID IN ('.$ids.')';
							}else{
								$conditions .= $conditions ? ' AND ID=0' : ' WHERE ID=0';
							}
						}else{
							$payments = zm_get_all('payment', '', 'nonpaying');
						
							if ($payments){
								$ids = '';
								foreach ($payments as $payment){
									$ids .= $ids ? ', '.$payment->member_id : $payment->member_id;
								}
								
								$conditions .= $conditions ? ' AND ID IN ('.$ids.')' : ' WHERE ID IN ('.$ids.')';
							}else{
								$conditions .= $conditions ? ' AND ID=0' : ' WHERE ID=0';
							}
						}
					}
				}
	
				$query = "SELECT COUNT(*) FROM {$wpdb->prefix}zm_members".$conditions;
				$data = $wpdb->get_var($query);
			}
			break;
			
		case 'payment':
			$local_time = date('Y-m-d', strtotime($data));
            $from       = strtotime($local_time . ' 00:00:00');
            $to         = strtotime($local_time . ' 23:59:59');
            $condition  = ' BETWEEN ' . $from . ' AND ' . $to;
			
			$data = $wpdb->get_var("SELECT SUM(amount) FROM {$wpdb->prefix}zm_payments WHERE txn_date".$condition);
			
			break;
		
		case 'coupon':
			$data = $wpdb->get_var("SELECT COUNT(*) FROM {$wpdb->prefix}zm_coupons");
			break;
			
		case 'report':
			if ($type == 'engagement'){
				$conditions = '';
				
				if ($txn_time = zm_isset($data['zm_txn_time'])){
					if ($txn_date = zm_time_condition('date', $txn_time, $data['zm_from'], $data['zm_to']))
						$conditions .= 'WHERE '.$txn_date;
				}
					
				$query = "SELECT COUNT(DISTINCT page_id) AS total_page
						FROM `{$wpdb->prefix}zm_access_log`
						{$conditions}";
						
				//die($query);
				$data = $wpdb->get_var($query);
			}else{
				$conditions = '';
			
				$txn_time = zm_isset($data['zm_txn_time']) ? $data['zm_txn_time'] : false;
				$product = zm_isset($data['zm_product']) ? $data['zm_product'] : false;
				$currency = zm_isset($data['zm_txn_currency']) ? $data['zm_txn_currency'] : false;
				$status = isset($data['zm_txn_status']) ? $data['zm_txn_status'] : false;
				
				if ($txn_time){
					if ($txn_date = zm_time_condition('T1.txn_date', $txn_time))
						$conditions .= ' WHERE '.$txn_date;
				}else{
					if ($txn_date = zm_time_condition('T1.txn_date', '7daysago'))
						$conditions .= ' WHERE '.$txn_date;
				}
				
				if ($product){
					if ($product != 'all'){
						$conditions .= $conditions ? ' AND T1.product_id='.$product : ' WHERE T1.product_id='.$product;
					}
				}
				
				if ($currency){
					$conditions .= $conditions ? ' AND T1.currency="'.$currency.'"' : ' WHERE T1.currency="'.$currency.'"';
				}
				
				if ($status != 'all'){
					$conditions .= $conditions ? ' AND T1.status='.$status : ' WHERE T1.status='.$status;
				}
	
				
				$query = "SELECT COUNT(*) FROM {$wpdb->prefix}zm_payments AS T1
										LEFT JOIN `{$wpdb->prefix}zm_products` AS T2 ON T1.product_id=T2.ID
										LEFT JOIN `{$wpdb->prefix}zm_members` AS T3 ON T1.member_id=T3.ID ".$conditions;
									
				//die($query);
				$data = $wpdb->get_var($query);
			}
			break;
			
		default:
			break;
	}
	
	return $data;
}

function zm_add( $db, $data, $type = false ) {
	switch ($db) {
		case 'product':
			// Add a Product
			$meta = array(
				'title' => str_replace('"', "", $data['zm-product-name']),
				'download_id' => $data['zm-download-page'],
				'thanks_url' => $data['zm-thanks-url'],
				'type' => $data['zm-payment-type'],
				'is_trial' => $data['zm-is-trial'],
				'trial_price' => $data['zm-trial-price'],
				'ot_price' => $data['zm-price-o'],
				'rc_price' => $data['zm-price-r'],
				'subs_num' => $data['zm-subscription-duration'],
				'trial_num' => $data['zm-trial-duration'],
				'subs_mode' => $data['zm-subscription-duration-for'],
				'trial_mode' => $data['zm-trial-duration-for'],
				'rebill_times' => $data['zm-rebill-times'],
				'metadata' => maybe_serialize($data['zm-payment-processor']),
				'autoresponder' => maybe_serialize(zm_isset($data['zm-autoresponder'])),
				'gotowebinar' => maybe_serialize(zm_isset($data['zm-gotowebinar'])),
				'status' => 1,
				'date' => strtotime("now")
			);
			$format = array('%s', '%d', '%s', '%s', '%d', '%f', '%f', '%f', '%d', '%d', '%s', '%s', '%d', '%s', '%s', '%s', '%d', '%d');
			
			$id = zm_insert_query('zm_products', $meta, $format);
			
			if ( $type == 'ajax' ) {
				echo $id;
				die();
			}
			
			if ( $id ) {
				global $wpdb;
				
				// Add to SKU table
				$meta = array(
					'payment' => 'zaxaa',
					'product_id' => $id,
					'sku' => $data['zm-payment-processor']['zaxaa']['pid'],
					'vendor' => $data['zm-payment-processor']['zaxaa']['price_num']
				);
				
				$format = array('%s', '%d', '%s', '%s');
				$wpdb->insert("{$wpdb->prefix}zm_sku", $meta, $format);
			
				if ($download_id = $meta['download_id']){
					
					if ($download_id > 0){
						$meta = array(
							'product_id' => $id,
							'post_id' => $download_id,
							'filename' => '',
							'd_start' => 0,
							'd_end' => 9999,
							'd_start_mode' => 'D',
							'd_end_mode' => 'D',
							'd_end_used' => false,
							'is_expired' => 0,
							'date' => strtotime("now")
						);
						
						$format = array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d', '%d');
						
						$insert_id = zm_insert_query('zm_protects', $meta, $format);
					}
				}
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=protect&id='.$id.'&step=complete'));
			} else{
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=products&process=add&added=false'));
			}
			exit;
		break;
		
		case 'member':
			// Add a Member
			$meta = array(
				'username' => $data['zm_username'],
				'email' => $data['zm_email'],
				//'pass' => wp_hash_password($data['zm_password']),
				'pass' => $data['zm_password'],
				'first_name' => $data['zm_fname'],
				'last_name' => $data['zm_lname'],
				'status' => 1,
				'paypal_id' => '',
				'metadata' => maybe_serialize(array('notes' => $data['zm_notes'])),
				'date' => strtotime("now")
			);
			
			$format = array('%s', '%s', '%s', '%s', '%s', '%d', '%s', '%s', '%d');
			
			$insert_id = zm_insert_query('zm_members', $meta, $format);
			
			//Update temp password
			$temp_passwords = get_option('zm_temp_pass');
			if (!$temp_passwords) $temp_passwords = array();
			
			$temp_passwords[$insert_id] = $data['zm_password'];
			update_option('zm_temp_pass', $temp_passwords);
	
			if ($insert_id)
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=edit&added=true&id='.$insert_id));
			else
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=add&added=false'));
				
			exit;
		break;
		
		case 'protect':
			//Save protect page
			if ($type == 'meta'){
				if (isset( $data['post_ID'])){
					zm_delete('protect', $data['post_ID'], 'meta');
				}
			}
			
			if (zm_isset($data['zm-ac-post'])){
				
				//Delete last data
				if ($type != 'meta'){
					$included = array ( 's3' => zm_isset($data['load-buckets'], false, true),
										'file' => zm_isset($data['zm-include-file'], false, true));
					
					if ($included['s3']){
						zm_s3_set_acp_to_public($data['zm-ac-product']);
					}
					
					zm_delete('protect', $data['zm-access-product-id'], $included);
				}
				
				$insert_id = false;
				
				//Add new data
				foreach ($data['zm-ac-post'] as $id){
					$e_used = zm_isset($data['zm-ac-data'][$id]['end']['used'], false, true) ? 1 : 0;
					
					$sval = $data['zm-ac-data'][$id]['start']['value'];
					$eval = $e_used ? $data['zm-ac-data'][$id]['end']['value'] : 1;
					$svald = $data['zm-ac-data'][$id]['start']['value-dp'];
					$evald = $e_used ? $data['zm-ac-data'][$id]['end']['value-dp'] : strtotime("now");
					
					$smode = $data['zm-ac-data'][$id]['start']['mode'];
					$emode = $e_used ? $data['zm-ac-data'][$id]['end']['mode'] : 'D';
					
					if (!$type){
						if (!is_numeric($id)){
							//set ACP
							if (substr($id, 0, 2) == 's3'){
								$file = explode('_', $id);
								zm_s3_set_acp($file[1], zm_decode($file[2], 'zm_s3'));
							}
						}
					}
					
					if ($type == 'meta'){
						$meta = array(
							'product_id' => $id,
							'post_id' => $data['post_ID'],
							'filename' => '',
							'd_start' => ($smode == 'X' ? strtotime($svald.' 00:00:00') : $sval),
							'd_end' => ($emode == 'X' ? strtotime($evald.' 23:59:59') : $eval),
							'd_start_mode' => $smode,
							'd_end_mode' => $emode,
							'd_end_used' => $e_used,
							'is_expired' => 0,
							'date' => strtotime("now")
						);
					}else{
						$meta = array(
							'product_id' => $data['zm-access-product-id'],
							'post_id' => is_numeric($id) ? $id : (substr($id, 0, 8) == 'category' ? -2 : -1),
							'filename' => is_numeric($id) ? '' : $id,
							'd_start' => ($smode == 'X' ? strtotime($svald.' 00:00:00') : $sval),
							'd_end' => ($emode == 'X' ? strtotime($evald.' 23:59:59') : $eval),
							'd_start_mode' => $smode,
							'd_end_mode' => $emode,
							'd_end_used' => $e_used,
							'is_expired' => 0,
							'date' => strtotime("now")
						);
					}
					
					$format = array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d', '%d');
					
					$insert_id = zm_insert_query('zm_protects', $meta, $format);
				}
			}
			if (!$type){
				//Save Files
				if($data['zm-step']){
					wp_redirect(admin_url('admin.php?page=zm-admin&mode=products&type='.$data['zm-ptype'].'&wizard=complete'));
					exit;
				}else{
					wp_redirect(admin_url('admin.php?page=zm-admin&mode=protect&saved=true&id='.$data['zm-access-product-id']));
					exit;
				}
			}
		break;
		
		case 'payment':
			// Add a Member
			$pid = $data['zm-list-product'];
			$type = zm_isset($data['zm-is-subscription'] , false, true) ? 'subscription' : 'onetime';
			
			$meta = array(
				'product_id' => $pid,
				'member_id' => $data['zm-member-id'],
				'type' => $type,
				'paysys' => $data['zm-payment'],
				'receipt' => $data['zm-receipt'],
				'amount' => $data['zm-amount'],
				'is_rebill' => zm_isset($data['zm-rebill']) ? 1 : 0,
				'status' => $data['zm-status-product'], // '0' is pending; '1' is completed; '2' is canceled; '3' is expired; '4' is refunded
				'currency' => $data['zm-currency'],
				'txn_id' => '',
				'other_id' => '',
				'ipaddr' => '',
				'begin_date' => strtotime($data['zm-begin']. ' 00:00:00 UTC'),
				'expired_date' => ($type == 'subscription') ? strtotime($data['zm-expired']. ' 23:59:59 UTC') : strtotime('19 Jan 2038 03:14:07 UTC'),
				'txn_date' => strtotime("now")
			);
			
			$format = array('%d', '%d', '%s', '%s', '%s', '%f', '%d', '%d', '%s', '%s', '%s', '%s', '%d', '%d', '%d');
			
			$insert_id = zm_insert_query('zm_payments', $meta, $format);
			
			if ($insert_id)
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=edit&payment=true&id='.$data['zm-member-id']));
			else
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=edit&payment=false&id='.$data['zm-member-id']));
			
			exit;
			break;
		default:
			break;
	}
}

function zm_update($db, $data, $type=''){
	global $wpdb;
	
	switch ($db) {
		case 'product':
			// Update a Product
			$meta = array(
				'title' => str_replace('"', "", $data['zm-product-name']),
				'download_id' => $data['zm-download-page'],
				'thanks_url' => $data['zm-thanks-url'],
				'type' => ($data['zm-payment-type-main'] == 'free') ? 'free' : $data['zm-payment-type'],
				'is_trial' => $data['zm-is-trial'] == 'off' ? false : true,
				'trial_price' => $data['zm-trial-price'],
				'ot_price' => $data['zm-price-o'],
				'rc_price' => $data['zm-price-r'],
				'subs_num' => $data['zm-subscription-duration'],
				'trial_num' => $data['zm-trial-duration'],
				'subs_mode' => $data['zm-subscription-duration-for'],
				'trial_mode' => $data['zm-trial-duration-for'],
				'rebill_times' => $data['zm-rebill-times'],
				'metadata' => maybe_serialize($data['zm-payment-processor']),
				'autoresponder' => ( isset($data['zm-autoresponder']) ) ? maybe_serialize($data['zm-autoresponder']) : '',
				'gotowebinar' => ( isset($data['zm-gotowebinar']) ) ? maybe_serialize($data['zm-gotowebinar']) : '',
				'status' => 1,
			);
			
			$format = array('%s', '%d', '%s', '%s', '%d', '%f', '%f', '%f', '%d', '%d', '%s', '%s', '%d', '%s', '%s', '%s', '%d');
			$wpdb->update( "{$wpdb->prefix}zm_products", $meta, array( 'ID' => $data['zm-nonce'] ), $format, array( '%d' ) );
			$id = $data['zm-nonce'];
			
			zm_delete('sku', $id);
			
			// Add to SKU table
			$meta = array(
				'payment' => 'zaxaa',
				'product_id' => $id,
				'sku' => $data['zm-payment-processor']['zaxaa']['pid'],
				'vendor' => $data['zm-payment-processor']['zaxaa']['price_num']
			);
			
			$format = array('%s', '%d', '%s', '%s');
			$wpdb->insert("{$wpdb->prefix}zm_sku", $meta, $format);
			

			if ($download_id = $meta['download_id']){
				if ($download_id > 0){
					$is_exist = zm_get_row('protect', array($id, $download_id));
					
					if (!$is_exist){
						$meta = array(
							'product_id' => $id,
							'post_id' => $download_id,
							'filename' => '',
							'd_start' => 0,
							'd_end' => 9999,
							'd_start_mode' => 'D',
							'd_end_mode' => 'D',
							'd_end_used' => false,
							'is_expired' => 0,
							'date' => strtotime("now")
						);
						
						$format = array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d', '%d');
						
						$insert_id = zm_insert_query('zm_protects', $meta, $format);
					}
				}
			}
			$step = zm_isset($_GET['step'], 0 , true);
			
			if ($step)
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=protect&step=3&id='.$id));
			else
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=products&process=edit&updated=true&id='.$id));
		break;
		
		case 'member':
			// Update a Member
			if($type == 'password'){
				$meta = array(
					'pass' => wp_hash_password($data[1]),
				);
				
				$format = array('%s');
				
				$wpdb->update( "{$wpdb->prefix}zm_members", $meta, array( 'ID' => $data[0]), $format, array( '%d' ) );
			}else{
				$meta = array(
					'email' => $data['zm_email'],
					'first_name' => $data['zm_fname'],
					'last_name' => $data['zm_lname'],
					'metadata' => maybe_serialize(array('notes' => $data['zm_notes']))
				);
				
				$format = array('%s', '%s', '%s', '%s');
				
				// Change Password
				if ($data['zm_password'] != ''){
					//$meta['pass'] = wp_hash_password($data['zm_password']);
					$meta['pass'] = $data['zm_password'];
					$format[] = '%s';
					
					//Update temp password
					$temp_passwords = get_option('zm_temp_pass');
					if (!$temp_passwords) $temp_passwords = array();
					
					$temp_passwords[$data['zm-nonce']] = $data['zm_password'];
					update_option('zm_temp_pass', $temp_passwords);
				}
				
				$wpdb->update( "{$wpdb->prefix}zm_members", $meta, array( 'ID' => $data['zm-nonce'] ), $format, array( '%d' ) );
				
				// clean caches
				wp_cache_delete($data['zm-nonce'], 'zm_members');
				wp_cache_delete($data['zm_cache_username'], 'zm_memberlogins');
				wp_cache_delete($data['zm_email'], 'zm_memberemail');
				
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=edit&updated=true&id='.$data['zm-nonce']));
			}
		break;
		
		case 'coupon':
			// Update a coupon
			$id = $data['zm-nonce'];
			
			$meta = array(
				'usage_limit' => $data['zm-coupon-usage'],
				'discount' => $data['zm-coupon-discount'],
				'mode' => $data['zm-coupon-discount-mode'],
				'valid_from' => strtotime($data['zm-coupon-valid-from']),
				'valid_until' => strtotime($data['zm-coupon-valid-until']),
				'valid_type' => $data['zm-coupon-valid-type'],
				'recurring' => $data['zm-coupon-recurring'] == 'off' ? false : true
			);
			
			$format = array('%d', '%f', '%d', '%d', '%d', '%d', '%d');
			
			$wpdb->update( "{$wpdb->prefix}zm_coupons", $meta, array( 'ID' => $id ), $format, array( '%d' ) );
			
			wp_redirect(admin_url('admin.php?page=zm-admin&mode=coupons&process=edit&updated=true&id='.$id));
		break;
		
		case 'payment':
			// Update a payment
			$id = explode('#', $data['zm-edit-id']);
			
			$meta = array(
				'type' => $id[0],
				'paysys' => $data['zm-payment'],
				'receipt' => $data['zm-receipt'],
				'amount' => $data['zm-amount'],
				'status' => $data['zm-status-product'],
				'currency' => $data['zm-currency'],
				'is_rebill' => zm_isset($data['zm-rebill']) ? 1 : 0,
			);
			
			$format = array('%s', '%s', '%s', '%f', '%d', '%s', '%d');
			
			if ($id[0] == 'subscription'){
				$meta['begin_date'] = strtotime($data['zm-begin']);
				$meta['expired_date'] = strtotime($data['zm-expired']);
				$format[] = '%s';
				$format[] = '%s';
			}
			
			$wpdb->update( "{$wpdb->prefix}zm_payments", $meta, array( 'ID' => $id[1] ), $format, array( '%d' ) );
			
			wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&process=edit&payment=updated&id='.$data['zm-member-id']));
		break;
		
		default:
		break;
	}
}

function zm_delete($db, $id, $attr=''){
	global $wpdb;
	
	switch ($db) {
		case 'product':
			
			zm_delete('sku', $id);
			zm_delete('protect', $id, 'link');
			zm_delete('coupon', $id, 'link');
			//...
			//zm_delete('payment', $id, 'link');
			
			if(is_array($id)){
				// Delete some products
				$id = implode(', ', $id);
				$wpdb->query("DELETE FROM {$wpdb->prefix}zm_products WHERE ID IN ($id)");
				
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=products&deleted=true'));
			}else{
				// Delete a Product
				$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_products WHERE ID = %d", $id));
				return true;
			}
			
		break;
		
		case 'coupon':
			if(is_array($id)){
				// Delete some coupons
				if ($attr == 'link'){
					$id = implode(', ', $id);
					$wpdb->query("DELETE FROM {$wpdb->prefix}zm_coupons WHERE product_id IN ($id)");
				}else{
					$id = implode(', ', $id);
					$wpdb->query("DELETE FROM {$wpdb->prefix}zm_coupons WHERE ID IN ($id)");
					wp_redirect(admin_url('admin.php?page=zm-admin&mode=coupons&deleted=true'));
				}
			}else{
				if ($attr == 'link'){
					// Delete a coupon
					$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_coupons WHERE product_id = %d", $id));
					return true;
				}else{
					// Delete a coupon
					$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_coupons WHERE ID = %d", $id));
					return true;
				}
			}
		break;
		
		case 'member':
			if(is_array($id)){
				// Delete some members
				$id = implode(', ', $id);
				$wpdb->query("DELETE FROM {$wpdb->prefix}zm_members WHERE ID IN ($id)");
				wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&deleted=true'));
			}else{
				// Delete a member
				$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_members WHERE ID = %d", $id));
				return true;
			}
		break;
		
		case 'protect':
			if (is_array($attr)){
				$conditions = '';
				if (!$attr['s3']){
					$conditions = " AND filename NOT LIKE 's3%'";
				}else{
					$i=0;
					foreach ($_POST['load-buckets'] as $bucket){
						if (!$i){
							$conditions = " AND (filename LIKE 's3_{$bucket}_%'";
						}else{
							$conditions .= " OR filename LIKE 's3_{$bucket}_%'";
						}
						$i++;
					}
					
					$conditions .= ' OR post_id != -1)';
				}
				
				if (!$attr['file']){
					$conditions .= " AND filename NOT LIKE 'local%'";
				}
				
				$query = "DELETE FROM {$wpdb->prefix}zm_protects WHERE product_id=".$id."".$conditions;
				
				$wpdb->query($query);
			}else if ($attr == 'link'){
				if(is_array($id)){
					// Delete some protect
					$id = implode(', ', $id);
					$wpdb->query("DELETE FROM {$wpdb->prefix}zm_protects WHERE product_id IN ($id)");
				}else{
					// Delete a protect
					$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_protects WHERE product_id = %d", $id));
				}
			}else if ($attr == 'meta'){
				// Delete a protect
				$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_protects WHERE post_id = %d", $id));
			}
		break;
		
		case 'sku':
			if(is_array($id)){
				// Delete some sku
				$id = implode(', ', $id);
				$wpdb->query("DELETE FROM {$wpdb->prefix}zm_sku WHERE product_id IN ($id)");
			}else{
				// Delete a sku
				$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_sku WHERE product_id = %d", $id));
			}
		break;
		
		case 'payment':
			if ($attr == 'link'){
				if(is_array($id)){
					// Delete some payments
					$id = implode(', ', $id);
					$wpdb->query( "DELETE FROM {$wpdb->prefix}zm_payments WHERE product_id IN ($id)");
				}else{
					// Delete a payment
					$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_payments WHERE product_id = %d", $id));
				}
			}else{
				if(is_array($id)){
					// Delete some payments
					$id = implode(', ', $id);
					$wpdb->query("DELETE FROM {$wpdb->prefix}zm_payments WHERE ID IN ($id)");
				}else{
					// Delete a payment
					$wpdb->query( $wpdb->prepare( "DELETE FROM {$wpdb->prefix}zm_payments WHERE ID = %d", $id));
				}
			}
		break;
		
		default:
		break;
	}
}

function zm_clone($db, $id){
	global $wpdb;
	
	switch ($db) {
		case 'product':
		// Get a Product
		$source = zm_get_row('product', $id, ARRAY_A);
		$format = array('%s', '%d', '%s', '%s', '%d', '%f', '%f', '%f', '%d', '%d', '%s', '%s', '%d', '%s', '%s', '%s', '%d', '%d');
		
		//modified some values
		unset($source['ID']);
		$source['title'] = 'Copy of '.$source['title'];
		$source['date'] = strtotime("now");
		
		$wpdb->insert( "{$wpdb->prefix}zm_products", $source, $format );
		
		if ($insert_id = $wpdb->insert_id){
			$protected = zm_get_all('protect', $id);
			
			if($protected){
				foreach ($protected as $row) {
					$new_protected = array(
							'product_id' => $insert_id,
							'post_id' => $row->post_id,
							'filename' => $row->filename,
							'd_start' => $row->d_start,
							'd_end' => $row->d_end,
							'd_start_mode' => $row->d_start_mode,
							'd_end_mode' => $row->d_end_mode,
							'd_end_used' => $row->d_end_used,
							'is_expired' => $row->is_expired,
							'date' => strtotime("now")
						);
					$format = array('%d', '%d', '%s', '%d', '%d', '%s', '%s', '%d', '%d', '%d');
					zm_insert_query('zm_protects', $new_protected, $format);
				}
			}
			
			return $insert_id;
		}else
			return false;
			
		break;
		
		case 'member':
		// Add a Member
		break;
		
		default:
		break;
	}
}

add_action('admin_init', 'zm_admin_action', 9);
function zm_admin_action() {
	//if (isset($_POST)){
	//	var_dump($_POST);
	//	die();
	//}
	if ( isset($_POST['zm_submit_form']) ) {
		$action = $_POST['zm_submit_form'];
		switch ( $action ) {
			case 'save_import':
				zm_import_csv_to_database();
				break;
				
			case 'save_config':
				zm_save_configuration();
				break;
				
			case 'save_product':
				if ( zm_isset($_POST['zm-nonce']) == md5('add_product') ) zm_add('product', $_POST);
				else if ( zm_isset($_POST['zm-nonce']) > 0 ) zm_update('product', $_POST);
				break;
				
			case 'save_member':
				if (zm_isset($_POST['zm-nonce']) == md5('add_member')) zm_add('member', $_POST);
				else if (zm_isset($_POST['zm-nonce']) > 0) zm_update('member', $_POST);
				break;
				
			case 'save_coupon':
				if ( zm_isset($_POST['zm-nonce']) == md5('add_coupon') ) zm_add('coupon', $_POST);
				else if ( zm_isset($_POST['zm-nonce']) > 0 ) zm_update('coupon', $_POST);
				break;
				
			case 'save_payment':
				if (zm_isset($_POST['zm-edit-id']) == '-1') zm_add('payment', $_POST);
				else zm_update('payment', $_POST);
				break;
				
			case 'save_access':
				zm_add('protect', $_POST);
				break;
				
			case 'generate_pages':
				zm_generate_pages();
				break;
		}
	}
}

function zm_generate_pages( $post ) {
	$results = array();
	//$vars = array();
	foreach ( $post['zm_page_title'] as $key => $val ) {
		$parent_post = array(
			'post_title'    => trim($val),
		  	'post_content'  => '',
		  	'post_status'   => $post['zm_page_status'][$key],
		  	'post_type' 	=> 'page'
		);

		//$vars[] = $parent_post;
		$parent = true;
		$post_id = wp_insert_post($parent_post, true);
		if ( is_wp_error($post_id) ) {
			$results[] = array(
					'id' => 0,
					'title' => trim($val),
					'status' => 'error',
					'error_code' => $post_id->get_error_code(),
					'error_msg' => $post_id->get_error_message(),
					'child' => 0
				);
			$parent = false;
		} else {
			$results[] = array(
					'id' => $post_id,
					'title' => trim($val),
					'status' => 'success',
					'child' => 0
				);
		}
		
		if ( isset($post['zm_child_title'][$key]) ) {
			foreach ( $post['zm_child_title'][$key] as $k => $v ) {
				if ( $parent ) {
					$child_post = array(
						'post_title'    => trim($v),
					  	'post_content'  => '',
					  	'post_status'   => $post['zm_child_status'][$key][$k],
					  	'post_type' 	=> 'page',
					  	'post_parent' 	=> $post_id
					);
					
					$vars[] = $child_post;
					$child_id = wp_insert_post($child_post, true);
					if ( is_wp_error($child_id) ) {
						$results[] = array(
								'id' => 0,
								'title' => trim($v),
								'status' => 'error',
								'error_code' => $post_id->get_error_code(),
								'error_msg' => $post_id->get_error_message(),
								'child' => 1
							);
					} else {
						$results[] = array(
								'id' => $child_id,
								'title' => trim($v),
								'status' => 'success',
								'child' => 1
							);
					}
				} else {
					$results[] = array(
						'id' => 0,
						'title' => trim($v),
						'status' => 'error',
						'error_code' => 'no_parent',
						'error_msg' => 'Parent page cannot be created.',
						'child' => 1
					);
				}
					
			}
		}
	}
	
	$res_id = zm_time();
	set_transient('zm_creator_' . $res_id, $results, 3600);
	$redirect_url = admin_url('admin.php?page=zm-admin&mode=config');
	$redirect_url .= '&tab=creator&res_id=' . $res_id;
	wp_redirect($redirect_url);
	exit;
}

add_action('admin_init', 'zm_admin_del_action');
function zm_admin_del_action() {
	if (isset($_POST['zm_action']) || isset($_POST['zm_action_1'])){
		if (zm_isset($_POST['zm_action']) == 'del' || zm_isset($_POST['zm_action_1']) == 'del'){
			if (zm_isset($_POST['zm_coupon'])) zm_delete('coupon', $_POST['zm_coupon']);
			else if (zm_isset($_POST['zm_member'])) zm_delete('member', $_POST['zm_member']);
			else if (zm_isset($_POST['zm_product'])) zm_delete('product', $_POST['zm_product']);
			else if (zm_isset($_POST['zm_payments'])) zm_delete('payment', $_POST['zm_payments']);
		}
	}
}

add_filter('upload_mimes', 'zm_allow_mimes');
function zm_allow_mimes( $mimes ) {
	$mimes['json'] = 'application/json';
	return $mimes;
}

add_action('zm_message', 'zm_import_messages');
function zm_import_messages() {
	if ( zm_isset($_GET['import']) == 'error' ) {
		if ( !empty($_GET['msg']) ) {
			echo '<div class="alert-box alert" style="margin:10px 0"><p><strong>Import Failed!</strong> ' . base64_decode($_GET['msg']) . '</p></div>';
		}
	}

	if ( zm_isset($_GET['import']) == 'success' ) {
		if ( !empty($_GET['msg']) ) {
			echo '<div class="alert-box success" style="margin:10px 0"><p><strong>' . base64_decode($_GET['msg']) . '</strong></p></div>';
		}
	}
}

add_action('admin_init', 'zm_export_all_data');
function zm_export_all_data() {
	if ( isset($_GET['action']) && $_GET['action'] == 'zm_export_data' ) {
		$nonce = $_REQUEST['_zmnonce'];
		if ( !wp_verify_nonce( $nonce, '_zmnonce' ) ) {
			wp_redirect(admin_url('admin.php?page=zm-admin&mode=config'));
			exit;
		}
		global $wpdb;
		$export = array();
		// export configs...
		$export['general_opts'] = get_option('zm_general_option');
		$export['payment_opts'] = get_option('zm_payment_option');
		$export['email_opts'] = get_option('zm_email_setup');
		$export['ar_opts'] = get_option('zm_autoresponder_option');
		
		// export members...
		$export['members'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_members` ORDER BY `ID` ASC", ARRAY_A);
		$export['products'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_products` ORDER BY `ID` ASC", ARRAY_A);
		$export['sku'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_sku` ORDER BY `ID` ASC", ARRAY_A);
		$export['payments'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_payments` ORDER BY `ID` ASC", ARRAY_A);
		$export['coupons'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_coupons` ORDER BY `ID` ASC", ARRAY_A);
		//$export['access_log'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_access_log` ORDER BY `log_id` ASC", ARRAY_A);
		//$export['error_log'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_error_log` ORDER BY `log_id` ASC", ARRAY_A);
		//$export['ipn_log'] = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}zm_ipn_log` ORDER BY `log_id` ASC", ARRAY_A);
		
		@header('Content-disposition: attachment; filename=zm-' . date("Ymd") . '-' . date("His") . '.json');
		@header('Content-type: application/json');
		
		echo '{"zm":' . json_encode($export) . '}';
		exit;
	}else if ( isset($_GET['action']) && $_GET['action'] == 'zm_export_m_data' ) {
		$nonce = $_REQUEST['_zmnonce'];
		if ( !wp_verify_nonce( $nonce, '_zmnonce' ) ) {
			wp_redirect(admin_url('admin.php?page=zm-admin&mode=config'));
			exit;
		}
		
		//EXPORT MEMBERS
		$members = zm_get_all('member');
		$products = zm_get_all('product');
		
		$file = 'username,email,firstname,lastname';
		$empty = '-,-,-,-';
		foreach ($products as $product){
			$file .= ',product/level';
			$empty .= ',-'; 
		}
		$file .= "\n";
		
		if ($members){
			foreach ($members as $row) {
				$first_name = $row->first_name != '' ? $row->first_name : '-';
				$last_name = $row->last_name != '' ? $row->last_name : '-';
				$file .= $row->username.','.$row->email.','.$first_name.','.$last_name;
				foreach ($products as $product){
					$file .= ',';
					if (zm_is_subscribed($row->ID, $product->ID)){
						$file .= $product->title;
					}else{
						$file .= '-';
					}
				}
				$file .= "\n";
			}
		}else{
			$file .= $empty;
		}
		
		
		$upload_dir = wp_upload_dir();
		if ( !is_writable($upload_dir['path']) ) {
			wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The "' . $upload_dir['path'] . '" is not writable. Please chmod it to "0777" and then you can revert it back to "0755" after the data has been imported.') . '&import=error');
			exit;
		}
		
		$fp = fopen($upload_dir['path'].'/zm-members.csv', 'w');
		fwrite($fp, $file);
		fclose($fp);
		
		//EXPORT SALES REPORT
		$reports = zm_get_all('report');
		$file = 'Date,Product,Price,Payment Type,Payment Status,Member'."\n";
		if ($reports){
			foreach ($reports as $report){
				$file .= date('M d Y H:i A', $report->txn_date);
				$file .= ','.($report->title ? $report->title : '-deleted-');
				$file .= ','.number_format($report->amount, 2, '.', '');
				$file .= ','.zm_payment_type_is($report->type);
				$file .= ','.zm_status($report->status, true);
				$file .= ','.($report->username ? $report->username.' ('.$report->email.')' : '-deleted-')."\n";
			}
		}else{
			$file .= '-,-,-,-,-,-';
		}
		$fp = fopen($upload_dir['path'].'/zm-sales-report.csv', 'w');
		fwrite($fp, $file);
		fclose($fp);
		
		//EXPORT PERFORMANCE REPORT
		$params = array('zm_txn_time' => 'all');
		$params['zm_from'] = '';
		$params['zm_to'] =  '';
		
		$reports = zm_get_all('report', $params, 'performance');
		$file = 'Product/Level,Total Members,Members Refunded,Members Canceled,Refund %,Cancel %,Value Per Member,Avg. Retention Rate'."\n";
		if ($reports){
			foreach($reports as $row){
				$file .= $row->title;
				$file .= ','.$row->total_member;
				$file .= ','.$row->refunded;
				$file .= ','.$row->cancelled;
				$file .= ','.($row->refunded > 0 ? number_format(($row->refunded/$row->total_member)*100, 2, '.', '') : 0);
				$file .= ','.($row->cancelled > 0 ? number_format(($row->cancelled/$row->total_member)*100, 2, '.', '') : 0);
				$file .= ','.($row->revenue > 0 ? number_format(($row->revenue/$row->total_member), 2, '.', '') : 0);
				
				if ($row->total_member > 0)
					$file .= ','.($row->type == 'subscription' ? zm_count_retention($row->not_cancelled, $row->total_member, $row->subs_num, $row->subs_mode) : '-');
				else
					$file .= ',';
				
				$file .= "\n";
			}
		}else{
			$file .= '-,-,-,-,-,-,-,-';
		}

		$fp = fopen($upload_dir['path'].'/zm-performance-report.csv', 'w');
		fwrite($fp, $file);
		fclose($fp);
		
		//EXPORT ENGAGEMENT REPORT
		$reports = zm_get_all('report', $params, 'engagement');
		$file = 'Member,Protected Page/Post Accessed,IP Address'."\n";
		if ($reports){
			foreach($reports as $row){
				$file .= $row->username;
				$file .= ','.$row->total_page;
				$file .= ','.$row->total_ip;
				$file .= "\n";
			}
		}else{
			$file .= '-,-,-';
		}
		$fp = fopen($upload_dir['path'].'/zm-engagement-report.csv', 'w');
		fwrite($fp, $file);
		fclose($fp);
		
		//CLEAR VARs
		unset($reports);
		unset($fp);
		unset($file);
		unset($members);
		unset($products);
		
		//SETUP ZIP FILE
		$files_to_zip = array(
			'report/zm-sales-report.csv' => $upload_dir['path'].'/zm-sales-report.csv',
			'report/zm-performance-report.csv' => $upload_dir['path'].'/zm-performance-report.csv',
			'report/zm-engagement-report.csv' => $upload_dir['path'].'/zm-engagement-report.csv',
			'zm-members.csv' => $upload_dir['path'].'/zm-members.csv'
		);
		
		//if true, good; if false, zip creation failed
		$zip_file = '/zm-data-' . date("Ymd") . '-' . date("His") . '.zip';
		
		if(zm_create_zip($files_to_zip, $upload_dir['path'].$zip_file, true)){
			wp_redirect($upload_dir['url'].$zip_file);
		}else{
			wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('Cant export ZM data.') . '&import=error');
		}
		exit;
	}
}

function zm_import_all_data() {
	if ( !function_exists('wp_handle_upload') )
		require_once( ABSPATH . 'wp-admin/includes/file.php' );
	
	if ( !empty($_FILES['zm-import-file']['name']) ) {
		global $wpdb;
		
		$upload_dir = wp_upload_dir();
		if ( !is_writable($upload_dir['path']) ) {
			wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The "' . $upload_dir['path'] . '" is not writable. Please chmod it to "0777" and then you can revert it back to "0755" after the data has been imported.') . '&import=error');
			exit;
		}
		
		$uploaded_file = $_FILES['zm-import-file'];
		$upload_overrides = array('test_form' => false);
		$movefile = wp_handle_upload($uploaded_file, $upload_overrides);
		if ( $movefile ) {
		    if ( !empty($movefile['error']) ) {
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode($movefile['error']) . '&import=error');
				exit;
		    }
			$file_path = $movefile['file'];
			$file_url = $movefile['url'];
			if ( $movefile['type'] != 'application/json' ) {
				@unlink($file_path);
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('Please upload the correct ZM data file.') . '&import=error');
				exit;
		    }
			
			$response = wp_remote_get($file_url, array( 'timeout' => 120, 'httpversion' => '1.1' ));
			if ( empty($response['body']) ) {
				@unlink($file_path);
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The uploaded file has no content.') . '&import=error');
				exit;
			}
			
			$data = json_decode($response['body'], true);
			if ( !isset($data['zm']) ) {
				@unlink($file_path);
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The uploaded file is not a valid ZM data file.') . '&import=error');
				exit;
			}

			$zm = $data['zm'];
			if ( !empty($zm['general_opts']) ) {
				$general = $zm['general_opts'];
				update_option('zm_general_option', $general);
			}
			
			if ( !empty($zm['payment_opts']) ) {
				$payments = $zm['payment_opts'];
				update_option('zm_payment_option', $payments);
			}
			
			if ( !empty($zm['email_opts']) ) {
				$email = $zm['email_opts'];
				update_option('zm_email_setup', $email);
			}
			
			if ( !empty($zm['ar_opts']) ) {
				$ar = $zm['ar_opts'];
				update_option('zm_autoresponder_option', $ar);
			}

			// importing members...
			if ( !empty($zm['members']) ) {
				foreach ( $zm['members'] as $m ) {
					if ( !zm_username_exists($m['username']) && !zm_email_exists($m['email']) ) {
						$wpdb->insert(
							"{$wpdb->prefix}zm_members",
							array(
								'username' => esc_sql(stripslashes($m['username'])),
			                    'email' => esc_sql(stripslashes($m['email'])),
			                    'pass' => $m['pass'],
			                    'first_name' => esc_sql(stripslashes($m['first_name'])),
			                    'last_name' => esc_sql(stripslashes($m['last_name'])),
			                    'status' => esc_sql(stripslashes($m['status'])),
			                    'paypal_id' => esc_sql(stripslashes($m['paypal_id'])),
			                    'metadata' => $m['metadata'],
			                    'date' => esc_sql(stripslashes($m['date']))
							)	
						);
					}
				}
			}

			// importing products...
			if ( !empty($zm['products']) ) {
				foreach ( $zm['products'] as $pr ) {
					$wpdb->insert(
						"{$wpdb->prefix}zm_products",
						array(
		                    'title' => esc_sql(stripslashes($pr['title'])),
		                    'download_id' => esc_sql(stripslashes($pr['download_id'])),
		                    'thanks_url' => esc_sql(stripslashes($pr['thanks_url'])),
		                    'type' => esc_sql(stripslashes($pr['type'])),
		                    'is_trial' => esc_sql(stripslashes($pr['is_trial'])),
		                    'trial_price' => esc_sql(stripslashes($pr['trial_price'])),
 							'ot_price' => esc_sql(stripslashes($pr['ot_price'])),
		                    'rc_price' => esc_sql(stripslashes($pr['rc_price'])),
		                    'subs_num' => esc_sql(stripslashes($pr['subs_num'])),
		                    'trial_num' => esc_sql(stripslashes($pr['trial_num'])),
		                    'subs_mode' => esc_sql(stripslashes($pr['subs_mode'])),
		                    'trial_mode' => esc_sql(stripslashes($pr['trial_mode'])),
		                    'rebill_times' => esc_sql(stripslashes($pr['rebill_times'])),
		                    'metadata' => $pr['metadata'],
		                    'status' => esc_sql(stripslashes($pr['status'])),
		                    'autoresponder' => esc_sql(stripslashes($pr['autoresponder'])),
		                    'gotowebinar' => esc_sql(stripslashes($pr['gotowebinar'])),
		                    'date' => esc_sql(stripslashes($pr['date']))
						)	
					);
				}
			}

			// importing SKUs...
			if ( !empty($zm['sku']) ) {
				foreach ( $zm['sku'] as $sku ) {
					$wpdb->insert(
						"{$wpdb->prefix}zm_sku",
						array(
		                    'payment' => esc_sql(stripslashes($sku['payment'])),
		                    'product_id' => esc_sql(stripslashes($sku['product_id'])),
		                    'sku' => esc_sql(stripslashes($sku['sku'])),
		                    'vendor' => esc_sql(stripslashes($sku['vendor']))
						)	
					);
				}
			}
			
			// importing payments...
			if ( !empty($zm['payments']) ) {
				foreach ( $zm['payments'] as $p ) {
					$wpdb->insert(
						"{$wpdb->prefix}zm_payments",
						array(
		                    'product_id' => esc_sql(stripslashes($p['product_id'])),
							'member_id' => esc_sql(stripslashes($p['member_id'])),
							'type' => esc_sql(stripslashes($p['type'])),
							'paysys' => esc_sql(stripslashes($p['paysys'])),
							'receipt' => esc_sql(stripslashes($p['receipt'])),
							'amount' => esc_sql(stripslashes($p['amount'])),
							'is_rebill' => esc_sql(stripslashes($p['is_rebill'])),
							'status' => esc_sql(stripslashes($p['status'])),
							'currency'=> esc_sql(stripslashes($p['currency'])),
							'txn_id' => esc_sql(stripslashes($p['txn_id'])),
							'other_id' => esc_sql(stripslashes($p['other_id'])),
							'ipaddr' => esc_sql(stripslashes($p['ipaddr'])),
							'begin_date' => esc_sql(stripslashes($p['begin_date'])),
							'expired_date' => esc_sql(stripslashes($p['expired_date'])),
							'txn_date' => esc_sql(stripslashes($p['txn_date'])),
						)	
					);
				}
			}

			// importing coupons...
			if ( !empty($zm['coupons']) ) {
				foreach ( $zm['coupons'] as $c ) {
					$wpdb->insert(
						"{$wpdb->prefix}zm_coupons",
						array(
							'product_id' => esc_sql(stripslashes($c['product_id'])),
							'code' => esc_sql(stripslashes($c['code'])),
							'usage_limit' => esc_sql(stripslashes($c['usage_limit'])),
							'used' => esc_sql(stripslashes($c['used'])),
							'valid_type' => esc_sql(stripslashes($c['valid_type'])),
							'valid_from' => esc_sql(stripslashes($c['valid_from'])),
							'valid_until' => esc_sql(stripslashes($c['valid_until'])),
							'discount' => esc_sql(stripslashes($c['discount'])),
							'mode' => esc_sql(stripslashes($c['mode'])),
							'recurring' => esc_sql(stripslashes($c['recurring'])),
						)	
					);
				}
			}
			unset($data, $zm);
			wp_redirect('admin.php?page=zm-admin&mode=config&import=success&msg=' . base64_encode('ZM data has been successfully imported.'));
		} else {
		    wp_redirect('admin.php?page=zm-admin&mode=config&import=error&msg=' . base64_encode('File cannot be uploaded.'));
		}
	} else {
		wp_redirect('admin.php?page=zm-admin&mode=config&import=error&msg=' . base64_encode('File is empty.'));
	}
}

function zm_import_csv_data(){
	if ( !function_exists('wp_handle_upload') )
		require_once( ABSPATH . 'wp-admin/includes/file.php' );
	
	if ( !empty($_FILES['zm-import-m-file']['name']) ) {
		global $wpdb;
		
		$upload_dir = wp_upload_dir();
		if ( !is_writable($upload_dir['path']) ) {
			wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The "' . $upload_dir['path'] . '" is not writable. Please chmod it to "0777" and then you can revert it back to "0755" after the data has been imported.') . '&import=error');
			exit;
		}
		
		$uploaded_file = $_FILES['zm-import-m-file'];
		$upload_overrides = array('test_form' => false);
		$movefile = wp_handle_upload($uploaded_file, $upload_overrides);
		if ( $movefile ) {
		    if ( !empty($movefile['error']) ) {
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode($movefile['error']) . '&import=error');
				exit;
		    }

			$file_path = $movefile['file'];
			$file_url = $movefile['url'];
			if ( $movefile['type'] != 'text/csv' ) {
				@unlink($file_path);
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('Please upload the correct CSV data file.') . '&import=error');
				exit;
		    }
			
			$response = wp_remote_get($file_url, array( 'timeout' => 120, 'httpversion' => '1.1' ));
			if ( empty($response['body']) ) {
				@unlink($file_path);
		    	wp_redirect('admin.php?page=zm-admin&mode=config&msg=' . base64_encode('The uploaded file has no content.') . '&import=error');
			}else{
				wp_redirect('admin.php?page=zm-admin&mode=import&csv='.zm_encode($file_url, 'csv'));
			}
		} else {
		    wp_redirect('admin.php?page=zm-admin&mode=config&import=error&msg=' . base64_encode('File cannot be uploaded.'));
		}
	} else {
		wp_redirect('admin.php?page=zm-admin&mode=config&import=error&msg=' . base64_encode('File is empty.'));
	}
	exit;
}

function zm_save_configuration() {
	if ( $_POST['zm_creator_state'] == 1 )
		zm_generate_pages($_POST['zm_creator']);
	else
		unset($_POST['zm_creator']);
	
	if ( isset($_POST['zm-import-submit']) ) {
		zm_import_all_data();
		exit;
	}
	
	if (isset($_POST['zm-import-m-submit'])){
		zm_import_csv_data();
	}
	
	$general = array(
		'is_powered' => $_POST['zm-is-powered'],
		'is_hideunavailable' => $_POST['zm-is-hideunavailable'],
		'aff_link'	=> $_POST['zm-aff-link'],
		'az_enable' => $_POST['zm-az-enable'],
		'az_api' => $_POST['zm-az-api'],
		'az_key'	=> $_POST['zm-az-key'],
		'rc_enable' => $_POST['zm-rc-enable'],
		'rc_public_key' => $_POST['zm-rc-public-key'],
		'rc_private_key' => $_POST['zm-rc-private-key'],
		'lock_enable' => $_POST['zm-autolock'],
		'lock_ip' => $_POST['zm-lock-ip'],
		'lock_minute' => $_POST['zm-lock-minute'],
		'expired_page' => $_POST['zm-expired-page'],
		'unavailable_page' => $_POST['zm-unavailable-page'],
		'login_page' => $_POST['zm-login-page'],
		'after_login_page' => $_POST['zm-after-login-page'],
		'access_error_page' => $_POST['zm-access-error-page'],
		'profile_page' => $_POST['zm-profile-page'],
		'logout_page' => $_POST['zm-logout-page']
	);
	
	update_option('zm_general_option', $general);
	unset($general);
	
	// Save Payments Settings
	$payment = $_POST['zm_payments'];
	update_option('zm_payment_option', $payment);
	
	$email = array(
		'from_name' => $_POST['zm-from-name'],
		'from_email' => $_POST['zm-from-email'],
		'mailer' => $_POST['zm-mailer'],
		'smtp_host'	=> $_POST['zm-smtp-host'],
		'smtp_port'	=> $_POST['zm-smtp-port'],
		'encryption' => $_POST['zm-smtp-enc'],
		'is_auth' => $_POST['zm-is-auth'],
		'smtp_username' => $_POST['zm-smtp-username'],
		'smtp_password' => $_POST['zm-smtp-password'],
		'welcome_email' => array('send_admin' => $_POST['zm-wemail-admin'], 'subject' => strip_tags($_POST['zm-wemail-subject']), 'body' => strip_tags($_POST['zm-wemail-body'])),
		'forgot_email' => array('subject' => strip_tags($_POST['zm-femail-subject']), 'body' => strip_tags($_POST['zm-femail-body']))
	);
	
	update_option('zm_email_setup', $email);
	unset($email);
	
	$autoresponder = array(
		'aw_key' => trim($_POST['zm-aw-key']),
		'aw_secret'	=> trim($_POST['zm-aw-secret']),
		'gr_key' => trim($_POST['zm-gr-key']),
		'ic_key' => trim($_POST['zm-ic-key']),
		'ic_pass' => trim($_POST['zm-ic-pass']),
		'ic_user' => trim($_POST['zm-ic-user']),
		'mc_key' => trim($_POST['zm-mc-key'])
	);
	
	update_option('zm_autoresponder_option', $autoresponder);
	unset($autoresponder);
	
	wp_redirect(admin_url('admin.php?page=zm-admin&mode=config&updated=true'));
	exit;
}

add_action('wp_ajax_zm_checkusername', 'zm_check_username');
function zm_check_username() {
	$username = $_REQUEST['zm_username'];
	$rand = zm_generate_username($username . '@' . $_SERVER['HTTP_HOST'], $username);
	if ( zm_username_exists($username) )
		$json = '"' . $username . '" is already taken, try "' . $rand . '" instead';
	else
		$json = 'true';
	
	$response = $_REQUEST['callback'] . "(" . json_encode($json) . ")";
	die($response);
}

add_action('wp_ajax_zm_checkemail', 'zm_check_email');
function zm_check_email() {
	$email = $_REQUEST['zm_email'];
	$old_email = $_REQUEST['old_email'];
	$check_existing = ( $_REQUEST['id'] != md5('add_member') && is_numeric($_REQUEST['id']) ) ? TRUE : FALSE;
	$unchanged = ( $check_existing && $email == $old_email );
	if ( $check_existing && $email == $old_email ) {
		$json = 'true';
	} else {
		if ( zm_email_exists($email) )
			$json = '"' . $email . '" is already registered, please enter a different email address';
		else
			$json = 'true';
	}

	$response = $_REQUEST['callback'] . "(" . json_encode($json) . ")";
	die($response);
}

function zm_access_folder_row($file){
	echo '<tr align="top" class="zm-row">';
	echo '<th scope="row" class="zm-check-column"></th>';
	echo '<td style="width:32px"><i class="icon-level-down"></i></td>';
	echo '<td>'.$file.'</td>';
	echo '<td></td>';
	echo '<td></td>';
	echo '<td></td>';
	echo '</tr>';
}

function zm_access_file_row($type, $file, $data){
	$row = array(
		'enable' => false,
		'start' => array('mode' => 'D',
						'value' => 0),
		'end' => array('mode' => 'D',
					   'value' => 30,
					   'used' => 0));
	
	$f_id = $type.''.md5($file);
	
	if (isset($data[$f_id])){
		$row = $data[$f_id];
	}
						
	$smode = zm_drip_options('start', $f_id, $row['start']['mode'], $row['enable']);
					
	$is_e_used = ($row['end']['used']) ? 'checked' : '';
	$is_expired = '';
	if ($is_e_used){
		if ($row['expired'] == 1){
			$is_expired = '<em class="zm_exp">(expired)</em>';
		}
	}

	$emode = zm_drip_options('end', $f_id, $row['end']['mode'], $is_e_used);
					
	$icon = zm_get_icon($file);
					
	echo '<tr align="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
	echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectfile" type="checkbox" name="zm-ac-post[]" value="'.$f_id.'" '.($row['enable'] ? 'checked' : '').'></th>';
	echo '<td style="width:32px"><i class="'.$icon.'"></i></td>';
	echo '<td>'.$file.' '.$is_expired.'</td>';
	echo '<td><span class="button small radius secondary zm-get-download-url" id="'.zm_encode('1|'.$file, 'zm').'">Get download URL</span></td>';
	echo '<td>';
	echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
		<div class="large-12 gpf-columns">
		<i class="icon-user"></i> Public Access
		</div>
		</div>';
	
	echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
	    	<div class="large-7 gpf-columns">';
	
	$is_exact = ($row['start']['mode'] == 'X') ? true : false;
	echo '<input type="text" id="numb'.$f_id.'-s" class="zm-start-value required digits" name="zm-ac-data['.$f_id.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
	echo '<input type="text" id="date'.$f_id.'-s" class="zm-start-dp-value" name="zm-ac-data['.$f_id.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
	echo '</div>';
	
	echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';
	
	echo '<td>';
	$is_exact = ($row['end']['mode'] == 'X') ? true : false;
	echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
	<div class="large-12 gpf-columns" >
	<i class="icon-user"></i> Public Access
	</div>
	</div>';
	
	echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
	    	<div class="large-3 gpf-columns">
	      		<span class="prefix radius">';
	echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$f_id.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
	echo '</span>
			</div>';
	
	echo '<div class="large-4 gpf-columns">';
	echo '<input type="text" id="numb'.$f_id.'-e" class="zm-end-value required digits" name="zm-ac-data['.$f_id.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
	echo '<input type="text" id="date'.$f_id.'-e" class="zm-end-dp-value" name="zm-ac-data['.$f_id.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';
	
	echo '</div>';
	
	echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
	echo '</tr>';
}

function zm_s3_connect(){
	//include the S3 class				
	if (!class_exists(ZM_LIBS . 'S3.php')) require_once(ZM_LIBS . 'S3.php');
	
	//AWS access info
	$general = get_option('zm_general_option');
	
	if (zm_isset($general['az_enable']) == 'on'){
		//instantiate the class
		$s3 = new S3(trim(zm_isset($general['az_api'])), trim(zm_isset($general['az_key'])));
		
		//we'll continue our script from here!
		if ($s3->hasAuth())
			return $s3;
	}
	return false;
}

function zm_s3_get_acp( $bucket, $filename ) {
	//include the S3 class				
	if (!class_exists(ZM_LIBS . 'S3.php')) require_once(ZM_LIBS . 'S3.php');
	
	//AWS access info
	$general = get_option('zm_general_option');
	
	//instantiate the class
	$s3 = new S3(zm_isset($general['az_api']), zm_isset($general['az_key']));
	if ( $acp = $s3->getAccessControlPolicy($bucket, $filename) )
		return $acp;
		
	return false;
}

function zm_s3_set_acp( $bucket, $filename, $type = 'private' ) {
	//include the S3 class				
	if (!class_exists(ZM_LIBS . 'S3.php')) require_once(ZM_LIBS . 'S3.php');
	
	//AWS access info
	$general = get_option('zm_general_option');
	
	//instantiate the class
	$s3 = new S3(zm_isset($general['az_api']), zm_isset($general['az_key']));
	
	if ( !$acp = $s3->getAccessControlPolicy($bucket, $filename) )
		return false;
	
	$new_acp = zm_new_acp($acp, $type);
	
	if ( !$set = $s3->setAccessControlPolicy($bucket, $filename, $new_acp) ) return false;
	return true;
}

function zm_new_acp($acp, $type){
	$new_acp = array();
	$new_acp['owner'] = $acp['owner'];
	$new_acp['acl'] = array();
	
	// Authenticated Users Read
	$new_acp['acl'][] = array(
		'type' => 'Group',
		'uri' => 'http://acs.amazonaws.com/groups/global/AuthenticatedUsers',
		'permission' => 'READ'
	); 
	
	// Authenticated Users Read ACP
	$new_acp['acl'][] = array(
		'type' => 'Group',
		'uri' => 'http://acs.amazonaws.com/groups/global/AuthenticatedUsers',
		'permission' => 'READ_ACP'
	); 
	
	if ( $type == 'public' ) { // then revert back to public...
		$new_acp['acl'][] = array(
			'type' => 'Group',
			'uri' => 'http://acs.amazonaws.com/groups/global/AllUsers',
			'permission' => 'READ'
		);
	}
	
	// Owner Permission
	$new_acp['acl'][] = array(
		'type' => 'CanonicalUser',
		'name' => $acp['owner']['name'],
		'id' => $acp['owner']['id'],
		'permission' => 'FULL_CONTROL'
	);
	
	return $new_acp;
}

function zm_get_pages($intro='', $selected_id=''){
    $post_types = get_post_types();
    
    unset($post_types['post']);
    unset($post_types['page']);
    unset($post_types['attachment']);
    unset($post_types['revision']);
    unset($post_types['nav_menu_item']);
    
	$pages = get_pages( array('post_status' => 'publish') );
	$elm = '';
	
	if ($intro){
		$elm .= '<option value="">'.$intro.'</option>';
	}
	
	if ( $pages ) {
	    $elm .= '<option disabled="">Pages</option>';
		foreach ( $pages as $page ) {
			$selected = ( $selected_id == $page->ID ) ? ' selected="selected"' : '';
			$elm .= "<option value='{$page->ID}'{$selected}>$page->post_title</option>";
		}
	}

    foreach ($post_types as $k => $v){
        $elm .= '<option disabled="">'.ucwords(str_replace(array('-', '_'), ' ', $v)).' (Custom Post Type)</option>';
        
        $posts = get_posts( array('numberposts' => 9999, 'post_status' => 'publish', 'post_type' => $k) );
        
        foreach ( $posts as $page ) {
            $selected = ( $selected_id == $page->ID ) ? ' selected="selected"' : '';
            $elm .= "<option value='{$page->ID}'{$selected}>$page->post_title</option>";
        }
    }
	return $elm;
}

function zm_s3_set_acp_to_public($id){
	$protects = zm_get_all('protect', $id, 'file_s3');

	//die(var_dump($protects));
	if ($protects){
		if ($s3 = zm_s3_connect()){
			foreach ($protects as $protect){
				$file = explode('_', $protect->filename);
				zm_s3_set_acp($file[1], zm_decode($file[2], 'zm_s3'), 'public');
			}
		}
	}
}

function zm_drip_options($type, $id, $value, $used=true){
	$key = $type;
	$type = ($type == 'start') ? '-s' : '-e';
	
	return '<select name="zm-ac-data['.$id.']['.$key.'][mode]" accesskey="'.$id.''.$type.'" class="zm-ca-changemode" '.($used ? '' : 'disabled').'>
				<option value="D" '.($value == 'D' ? 'selected="selected"' : '').'>Days(s)</option>
				<option value="W" '.($value == 'W' ? 'selected="selected"' : '').'>Week(s)</option>
				<option value="M" '.($value == 'M' ? 'selected="selected"' : '').'>Month(s)</option>
				<option value="Y" '.($value == 'Y' ? 'selected="selected"' : '').'>Year(s)</option>
				<option value="X" '.($value == 'X' ? 'selected="selected"' : '').'>Exact Date</option>
			</select>';
}

function zm_gtw_get_login_url(){
	require_once ZM_CITRIX;
	
	$general_option = get_option('zm_general_option');
	$citrix = new Citrix($general_option['gtw_key']);
	
	return $citrix->auth_citrixonline(site_url().'/?app=gotowebinar');
}

function zm_get_webinar(){
	require_once ZM_CITRIX;
	
	$general_option = get_option('zm_general_option');
	$citrix = new Citrix($general_option['gtw_key']);
	
	$citrix->set_organizer_key(get_option('zm_gtw_key'));
	$citrix->set_access_token(get_option('zm_gtw_token'));

	return $citrix->citrixonline_get_list_of_webinars();
}

function zm_time_condition($field_name, $txn_time, $from='', $to=''){
    if(!$field_name || !$txn_time || $txn_time == 'all') return false;
    
    $condition = '';
    
    switch($txn_time){
        case 'today':
            $local_time = date('Y-m-d', strtotime('today'));
            $from       = strtotime($local_time . ' 00:00:00');
            $to         = strtotime($local_time . ' 23:59:59');
            $condition  = $field_name . ' BETWEEN ' . $from . ' AND ' . $to;
            break;

        case 'yesterday':
            $local_time = date('Y-m-d', strtotime('yesterday'));
            $from       = strtotime($local_time . ' 00:00:00');
            $to         = strtotime($local_time . ' 23:59:59');
            $condition  = $field_name . ' BETWEEN ' . $from . ' AND ' . $to;
            break;

        case '7daysago':
            $local_time = date('Y-m-d', strtotime('7 days ago'));
            $time       = strtotime($local_time . ' 00:00:00');
            $condition  = $field_name . ' >= ' . $time;
            break;

        case '30daysago':               
            $local_time = date('Y-m-d', strtotime('30 days ago'));
            $time       = strtotime($local_time . ' 00:00:00');
            $condition  = $field_name . ' >= ' . $time;
            break;
            
        case 'exactdate':
            $from       = $from ? $from : $_GET['f']; 
            $to         = $to ? $to : $_GET['t'];
            
            $from       = $from ? strtotime($from . ' 00:00:00') : '';
            $to         = $to ? strtotime($to . ' 23:59:59') : '';
            
            if( $from && !$to ) $condition = $field_name . ' >= ' . $from;
            if( !$from && $to ) $condition = $field_name . ' <= ' . $to;
            if( $from && $to ) $condition = $field_name . ' BETWEEN ' . $from . ' AND ' . $to;
            break;
        default:
            return false;
    }
    
    return $condition;
}

function zm_is_post_exist($id){
	
	if (get_post($id)){
		return true;
	}else{
		return false;
	}
}

function zm_count_retention($row, $members, $num, $mode){
	$multiple = 0;
	
	$num = abs($num);
	
	if ($mode == 'D'){
		$multiple = $num / 30;
		$total = ($row*$multiple) < 1 ? number_format(($row*$num)/$members, 2, '.', '').' day(s)' : number_format(($row*$multiple)/$members, 2, '.', ''). ' month(s)';
	}else if ($mode == 'W'){
		$multiple = $num / 4;
		$total = ($row*$multiple) < 1 ? number_format(($row*$num)/$members, 2, '.', '').' week(s)' : number_format(($row*$multiple)/$members, 2, '.', ''). ' month(s)';
	}else if ($mode == 'M'){
		$multiple = $num;
		$total = number_format(($row*$multiple)/$members, 2, '.', ''). ' month(s)';
	}else if ($mode == 'Y'){
		$multiple = $num * 12;
		$total = number_format(($row*$multiple)/$members, 2, '.', ''). ' month(s)';
	}
	
	return $total;
}

add_action('admin_init', 'zm_duplicate_link');
function zm_duplicate_link(){
	//avoid duplicate function with PT Instant
	if (!is_plugin_active('pt-instant/pt-instant.php')){
		add_filter('post_row_actions', 'zm_duplicate_link_post', 10, 2);
		add_filter('page_row_actions', 'zm_duplicate_link_page', 10, 2);
	}
}

function zm_duplicate_link_post($actions, $post) {
	if ( current_user_can('publish_posts') ) {
		if ($post->post_type == 'post'){
			$actions['zm_duplicate'] = '<a href="admin.php?action=duplicate&plugin=zm&post=' . $post->ID . '" title="' . __("Duplicate this post", 'zm') . '" rel="permalink">' .  __('Clone This Post', 'zm') . '</a>';
		}
	}
	return $actions;
}

	
function zm_duplicate_link_page($actions, $page) {
	if ( current_user_can('publish_pages') ) {
		if ($page->post_type == 'page'){
			$actions['zm_duplicate'] = '<a href="admin.php?action=duplicate&plugin=zm&post=' . $page->ID . '" title="' . __("Duplicate this page", 'zm') . '" rel="permalink">' .  __('Clone This Page', 'zm') . '</a>';
		}
	}
	return $actions;
}

add_action('wp_ajax_zm_get_welcome_url', 'zm_get_welcome_url');
function zm_get_welcome_url() {
	die(get_permalink($_POST['id']));
}

//DUPLICATE PAGE/POST
add_action('init', 'zm_duplicate_page');
function zm_duplicate_page() {
	if ( zm_isset($_GET['action']) == 'duplicate' && zm_isset($_GET['plugin']) == 'zm' && zm_isset($_GET['post']) > 0 ) {
		$source_id = $_GET['post'];
		
		//DUPLICATE MAIN CONTENT
		$page = get_page($source_id);
		$newdata = array(
		  'comment_status' => $page->comment_status,
		  'ping_status'    => $page->ping_status,
		  'pinged'         => $page->pinged,
		  'post_author'    => $page->post_author,
		  'post_category'  => $page->post_category,
		  'post_content'   => $page->post_content,
		  'post_excerpt'   => $page->post_excerpt,
		  'post_name'      => $page->post_name.'_copy',
		  'post_parent'    => $page->post_parent,
		  'post_password'  => $page->post_password,
		  'post_status'    => 'draft',
		  'post_title'     => $page->post_title.' copy',
		  'post_type'      => 'page',
		  'tags_input'     => $page->tags_input,
		  'to_ping'        => $page->to_ping,
		  'tax_input'      => $page->tax_input
		);  
		$post_id = wp_insert_post( $newdata, false );
		
		if ($post_id === 0) die('Oops. Clone page failed. Please try again.');
		
		$all_meta = get_post_meta($source_id);
		
		//die(var_dump($all_meta));
		
		foreach ($all_meta as $meta_key=>$meta_value){
			add_post_meta( $post_id, $meta_key, maybe_unserialize($meta_value[0]), true);
		}
		
		//Integration with Landing Page of Profits Theme
		if (ZM_CURRENT_THEME == 'Profits Theme'){
			// REGULAR PROFITS THEME LANDING PAGE ELEMENTS
			$tops = pt_get_elements_col( $source_id, 'top' );
			if ( $tops ) {
				$lp_top = array();
				foreach ( $tops as $top ) {
					$lp_top[] = "{$top->element_id}/{$top->title}";
				}
	
				$lp_top = implode("|", $lp_top);
				
				// duplicate top column
				pt_save_element_data($post_id, zm_isset($lp_top), 'top');
			}
	
			$lefts = pt_get_elements_col( $source_id, 'left' );
			if ( $lefts ) {
				$lp_left = array();
				foreach ( $lefts as $left ) {
					$lp_left[] = "{$left->element_id}/{$left->title}";
				}
	
				$lp_left = implode("|", $lp_left);
				
				// duplicate left column
				pt_save_element_data($post_id, zm_isset($lp_left), 'left');
			}
	
			$rights = pt_get_elements_col( $source_id, 'right' );
			if ( $rights ) {
				$lp_right = array();
				foreach ( $rights as $right ) {
					$lp_right[] = "{$right->element_id}/{$right->title}";
				}
	
				$lp_right = implode("|", $lp_right);
				
				// duplicate right column
				pt_save_element_data($post_id, zm_isset($lp_right), 'right');
			}
	
			$bottoms = pt_get_elements_col( $source_id, 'bottom' );
			if ( $bottoms ) {
				$lp_bottom = array();
				foreach ( $bottoms as $bottom ) {
					$lp_bottom[] = "{$bottom->element_id}/{$bottom->title}";
				}
	
				$lp_bottom = implode("|", $lp_bottom);
				
				// duplicate bottom column
				pt_save_element_data($post_id, zm_isset($lp_bottom), 'bottom');
			}
		}

		wp_redirect(admin_url('post.php?post='.$post_id.'&action=edit'));
		exit;
	}	
}

function zm_import_csv_to_database(){
	if(isset($_POST['zm_submit_form']) && $_POST['zm_submit_form'] == 'save_import'){
		$file_url =  zm_decode($_POST['zm-import-url'], 'csv');
		$response = wp_remote_get($file_url, array( 'timeout' => 120, 'httpversion' => '1.1' ));
		$data = str_getcsv($response['body'], "\n");
		$row_type = $_POST['zm_row_type'];
		$now = strtotime("now");
		$currency = 'USD';
		
		//exclude index 0
		unset($data[0]);
		
		// Default Meta Member
		$meta = array(
			'username' => '',
			'email' => '',
			'pass' => '',
			'first_name' => '',
			'last_name' => '',
			'status' => 1,
			'paypal_id' => '',
			'metadata' => maybe_serialize(array('notes' => '')),
			'date' => $now
		);
		$format = array('%s', '%s', '%s', '%s', '%s', '%d', '%s', '%s', '%d');
		
		// Default Meta Payment
		$product = zm_get_product($_POST['zm-product-apply']);
		$expired = strtotime('19 Jan 2038 03:14:07 UTC');
		$temp_day = array(
			'D' => 'day',
			'W' => 'week',
			'M' => 'month',
			'Y' => 'year'
		);
		
		$type = zm_isset($_POST['is_subscription'], false, true) ? 'subscription' : 'onetime';
		
		if($type == 'onetime'){
			$price = 0;
			$begin = $now;
		}else if($type == 'subscription'){
			$price = 0;
			$begin = strtotime($_POST['zm-begin']);
			$expired = strtotime($_POST['zm-expired']);
		}
		
		$metadata = maybe_unserialize($product->metadata);
		
		$meta_p = array(
			'product_id' => $product->ID,
			'member_id' => 0,
			'type' => $type,
			'paysys' => 'IMPORTED',
			'receipt' => 'IMPORTED',
			'amount' => $price,
			'is_rebill' => 0,
			'status' => 1, // '0' is pending; '1' is completed; '2' is canceled; '3' is expired; '4' is refunded
			'currency' => 'USD',
			'txn_id' => '',
			'other_id' => '',
			'ipaddr' => zm_get_ipaddr(),
			'begin_date' => $begin,
			'expired_date' => $expired,
			'txn_date' => $now
		);
		
		$format_p = array('%d', '%d', '%s', '%s', '%s', '%f', '%d', '%d', '%s', '%s', '%s', '%s', '%d', '%d', '%d');
		
		foreach ($data as $row){
			$i=0;
			$singledata = explode(',', $row);
			$emailexist = false;
			$meta['username'] = '';
			$meta['first_name'] = '';
			$meta['last_name'] = '';
			$meta['email'] = '';
			$meta['pass'] = '';
				
			foreach ($singledata as $singlerow){
				$datavalue = trim($singlerow);
				
				if($row_type[$i] == 'username'){
					//check is username exist
					if(zm_username_exists($datavalue)){
						$datavalue .= '_'.zm_generate_secret(4);
					}
					$username = sanitize_user($datavalue, true);
					$username = trim($username, true);
					$meta['username'] = $username;
				}else if($row_type[$i] == 'email'){
					//check is email exist
					
					if($insert_id = zm_email_exists($datavalue)){
						$emailexist = true;
					}
					
					$meta['email'] = $datavalue;
					//$meta['pass'] = wp_hash_password($datavalue);
					$meta['pass'] = $datavalue;
				}else if($row_type[$i] == 'fname'){
					$meta['first_name'] = $datavalue;
				}else if($row_type[$i] == 'lname'){
					$meta['last_name'] = $datavalue;
				}
				
				$i++;
			}

			if (!$emailexist){
				if($meta['username'] == ''){
					$username = strtolower(zm_generate_username($meta['email'], zm_isset($meta['first_name']) ? $meta['first_name'] : $meta['email'], zm_isset($meta['last_name']) ? $meta['last_name'] : ''));
					$username = sanitize_user($username, true);
					$meta['username'] = trim($username, true);
				}
				
				$insert_id = zm_insert_query('zm_members', $meta, $format);
			}
			//Set payment/assign to product
			$meta_p['member_id'] = $insert_id;
			zm_insert_query('zm_payments', $meta_p, $format_p);
		}
		
		wp_redirect(admin_url('admin.php?page=zm-admin&mode=members&imported=true'));
		exit;
	}
}

function zm_generate_history_id($id){
	$mode = str_replace('?', '', $id);
	$mode = str_replace('&', '', $mode);
	$mode = str_replace('=', '', $mode);
	$mode = str_replace('/', '', $mode);
	$mode = str_replace('-', '', $mode);
	return md5($mode);
}
