<?php

/* ======================================
 * JS-CALLBACK-RELATED FUNCTIONS
 * ====================================== */

 add_action('wp_ajax_zm_lock', 'zm_lock_callback');
function zm_lock_callback() {
    global $wpdb;
    // Update status member
    $id = intval($_POST['id']);
    $status = intval($_POST['status']);

    $meta = array(
        'status' => $status
    );

    $format = array('%d');
    $wpdb->update( "{$wpdb->prefix}zm_members", $meta, array( 'ID' => $id ), $format, array( '%d' ) );

    echo 'success';
    die();
}

add_action('wp_ajax_zm_resend', 'zm_resend_callback');
function zm_resend_callback() {
    global $wpdb;

    $member_id = intval($_POST['id']);

    $emails = get_option('zm_email_setup');
    $welcome = zm_isset($emails['welcome_email']);

    $last_payment = $wpdb->get_row(
        $wpdb->prepare("SELECT * FROM `{$wpdb->prefix}zm_payments`
            WHERE `member_id` = %d ORDER BY ID DESC LIMIT 1",
            $member_id
        )
    );

    if ($last_payment){
        if ( !$m = zm_member($member_id) )
        die('failed');

        $temp_passwords = get_option('zm_temp_pass');
        $plain_pass = zm_isset($temp_passwords[$member_id], '- your existing password -', true);

        $subject = zm_parse_mail_tags(zm_sanitize($welcome['subject']), $member_id, $last_payment->product_id, $last_payment->ID, $plain_pass);
        $body = zm_parse_mail_tags(zm_sanitize($welcome['body']), $member_id, $last_payment->product_id, $last_payment->ID, $plain_pass);

        zm_mail($m->email, $subject, $body);

        die('success');
    }else{
        die('failed');
    }
}

add_action('wp_ajax_zm_save_product_wizard', 'zm_save_product_wizard_callback');
function zm_save_product_wizard_callback() {
    $data = array(
        'zm-product-name' => str_replace('"', "", $_POST['pname']),
        'zm-download-page' => $_POST['pdownload'],
        'zm-thanks-url' => $_POST['pthanksurl'],
        'zm-payment-type' => $_POST['ptype'],
        'zm-is-trial' => 0,
        'zm-trial-price' => 0.00,
        'zm-price-o' => 0.00,
        'zm-price-r' => 0.00,
        'zm-subscription-duration' => 1,
        'zm-trial-duration' => 1,
        'zm-subscription-duration-for' => 'M',
        'zm-trial-duration-for' => 'M',
        'zm-rebill-times' => 0,
        'zm-payment-processor' => maybe_unserialize('a:5:{s:5:"zaxaa";a:3:{s:6:"enable";s:3:"off";s:3:"pid";s:0:"";s:8:"currency";s:3:"USD";}s:6:"wsopro";a:2:{s:6:"enable";s:3:"off";s:8:"currency";s:3:"USD";}s:6:"paypal";a:2:{s:6:"enable";s:3:"off";s:8:"currency";s:3:"USD";}s:5:"jvzoo";a:3:{s:6:"enable";s:3:"off";s:3:"pid";s:0:"";s:8:"currency";s:3:"USD";}s:9:"clickbank";a:4:{s:6:"enable";s:3:"off";s:3:"pid";s:0:"";s:3:"vid";s:0:"";s:8:"currency";s:3:"USD";}}'),
        'zm-autoresponder' => maybe_unserialize('a:4:{s:6:"enable";s:3:"off";s:8:"provider";s:6:"aweber";s:4:"list";s:0:"";s:4:"code";s:0:"";}'),
        'zm-gotowebinar' => '',
    );
    zm_add('product', $data, 'ajax');
}

add_action('wp_ajax_zm_create_page', 'zm_create_page_callback');
function zm_create_page_callback(){
    $id = $_POST['id'];
    $title = zm_isset($_POST['title']) ? $_POST['title'] : date('M d, Y, H:i A', zm_time());
    $newpage = array();
      $newpage['post_status'] = 'publish';
      $newpage['post_author'] = 1;
    $newpage['post_type'] = 'page';

    $newpage['post_title'] = 'Zaxaa Member - Download Page '.$title;
    $newpage['post_content'] = 'Download content OR link here';

    $post_id = wp_insert_post( $newpage );

    echo json_encode(array($post_id, $newpage['post_title']));
    die();
}

add_action('wp_ajax_zm_az_getlists', 'zm_az_getlists_callback');
function zm_az_getlists_callback(){
    if ($s3 = zm_s3_connect()){
        $lists = $s3->listBuckets();
        ?>
        <br>
        <div class="gpf-row collapse">
            <div class="large-12 gpf-columns">
                <select name="zm-az-bucket" data-product="s3files<?php echo isset($_POST['id']) ? 'protect'.$_POST['id'] : ''; ?>" id="zm-az-bucket">
                    <?php
                    if ($lists){
                        echo '<option value="-1">-- Select Bucket --</option>';
                        foreach ($lists as $list){
                            echo '<option value="'.$list.'">'.$list.'</option>';
                        }
                    }else{
                        echo '<option value="-1">no list</option>';
                    }
                    ?>
                </select>
            </div>
        </div>
        <br>
    <?php
    die();
    }
}

add_action('wp_ajax_zm_az_getfiles', 'zm_az_getfiles_callback');
function zm_az_getfiles_callback(){
    $table_header = array('', 'Title', '',
                      'Drip Start <span data-tooltip class="zm-help tip-top" title="If you want your content/file to be immediately available for members, enter &quot;0&quot;"></span>',
                      'Drip End');
    $id = $_POST['id'];
    $bucket = $_POST['bucket'];

    if ($s3 = zm_s3_connect()){
        $protects = zm_get_all('protect', array('product_id', $id), 'file_s3');

        $protect_data = array();
        foreach ($protects as $protect){
            $protect_data[$protect->filename] = array(
                'enable' => true,
                'start' => array('mode' => $protect->d_start_mode,
                                'value' => $protect->d_start),
                'end' => array('mode' => $protect->d_end_mode,
                                'value' => $protect->d_end,
                                'used' => $protect->d_end_used),
                'expired' => $protect->is_expired
            );
        }
        //var_dump($s3->getBucket('sembucket'));
        //$lists = $s3->listBuckets();

        //var_dump($lists);

        ?>
        <div id="zm-table-s3filesprotect<?php echo $id; ?>">
        <?php
            //if ($lists){
                //$i = 0;
                //foreach ($lists as $bucket){
                    $files = $s3->getBucket($bucket);

                    //$hide = ($i > 0) ? 'style="display:none;"' : '';
                    //$i++;

                    echo '<div class="bucket-s3" id="bucket-s3-'.$bucket.'" '.$hide.'>';
                    echo '<input type="hidden" name="load-buckets[]" value="'.$bucket.'"/>';
                    if ($files){
                        //OPEN TABLE
                        zm_table_open($table_header, 's3');

                        if (count($files) > 0){
                            foreach ( $files as $file ) {
                                $icon = zm_get_icon($file['name']);
                                //var_dump($file);
                                $row = array(
                                    'enable' => false,
                                    'start' => array('mode' => 'D',
                                                    'value' => 0),
                                    'end' => array('mode' => 'D',
                                                   'value' => 30,
                                                   'used' => 0));

                                $f_id = 's3_'.$bucket.'_'.zm_encode($file['name'], 'zm_s3');

                                if (isset($protect_data[$f_id])){
                                    $row = $protect_data[$f_id];
                                }

                                $smode = zm_drip_options('start', $f_id, $row['start']['mode'], $row['enable']);

                                $is_e_used = ($row['end']['used']) ? 'checked' : '';

                                $is_expired = '';
                                if ($is_e_used){
                                    if ($row['expired'] == 1){
                                        $is_expired = '<em class="zm_exp">(expired)</em>';
                                    }
                                }

                                $emode = zm_drip_options('end', $f_id, $row['end']['mode'], $is_e_used);

                                echo '<tr valign="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
                                echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selects3" type="checkbox" name="zm-ac-post[]" value="'.$f_id.'" '.($row['enable'] ? 'checked' : '').'></th>';
                                echo '<td><i class="'.$icon.'"></i></td>';
                                echo '<td>'.$file['name'].' '.$is_expired.'</td>';
                                if($icon == 'zm-icon-vid')
                                    echo '<td><span class="button small radius secondary zm-get-s3-download-url" id="'.zm_encode('2|'.$bucket.'|'.$file['name'], 'zm').'&type=video">Get video URL</span></td>';
                                else
                                    echo '<td><span class="button small radius secondary zm-get-s3-download-url" id="'.zm_encode('2|'.$bucket.'|'.$file['name'], 'zm').'">Get download URL</span></td>';
                                echo '<td>';
                                echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
                                    <div class="large-12 gpf-columns">
                                    <i class="icon-user"></i> Public Access
                                    </div>
                                    </div>';

                                echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
                                        <div class="large-7 gpf-columns">';

                                $is_exact = ($row['start']['mode'] == 'X') ? true : false;
                                echo '<input type="text" id="numb'.$f_id.'-s" class="zm-start-value required digits" name="zm-ac-data['.$f_id.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
                                echo '<input type="text" id="date'.$f_id.'-s" class="zm-start-dp-value" name="zm-ac-data['.$f_id.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
                                echo '</div>';

                                echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';

                                echo '<td>';
                                $is_exact = ($row['end']['mode'] == 'X') ? true : false;
                                echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
                                    <div class="large-12 gpf-columns" style="text-align: center;">
                                    <i class="icon-user"></i> Public Access
                                    </div>
                                    </div>';

                                echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
                                        <div class="large-3 gpf-columns">
                                              <span class="prefix radius">';
                                echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$f_id.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
                                echo '</span>
                                        </div>';

                                echo '<div class="large-4 gpf-columns">';
                                echo '<input type="text" id="numb'.$f_id.'-e" class="zm-end-value required digits" name="zm-ac-data['.$f_id.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
                                echo '<input type="text" id="date'.$f_id.'-e" class="zm-end-dp-value" name="zm-ac-data['.$f_id.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';

                                echo '</div>';

                                echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
                                echo '</tr>';
                            }
                        }else{
                            echo '<tr class="alternate" valign="top"><td colspan="6" align="center">--No Files--</td></tr>';
                        }

                        zm_table_close();
                        //CLOSE TABLE
                    }else{
                        echo '<p style="text-align: center; color:red;"><i class="icon-exclamation-sign"></i> Couldn\'t not found bucket with name specified above.</p>';
                    }

                    echo '</div>';
                //}
            //}
        ?>
        </div>
        <?php
    }else{
        echo '<div class="alert-box alert" style="margin:10px 0"><p>Can\'t connect to your amazon s3 account. Please make sure you have enabled this feature AND entered the correct API key and Secret Key <a href="'.admin_url('admin.php?page=zm-admin&mode=config').'" target="_blank">here</a></p></div>';
    }
    die();
}

add_action('wp_ajax_zm_local_getfiles', 'zm_local_getfiles_callback');
function zm_local_getfiles_callback(){

    $id = $_POST['id'];
    $protects = zm_get_all('protect', array('product_id', $id), 'file_local');
    $table_header = array('', 'Title', '',
                      'Drip Start <span data-tooltip class="zm-help tip-top" title="If you want your content/file to be immediately available for members, enter &quot;0&quot;"></span>',
                      'Drip End');
    $protect_data = array();
    foreach ($protects as $protect){
        $protect_data[$protect->filename] = array(
            'enable' => true,
            'start' => array('mode' => $protect->d_start_mode,
                            'value' => $protect->d_start),
            'end' => array('mode' => $protect->d_end_mode,
                            'value' => $protect->d_end,
                            'used' => $protect->d_end_used),
            'expired' => $protect->is_expired
        );
    }
    ?>
    <div id="zm-table-filesprotect<?php echo $id; ?>">
    <?php
        //OPEN TABLE
        zm_table_open($table_header, 'file');

        $empty = true;
        if ( $dir = opendir( ZM_DOWNLOAD) ) {
            while ( false !== ($file = readdir($dir)) ) {
                   if ( $file != "." && $file != ".." && $file != '.htaccess') {
                       $empty = false;
                    $is_dir = is_dir(ZM_DOWNLOAD.'/'.$file);

                    if ($is_dir){
                        //zm_access_folder_row($file);

                        $path2 = ZM_DOWNLOAD.'/'.$file;
                        if ( $dir2 = opendir($path2) ) {
                            while ( false !== ($file2 = readdir($dir2)) ) {
                                   if ( $file2 != "." && $file2 != ".." && $file2 != '.htaccess') {

                                    $is_dir = is_dir($path2.'/'.$file2);

                                    if ($is_dir){
                                        //zm_access_folder_row($file2);

                                        $path3 = ZM_DOWNLOAD.'/'.$file.'/'.$file2;

                                        if ( $dir3 = opendir($path3) ) {
                                            while ( false !== ($file3 = readdir($dir3)) ) {
                                                   if ( $file3 != "." && $file3 != ".." && $file3 != '.htaccess') {
                                                    zm_access_file_row('local_', $file.'/'.$file2.'/'.$file3, $protect_data);
                                                }
                                            }
                                            closedir($dir3);
                                        }
                                    }else{
                                        zm_access_file_row('local_', $file.'/'.$file2, $protect_data);
                                    }
                                }
                            }
                            closedir($dir2);
                        }
                    }else{
                        zm_access_file_row('local_', $file, $protect_data);
                    }
                }
            }

            if ($empty){
                echo '<tr class="alternate" valign="top"><td colspan="6" align="center">--No Files--</td></tr>';
            }
            closedir($dir);
        }else{
            echo '<tr class="alternate" valign="top"><td colspan="6" align="center">--No Files--</td></tr>';
        }

        zm_table_close();
        //CLOSE TABLE
    ?>
    </div>
    <input type="hidden" value="1" name="zm-include-file" id="zm-include-file"/>
    <?php
    die();
}

add_action('wp_ajax_zm_autoresponder_get_list', 'zm_autoresponder_get_list_callback');
function zm_autoresponder_get_list_callback(){
    $provider = $_POST['provider'];

    if ($provider == 'aweber'){
        echo zm_get_aweber_lists();
    }else if ($provider == 'getresponse'){
        echo zm_get_getresponse_lists();
    }else if ($provider == 'icontact'){
        echo zm_get_icontact_lists();
    }else if ($provider == 'mailchimp'){
        echo zm_get_mailchimp_lists();
    }

    die();
}

add_action('wp_ajax_zm_edit_payment', 'zm_edit_payment_callback');
function zm_edit_payment_callback(){
    $id = $_POST['id'];
    $data = zm_get_row('payment', $id);
    $data->begin_date = date("m/d/Y", $data->begin_date);
    $data->expired_date = date("m/d/Y", $data->expired_date);
    die(json_encode($data));
}

add_action('wp_ajax_zm_config_general', 'zm_config_general_callback');
function zm_config_general_callback(){
    $general = array(
        'is_powered' => 'on',
        'aff_link'	=> '',
        'az_api' => '',
        'az_key'	=> '',
        'expired_page' => $_POST['expired'],
        'unavailable_page' => $_POST['unavailable'],
        'login_page' => $_POST['login'],
        'after_login_page' => $_POST['welcome'],
        'access_error_page' => $_POST['error'],
        'profile_page' => $_POST['profile'],
        'logout_page' => $_POST['logout'],
        'rc_public_key' => '',
        'rc_private_key' => '',
        'gtw_key' => ''
    );

    update_option('zm_general_option', $general);

    if (get_option('zm_general_option')){
        die('success');
    }

    die('failed');
}

add_action('wp_ajax_zm_config_payment', 'zm_config_payment_callback');
function zm_config_payment_callback(){
    $payment = array(
        'zaxaa' => array('api' => $_POST['za_api'])
    );

    update_option('zm_payment_option', $payment);

    if (get_option('zm_payment_option')){
        die('success');
    }

    die('failed');
}

add_action('wp_ajax_zm_config_email', 'zm_config_email_callback');
function zm_config_email_callback(){
    $email = array(
        'from_name' => $_POST['name'],
        'from_email' => $_POST['email'],
        'mailer' => $_POST['mailer'],
        'smtp_host'	=> $_POST['host'],
        'smtp_port'	=> $_POST['port'],
        'encryption' => $_POST['encryption'],
        'is_auth' => $_POST['auth'],
        'smtp_username' => $_POST['username'],
        'smtp_password' => $_POST['password'],
        'welcome_email' => array('send_admin' => $_POST['w_admin'], 'subject' => strip_tags($_POST['w_subject']), 'body' => strip_tags($_POST['w_body'])),
        'forgot_email' => array('subject' => strip_tags($_POST['f_subject']), 'body' => strip_tags($_POST['f_body']))
    );

    update_option('zm_email_setup', $email);
    if (get_option('zm_email_setup')){
        update_option('zm_wizard_completed', true);
        die('success');
    }

    die('failed');
}


add_action('wp_ajax_zm_display_order_url', 'zm_display_order_url_callback' );
function zm_display_order_url_callback(){

    $id = $_POST['id'];
    $data = zm_get_row('product', $id);

    if ($data){
        $payments = array();
        $metadata = maybe_unserialize($data->metadata);

        if ($metadata['paypal']['enable'] == 'on'){
            $payments[] = 'paypal';
        }

        if ($metadata['clickbank']['enable'] == 'on'){
            $payments[] = $metadata['clickbank']['vid'].'|'.$metadata['clickbank']['pid'];
        }

        if ($metadata['zaxaa']['enable'] == 'on'){
            $payments[] = 'zaxaa';
        }

        if ($metadata['jvzoo']['enable'] == 'on'){
            $payments[] = 'jvzoo';
        }

        die (json_encode($payments));
    }else{
        die('failed');
    }
}

add_action('wp_ajax_zm_clone_product', 'zm_clone_product_callback' );
function zm_clone_product_callback(){
    $id = $_POST['id'];
    $site_name = get_bloginfo('name');
    $id = zm_clone('product', $id);

    if ($id){
        $row = zm_get_row('product', $id);

        $payment_proc = '';

        if ($row->type == 'onetime'){
            $type = 'One-time Payment';
            $price = $row->ot_price;
        }else if ($row->type == 'subscription'){
            $type = ' Recurring Billing';
            $price = $row->rc_price.' '.zm_format_recurring($row->subs_num, $row->subs_mode);
        }

        $payment_proc_temp = maybe_unserialize($row->metadata);
        if ( $payment_proc_temp ) {
            $payment_proc_temp = array_reverse($payment_proc_temp);
            foreach ( $payment_proc_temp as $key => $value ) {
                if ($value['enable'] == 'on'){
                    if ($payment_proc) $payment_proc .= ' '.zm_lbl_payment_type($key);
                    else $payment_proc .= zm_lbl_payment_type($key);
                }
            }
        } else {
            $payment_proc = '- None Selected -';
        }

        echo '<tr class="zm-row zm-ease">';
        echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select" type="checkbox" name="zm_product[]" value="'.$row->ID.'"></th>';
        echo '<td><a class="zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=products&process=edit&id='.$row->ID.'" title="Edit &quot;'.$row->title.'&quot;" data-mode="productsedit'.$row->ID.'" data-title="'.$row->title.' &lsaquo; '.$site_name.'">'.$row->title.'</a></td>';
        if ($row->type == 'free'){
            echo '<td colspan="3" align="center">Free (<a href="#" id="'.$row->ID.'" class="zm-create-fr">Create free registration form</a>)</td>';
        }else{
            echo '<td>'.$type.'</td>';
            echo '<td>'.$price.'</td>';
            echo '<td>'.$payment_proc.'</td>';
        }
        echo '<td>'.date('M d, Y, H:i A', $row->date).'</td>';
        echo '<td style="text-align:right;"><div class="button-group">';
        echo '<a class="button zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=products&process=edit&id='.$row->ID.'" title="edit" data-mode="productsedit'.$row->ID.'" data-title="'.$row->title.' &lsaquo; '.$site_name.'"><i class="icon-pencil"></i></a>';
        echo '<a class="button zm-clone-product" href="#" id="'.$row->ID.'" title="duplicate product"><i class="icon-copy"></i></a>';

        if ($row->type == 'free')
            echo '<a class="button zm-show-order-url" id="0" href="#" title="order URL" disabled><i class="icon-link"></i></a>';
        else
            echo '<a class="button zm-show-order-url" id="'.$row->ID.'" href="'.admin_url('admin.php').'?page=zm-admin&mode=products&process=order&id='.$row->ID.'" title="order URL"><i class="icon-link"></i></a>';

        echo '<a class="button zm-delete-item" href="#" id="product|'.$row->ID.'" title="delete"><i class="icon-trash"></i></a>';
        echo '</div></td>';

        echo '</tr>';
        die();
    }else{
        die('failed');
    }
}

add_action('wp_ajax_zm_delete_item', 'zm_delete_item_callback' );
function zm_delete_item_callback(){
    $id = $_POST['id'];
    $var = explode('|', $id);

    if ($var[0] == 'product'){
        zm_delete('product', abs($var[1]));
        die('success');
    }else if ($var[0] == 'member'){
        zm_delete('member', abs($var[1]));
        die('success');
    }else if ($var[0] == 'coupon'){
        zm_delete('coupon', abs($var[1]));
        die('success');
    }
}

add_action('wp_ajax_zm_eng_detail_page', 'zm_eng_detail_page_callback' );
function zm_eng_detail_page_callback(){
    $member_id = $_POST['id'];

    if ($member_id){
        global $wpdb;

        $conditions = 'WHERE T1.member_id='.$member_id;
        if ($txn_time = zm_isset($_POST['time'])){
            if ($txn_date = zm_time_condition('T1.date', $txn_time, $_POST['f'], $_POST['t']))
                $conditions .= ' AND '.$txn_date;
        }

        $query = "SELECT T1.*, T2.post_title, T2.post_type, COUNT(T1.page_id) as times
            FROM `{$wpdb->prefix}zm_access_log` AS T1
            LEFT JOIN `{$wpdb->prefix}posts` AS T2 ON T1.page_id=T2.ID
            {$conditions}
            GROUP BY T1.page_id
            ORDER BY times DESC";

        $data = $wpdb->get_results($query);

        zm_table_open(array('','Page/Post', '# times'), '', false);
        if ($data){
            foreach ($data as $row){
                echo '<tr valign="top" class="zm-row">';
                echo '<td><i class="icon-file-text-alt"></i></td>';
                echo '<td>'.$row->post_title.' ('.$row->post_type.')</td>';
                echo '<td>'.$row->times.'</td>';
                echo '</tr>';
            }
        }else{
            echo '<tr><td colspan="3" style="text-align:center;">--No data--</td></tr>';
        }
        zm_table_close();
        die();
    }else{
        die('failed');
    }
}


add_action('wp_ajax_zm_import_members', 'zm_import_members_callback' );
function zm_import_members_callback(){
    for($i=0; $i<10000; $i++){
        $data = zm_encode($i, 'test');
    }

    die($data);
}

add_action('wp_ajax_zm_eng_detail_ip', 'zm_eng_detail_ip_callback' );
function zm_eng_detail_ip_callback(){
    $member_id = $_POST['id'];

    if ($member_id){
        global $wpdb;

        $conditions = 'WHERE member_id='.$member_id;
        if ($txn_time = zm_isset($_POST['time'])){
            if ($txn_date = zm_time_condition('date', $txn_time, $_POST['f'], $_POST['t']))
                $conditions .= ' AND '.$txn_date;
        }

        $query = "SELECT *, COUNT(ip_addr) as times
            FROM `{$wpdb->prefix}zm_access_log`
            {$conditions}
            GROUP BY ip_addr
            ORDER BY times DESC";

        $data = $wpdb->get_results($query);

        zm_table_open(array('','IP Address', '# times'), '', false);
        if ($data){
            foreach ($data as $row){
                echo '<tr valign="top" class="zm-row">';
                echo '<td><i class="icon-location-arrow"></i></td>';
                if ($_POST['geo']){
                    $ipinfo = zm_get_info($row->ip_addr);
                    $city = zm_city($ipinfo);
                    $country = zm_country($ipinfo);

                    echo '<td>'.$row->ip_addr.' ('.($city ? $city : 'unknown').', '.($country ? $country : 'unknown').')</td>';
                }else{
                    echo '<td>'.$row->ip_addr.'</td>';
                }
                echo '<td>'.$row->times.'</td>';
                echo '</tr>';
            }
        }else{
            echo '<tr><td colspan="3" style="text-align:center;">--No data--</td></tr>';
        }
        zm_table_close();
        die();
    }else{
        die('failed');
    }
}

add_action('wp_ajax_zm_1shoppingcart_test', 'zm_1shoppingcart_test_callback');
function zm_1shoppingcart_test_callback(){
    $id = $_POST['id'];
    $key = $_POST['key'];

    $api_url = 'https://www.mcssl.com/API/'.$id.'/Notifications/TEST?key='.$key;

    $result = wp_remote_get( $api_url, array(
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.1',
            'sslverify' => false
        )
    );

    $requestBodyXML = new DOMDocument();
    # Load the request body into XML and check that the result has been parsed into XML

    if ($requestBodyXML->loadXML($result['body']) == true){
        $response = $requestBodyXML->getElementsByTagName('Response')->item(0)->getAttribute('success');

        if ($response == 'true'){
            die('success');
        }else{
            $error = $requestBodyXML->getElementsByTagName('Error')->item(0)->getAttribute('success');
            die($error);
        }
    }else{
        die('Cant parsed XML.');
    }
}

add_action('wp_ajax_zm_truncate', 'zm_truncate_callback');
function zm_truncate_callback(){
    $id = $_POST['id'];
    global $wpdb;

    if ($id == 'product'){
        $pass = false;
        if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_products")){
            $pass = true;
        }

        if($pass){
            if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_protects")){
                die('success');
            }
        }
    }else if ($id == 'member'){
        if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_members")){
            die('success');
        }
    }else if ($id == 'coupon'){
        if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_coupons")){
            die('success');
        }
    }else if ($id == 'report'){
        $pass = false;

        if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_payments")){
            $pass = true;
        }

        if($pass){
            if($wpdb->query("DELETE FROM {$wpdb->prefix}zm_access_log")){
                die('success');
            }
        }
    }

    die('failed');
}
