<?php
$process = zm_isset($_GET['process']);
switch ( $process ) {
	case 'add':
	case 'edit':
		zm_add_member_form();
		break;

	case 'delete':
		zm_delete('member', $_GET['id']);
		break;

	case 'clone':
		zm_clone('member', $_GET['id']);
		break;
	default:
		zm_manage_members();
}

function zm_manage_members() {
	$site_name = get_bloginfo('name');

	$start = isset($_GET['p']) ? $_GET['p'] : 1;
	$limit = 10;

	$params = array('zm_reg_time' => isset($_GET['time']) ? $_GET['time'] : '7daysago');
	$params['zm_from'] = isset($_GET['f']) ? $_GET['f'] : '';
	$params['zm_to'] = isset($_GET['t']) ? $_GET['t'] : '';
	$params['zm_email'] = isset($_GET['e']) ? $_GET['e'] : 'all';
	$params['zm_username'] = isset($_GET['u']) ? $_GET['u'] : 'all';
	$params['zm_lock'] = isset($_GET['l']) ? $_GET['l'] : 'all';
	$params['zm_status'] = isset($_GET['m']) ? $_GET['m'] : 'all';
	$params['start'] = $start;
	$params['limit'] = $limit;
	$data = zm_get_all('member', $params);

	$data_count = zm_get_count('member', $params);

	$conditions = '&time='.$params['zm_reg_time'];
	if ($params['zm_reg_time'] == 'exactdate'){
		$conditions .= '&f='.$params['zm_from'];
		$conditions .= '&t='.$params['zm_to'];
	}
	$conditions .= '&e='.$params['zm_email'];
	$conditions .= '&u='.$params['zm_username'];
	$conditions .= '&l='.$params['zm_lock'];
	$conditions .= '&m='.$params['zm_status'];

	$paginations = zm_set_pagination(admin_url('admin.php?page=zm-admin&mode=members'.$conditions), $data_count, $start, $limit, 'Zaxaa Member &lsaquo; '.$site_name, 'sem-members');

	do_action('zm_message');
	?>
<div id="zm-members">
	<form class="custom" method="post">
		<div class="zm-biglabel"><i class="icon-group"></i> Manage Members&nbsp;&nbsp;&nbsp;<span style="margin:0 !important;" class="gpf-button tiny radius zm-add-new" data-url="<?php echo admin_url('admin.php?page=zm-admin&mode=members&process=add');?>" data-mode="membersadd" data-title="Zaxaa Member &lsaquo; <?php echo $site_name; ?>"><i class="icon-plus"></i> add new</span>&nbsp;&nbsp;<?php echo '<span style="margin:0 !important;" data-type="member" class="gpf-button radius disabled tiny alert zm-delete-all"><i class="icon-trash"></i> delete ALL members</span>'; ?></div>
		<div class="gpf-row collapse">
			<div class="large-2 gpf-columns">
			  <span class="prefix radius"><?php _e('Email Address', 'zm'); ?></span>
			</div>
			<div class="large-4 gpf-columns">
				<input type="text" name="zm_email" id="zm-m-email" value="<?php echo isset($_GET['e']) ? ($_GET['e'] == 'all' ? '' : $_GET['e']) : ''; ?>" />
			</div>
			<div class="large-2 gpf-columns">
			  <span class="prefix"><?php _e('Username', 'zm'); ?></span>
			</div>
			<div class="large-4 gpf-columns">
				<input type="text" name="zm_username" id="zm-m-username" value="<?php echo isset($_GET['u']) ? ($_GET['u'] == 'all' ? '' : $_GET['u']) : ''; ?>" />
			</div>
		</div>
		<div class="gpf-row collapse">
			<div class="large-2 gpf-columns">
			  <span class="prefix radius"><?php _e('Lock Status', 'zm'); ?></span>
			</div>
			<div class="large-4 gpf-columns">
				<select name="zm-m-lock" id="zm-m-lock">
					<option value="all" <?php echo zm_isset($_GET['l'], 'all') == 'all' ? 'selected="selected"' : ''; ?>>All</option>
					<option value="1" <?php echo zm_isset($_GET['l'], 'all') == '1' ? 'selected="selected"' : ''; ?>>Actived</option>
					<option value="2" <?php echo zm_isset($_GET['l'], 'all') == '2' ? 'selected="selected"' : ''; ?>>Locked</option>
				</select>
			</div>

			<div class="large-2 gpf-columns">
			  <span class="prefix"><?php _e('Membership Status', 'zm'); ?></span>
			</div>
			<div class="large-4 gpf-columns">
				<select name="zm-m-lock" id="zm-m-status">
					<option value="all" <?php echo zm_isset($_GET['m'], 'all') == 'all' ? 'selected="selected"' : ''; ?>>All</option>
					<option value="1" <?php echo zm_isset($_GET['m'], 'all') == '1' ? 'selected="selected"' : ''; ?>>Currently Paying Members</option>
					<option value="2" <?php echo zm_isset($_GET['m'], 'all') == '2' ? 'selected="selected"' : ''; ?>>Currently Non-Paying Members</option>
				</select>
			</div>
		</div>
		<div class="gpf-row collapse">
			<div class="large-2 gpf-columns">
			  <span class="prefix radius"><?php _e('Registration Date', 'zm'); ?></span>
			</div>
			<div class="large-<?php echo zm_isset($_GET['time']) == 'exactdate' ? '3' : '9'; ?> gpf-columns" id="zm_reg_time_parent">
				<select name="zm_txn_time" id="zm-m-txn-time">
					<option value="all" <?php echo zm_isset($_GET['time'], '7daysago') == 'all' ? 'selected="selected"' : ''; ?>>All</option>
					<option value="today" <?php echo zm_isset($_GET['time'], '7daysago') == 'today' ? 'selected="selected"' : ''; ?>>Today</option>
					<option value="yesterday" <?php echo zm_isset($_GET['time'], '7daysago') == 'yesterday' ? 'selected="selected"' : ''; ?>>Yesterday</option>
					<option value="7daysago" <?php echo zm_isset($_GET['time'], '7daysago') == '7daysago' ? 'selected="selected"' : ''; ?>>Last 7 Days</option>
					<option value="30daysago" <?php echo zm_isset($_GET['time'], '7daysago') == '30daysago' ? 'selected="selected"' : ''; ?>>Last 30 Days</option>
					<option value="exactdate" <?php echo zm_isset($_GET['time'], '7daysago') == 'exactdate' ? 'selected="selected"' : ''; ?>>Use Exact Date</option>
				</select>
			</div>
			<div class="large-3 gpf-columns zm-m-exact-search" <?php echo zm_isset($_GET['time']) == 'exactdate' ? '' : 'style="display:none;"'; ?>>
				<input type="text" name="zm_from" id="zm-m-start-exact-search" value="<?php echo isset($_GET['f']) ? $_GET['f'] : date("m/d/Y"); ?>" />
			</div>
			<div class="large-3 gpf-columns zm-m-exact-search" <?php echo zm_isset($_GET['time']) == 'exactdate' ? '' : 'style="display:none;"'; ?>>
				<input type="text" name="zm_to" id="zm-m-until-exact-search" value="<?php echo isset($_GET['t']) ? $_GET['t'] : date("m/d/Y", strtotime("tomorrow")); ?>" />
			</div>
			<div class="large-1 gpf-columns">
			  <span data-title="Zaxaa Member &lsaquo; <?php echo $site_name; ?>" data-url="<?php echo admin_url('admin.php?page=zm-admin&mode=members'); ?>" id="zm-search-member"><a class="gpf-button radius postfix"><i class="icon-search"></i> Search</a></span>
			</div>
		</div>
		<div id="sem-members">
			<div id="zm-members<?php echo zm_generate_history_id($conditions.'p'.$params['start']); ?>"><!-- ajax load wrapper -->
				<?php
				//OPEN TABLE
				zm_table_open(array('Username', 'Email', 'Lock Status', 'Registered Date', ''));

				if (zm_isset($data)) {
					foreach ($data as $row){
						$lock = ($row->status == 1) ? '<span class="gpf-label success round"><i class="icon-ok" id="zm-status-'.$row->ID.'" title="active"></i></span>' : '<span class="gpf-label alert round"><i title="locked" class="icon-lock" id="zm-status-'.$row->ID.'"></i></span>';
						echo '<tr valign="top" class="zm-row">';
						echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select" type="checkbox" name="zm_member[]" value="'.$row->ID.'"></th>';
						echo '<td><a class="zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=members&process=edit&id='.$row->ID.'" title="Edit &quot;'.$row->username.'&quot;" data-mode="membersedit'.$row->ID.'" data-title="Zaxaa Member - Edit Member &lsaquo; '.$site_name.'">'.$row->username.'</a></td>';
						echo '<td>'.$row->email.'</td>';
						echo '<td style="padding-left: 30px">'.$lock.'</td>';
						echo '<td>'.date('M d, Y, H:i A', $row->date).'</td>';
						echo '<td style="text-align:right;">';
						echo '<div class="button-group">';
						echo '<a class="button zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=members&process=edit&id='.$row->ID.'" title="edit" data-mode="membersedit'.$row->ID.'" data-title="Zaxaa Member - Edit Member &lsaquo; '.$site_name.'"><i class="icon-pencil"></i></a>';
						echo '<a class="button zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=members&process=edit&id='.$row->ID.'&payment=add" title="payments/subscriptions" data-mode="memberspayment'.$row->ID.'" data-title="Zaxaa Member - Edit Member &lsaquo; '.$site_name.'"><i class="icon-file-text"></i></a>';
						echo '<a class="zm-lock button" href="#" mid="'.$row->ID.'" status="'.$row->status.'" title="'.($row->status ? 'lock this member"><i class="icon-lock"></i>' : 'unlock this member"><i class="icon-unlock "></i>').'</a>';
						echo '<a class="zm-resend button" href="#" data-rid="'.$row->ID.'" title="resend login information"><i class="icon-envelope"></i></a>';
						echo '<a class="button zm-delete-item" href="#" id="member|'.$row->ID.'" title="delete"><i class="icon-trash"></i></a></div></td>';
						echo '</tr>';
					}
				}else{ ?>
				<tr class="alternate" valign="top">
					<td colspan="6" align="center">--No members--</td>
				</tr>
				<?php }
				zm_table_close();
				//CLOSE TABLE
				?>
				<br>
				<div class="gpf-row collapse">
					<div class="large-3 gpf-columns">
						<select name="zm_action_1" style="height: 25px;" >
							<option value="-1" selected="selected">Bulk Actions</option>
							<option value="del">Delete</option>
						</select>
					</div>
					<div class="large-1 gpf-columns">
					<input type="submit" name="" id="doaction" class="gpf-button action postfix" value="Apply">
					</div>
					<div class="large-6 gpf-columns">
						<?php if (ceil($data_count/$limit) > 1): ?>
						<div style="text-align: right;">
							<?php echo $paginations; ?>
						</div>
						<?php endif; ?>
					</div>
				</div>
			</div><!-- ajax load wrapper nested -->
		</div>
	</form>
</div><!-- ajax load wrapper -->
<?php
}

function zm_add_member_form(){

	$tabsmenunestedception = zm_isset($_COOKIE['zm_tabs_menu_nestedception'], 'member-general');
	$id = zm_isset($_GET['id'], 0 , true);
	$payment = zm_isset($_GET['payment'], false , true);

	$data = (object) array();

	if ( $id ) {
		// GET DATA
		$data = zm_get_row('member', $id);
		$data->metadata = maybe_unserialize($data->metadata);
	}

	do_action('zm_message');

	if (!$payment):
	?>
	<div id="<?php echo ($id) ? 'zm-membersedit'.$id : 'zm-membersadd'; ?>">
		<div class="zm-biglabel"><?php echo ($id) ? '<i class="icon-pencil"></i> Edit' : '<i class="icon-plus"></i> Add'; ?> Member</div>
		<div id="zm-wrapper" style="padding-bottom:20px">
			<form class="custom zm-required" method="post">
				<input type="hidden" name="zm-nonce" id="zm-nonce" value="<?php echo $id ? $id : md5('add_member'); ?>" />
				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Username', 'zm'); ?></span>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<input type="text" name="zm_username" id="zm_username" value="<?php echo zm_isset($data->username, '', true); ?>" <?php echo $id ? 'disabled' : ''; ?> />
				    	<?php if ( $id ) : echo '<input type="hidden" name="zm_cache_username" value="' . zm_sanitize($data->username) . '" />'; endif; ?>
				    </div>
				</div>

				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('First Name', 'zm'); ?></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<?php $firstname = zm_isset($data->first_name, '', true); ?>
				    	<input type="text" name="zm_fname" id="zm_fname" value="<?php echo zm_sanitize($firstname); ?>" />
				    </div>
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Last Name', 'zm'); ?></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<?php $lastname = zm_isset($data->last_name, '', true); ?>
				    	<input type="text" name="zm_lname" id="zm_lname" value="<?php echo zm_sanitize($lastname); ?>" />
				    </div>
				</div>

				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Email', 'zm'); ?></span>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<input class="required email" type="text" name="zm_email" id="zm_email" value="<?php echo zm_isset($data->email, '', true); ?>" />
				    	<input type="hidden" id="zm_cache_email" value="<?php echo zm_isset($data->email, '', true); ?>" />
				    </div>
				</div>
				<?php if ($id):?>
				<fieldset>
				<legend>Change Password <span data-tooltip class="zm-help tip-top" title="Leave this empty if you do not want to change current password"></span></legend>
				<?php endif; ?>
				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Password', 'zm'); ?></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<input <?php echo $id ? '' : 'class="required"'; ?> type="password" name="zm_password" id="zm_password" value="" />
				    </div>
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Re-enter Password', 'zm'); ?></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<input <?php echo $id ? '' : 'class="required"'; ?> type="password" name="zm_repassword" id="zm_repassword" value="" />
				    </div>
				</div>
				<?php if ($id):?>
				</fieldset>
			<?php endif; ?>
				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Notes', 'zm'); ?><span data-tooltip class="zm-help tip-top" title="You can enter custom notes for this member, which can only be seen by you."></span></span>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<textarea name="zm_notes" id="zm_notes"><?php echo stripslashes(zm_isset($data->metadata['notes']));?></textarea>
				    </div>
				</div>
				<input type="hidden" name="zm_submit_form" value="save_member">
				<input type="submit" value="<?php echo $id ? 'Save Changes' : 'Add Member'; ?>" class="radius gpf-button zm-submit zm_submit_form" />
			</form>
		</div>
	</div>
	<?php else: ?>
	<div id="<?php echo ($id) ? 'zm-memberspayment'.$id : ''; ?>">
		<div class="zm-biglabel"><i class="icon-money"></i> "<?php echo zm_isset($data->username, '', true); ?>" Payments/Subscriptions <a class="gpf-button tiny radius" id="zm-add-payment"><i class="icon-plus"></i> add manual payment</a></div>
		<form method="post" class="custom">
			<div class="gpf-row collapse">
                <div class="large-3 gpf-columns">
                    <select name="zm_action">
                        <option value="-1" selected="selected">Bulk Actions</option>
                        <option value="del">Delete</option>
                    </select>
                </div>
                <div class="large-1 gpf-columns">
                	<button style="margin-top:0px;border-left:0;" type="submit" name="" id="doaction" class="gpf-button action postfix">Apply</button>
                </div>
                <div class="large-8 gpf-columns"></div>
            </div>
		<?php
		//get access
   		//get all from payments WHERE user_id == current edited user
   		$metadatas = zm_get_all('payment', $id);
		$product_access = array();
		//OPEN TABLE
		zm_table_open(array('Product', 'Period', 'Status', ''));
		if (zm_isset($metadatas)) {
			foreach ($metadatas as $row){

				if (!in_array($row->product_id, $product_access)) $product_access[] = $row->product_id;

				echo '<tr valign="top" class="zm-row">';
				echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select" type="checkbox" name="zm_payments[]" value="'.$row->ID.'"></th>';
				echo '<td id="zm-product-'.$row->ID.'">'.(zm_isset($row->title) ? $row->title : '<span class="gpf-label alert round">-deleted-</span>').'</td>';

				if ($row->type == 'subscription')
					echo '<td>'.date("M d, Y", $row->begin_date).' - '.date("M d, Y", $row->expired_date).'</td>';
				else
					echo '<td>LIFETIME</td>';

				//echo '<td>'.$row->paysys.'</td>';
				//echo '<td>'.$row->receipt.'</td>';

				//if ($row->type == 'free'){
				//	echo '<td>FREE</td>';
				//	echo '<td><span class="gpf-label success round">COMPLETED</span></td>';
				//	echo '<td></td>';
				//}else{
					//	echo '<td>'.$row->amount.'</td>';
					echo '<td>'.zm_status($row->status).'</td>';
					echo '<td style="text-align:right"><a href="#" class="button zm-edit-payment" id="'.$row->ID.'" title="edit"><i class="icon-pencil"></i></a></td>';
				//}
				echo '</tr>';
			}
		}else{ ?>
		<tr class="alternate" valign="top">
			<td colspan="5" align="center">--No payments--</td>
		</tr>
		<?php }
		zm_table_close();
		//CLOSE TABLE
		?>
			<br>
			<div class="gpf-row collapse">
                <div class="large-3 gpf-columns">
                    <select name="zm_action_1">
                        <option value="-1" selected="selected">Bulk Actions</option>
                        <option value="del">Delete</option>
                    </select>
                </div>
                <div class="large-1 gpf-columns">
                	<button style="margin-top:0px;border-left:0;" type="submit" name="" id="doaction" class="gpf-button action postfix">Apply</button>
                </div>
                <div class="large-8 gpf-columns"></div>
            </div>
		</form>
		<div id="zm-edit-payment-box" style="display: none; padding:5px 10px;">
			<div class="zm-biglabel">Add Payment/Subscription</div>
			<form class="custom" method="post">
				<input type="hidden" name="zm-member-id" value="<?php echo $id; ?>"/>

				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Products / Levels Access', 'zm'); ?></span>
				    </div>
				    <div class="large-6 gpf-columns" id="zm-current-edit-box" style="display:none">
				    	<input type="text" id="zm-current-edit" value="" disabled="disabled"/>
				    </div>
				    <div class="large-6 gpf-columns" id="zm-list-product-box">
						<?php
						$products = zm_get_all('product', '', 'payment');
					 	?>
				      	<select id="zm-list-product" name="zm-list-product">
			               	<?php
			               	$firstlist = '';

			               	if ($products){
			               		$access = array();
			               		//die(var_dump($access));
				               	foreach ($products as $product){
				               		$include = true;

									//if ($product->type !== 'subscription'){
									//	if (in_array($product->ID, $product_access)){
									//		$include = false;
									//	}
									//}

									//if ($include){
				               			echo '<option value="'.$product->ID.'" >'.$product->title.'</option>';
									//}
				               	}
			               	}
			               ?>
			        	</select>
			   		</div>
			   		<div class="large-2 gpf-columns">
				      <span class="prefix"><?php _e('Status', 'zm'); ?></span>
				    </div>
				    <div class="large-2 gpf-columns">
				      	<select id="zm-status-product" name="zm-status-product">
				      		<option value="0">Pending</option>
				      		<option value="1">Complete</option>
				      		<option value="2">Canceled</option>
				      		<option value="3">Expired</option>
				      		<option value="4">Refunded</option>
				      	</select>
				    </div>
		   		</div>
		   		<div class="gpf-row collapse" id="zm-is-subscription-box">
		   			<div class="large-2 gpf-columns">
				     	<label for="zm-is-subscription"><input type="checkbox" name="zm-is-subscription" id="zm-is-subscription"/> is subscription?</label>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<input type="text" class="zm-ssss" name="zm-ssss" value="ssss" style="visibility: hidden">
				    </div>
		   		</div>
		   		<div class="gpf-row collapse" id="zm-subscription" style="display:none;">
		   			<div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Start of period', 'zm'); ?></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<input type="text" class="zm-begin" name="zm-begin" value="<?php echo date("m/d/Y"); ?>"/>
				    </div>
				    <div class="large-2 gpf-columns">
				      <span class="prefix"><?php _e('End of period', 'zm'); ?><span data-tooltip class="zm-help tip-top" title="If you want to set to lifetime subscription, just set the date to Jan 1 2038"></span></span>
				    </div>
				    <div class="large-4 gpf-columns">
				    	<input type="text" class="zm-expired" name="zm-expired" value="<?php echo date("m/d/Y"); ?>"/>
				    </div>
				    <input type="hidden" name="zm-rebill" value=""/>
		   		</div>
		   		<div class="gpf-row collapse" id="zm-not-free" style="display: none">
					<div class="large-3 gpf-columns" style="display: none">
				      <span class="prefix radius"><?php _e('Amount', 'zm'); ?></span>
				    </div>
					<div class="large-3 gpf-columns" style="display: none">
						<input type="text" id="zm-amount" name="zm-amount" value="" placeholder="0.00"/>
					</div>
					<div class="large-3 gpf-columns" style="display: none">
				      <span class="prefix"><?php _e('Currency', 'zm'); ?></span>
				    </div>
					<div class="large-3 gpf-columns" style="display: none">
						<select id="zm-currency" name="zm-currency">
							<?php
							foreach ( zm_currencies() as $k => $v ) {
								echo "<option value='{$k}'>{$v}</option>";
							}
							?>
						</select>
					</div>
					<div class="large-3 gpf-columns" style="display: none">
				      <span class="prefix radius"><?php _e('Payment System', 'zm'); ?></span>
				    </div>
					<div class="large-3 gpf-columns" style="display: none">
						<select id="zm-payment" name="zm-payment">
							<option value="manual">Manual Payment</option>
							<option value="zaxaa">Zaxaa</option>
						</select>
					</div>
					<div class="large-3 gpf-columns" style="display: none">
				      <span class="prefix"><?php _e('Receipt', 'zm'); ?></span>
				    </div>
					<div class="large-3 gpf-columns" style="display: none">
						<input type="text" id="zm-receipt" name="zm-receipt" value="manual"/>
					</div>

				</div>
				<br>
				<input type="hidden" name="zm-edit-id" value="0" id="zm-edit-id" />
				<input type="hidden" name="zm_submit_form" value="save_payment">
				<input type="submit" id="zm-submit-payment" value="Add" class="radius gpf-button zm_submit_form" name="zm-add-payment"/>
	   		</form>
		</div>
   	</div>
	<?php
	endif;
}
