<?php
function zm_access_meta_box( $post ) {
	$products = zm_get_all('product');
	$protects = zm_get_all('protect', $post->ID, 'meta');
	$protect_data = array();
	foreach ($protects as $protect){
		$protect_data[$protect->product_id] = array(
			'enable' => true,
			'start' => array('mode' => $protect->d_start_mode,
							'value' => $protect->d_start),
			'end' => array('mode' => $protect->d_end_mode,
							'value' => $protect->d_end,
							'used' => $protect->d_end_used),
			'expired' => $protect->is_expired
		);
	}
	
	$table_header = array('Title',
					  'Drip Start <span data-tooltip class="zm-help tip-top" title="If you want your content/file to be immediately available for members, enter &quot;0&quot;"></span>',
					  'Drip End');
	?>
	<div class="zm_access_meta_box">
		<?php zm_table_open($table_header, 'meta');
		if ($products){
			foreach ( $products as $product ) {
				$row = array(
					'enable' => false,
					'start' => array('mode' => 'D',
									'value' => 0),
					'end' => array('mode' => 'D',
								   'value' => 30,
								   'used' => 0));
				
				if (isset($protect_data[$product->ID])){
					$row = $protect_data[$product->ID];
				}
	
				$smode = zm_drip_options('start', $product->ID, $row['start']['mode']);
				
				$is_e_used = ($row['end']['used']) ? 'checked' : '';
				
				$is_expired = '';
				if ($is_e_used){
					if ($row['expired'] == 1){
						$is_expired = '<em class="zm_exp">(expired)</em>';
					}
				}
					
				$emode = zm_drip_options('end', $product->ID, $row['end']['mode'], $is_e_used);
				
				echo '<tr valign="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
				echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectpost" type="checkbox" name="zm-ac-post[]" value="'.$product->ID.'" '.($row['enable'] ? 'checked' : '').'></th>';
				echo '<td id="title-'.$product->ID.'">'.$product->title.' '.$is_expired.'</td>';
				
				echo '<td>';
				
				echo '<div class="gpf-row  zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
					<div class="large-12 gpf-columns">
					<i class="icon-user"></i> Public Access
					</div>
					</div>';
				
				echo '<div class="gpf-row  zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
				    	<div class="zm-start-columns1">';
				$is_exact = ($row['start']['mode'] == 'X') ? true : false;
				echo '<input type="text" id="numb'.$product->ID.'-s" class="zm-start-value" name="zm-ac-data['.$product->ID.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').'/>';
				echo '<input type="text" id="date'.$product->ID.'-s" class="zm-start-dp-value" name="zm-ac-data['.$product->ID.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').'/>';
				echo '</div>';
				
				echo '<div class="zm-start-columns2"><div class="selectParent">'.$smode.'</div></div></div></td>';
				
				echo '<td>';
				
				$is_exact = ($row['end']['mode'] == 'X') ? true : false;
				echo '<div class="gpf-row  zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
					<div class="large-12 gpf-columns" >
					<i class="icon-user"></i> Public Access
					</div>
					</div>';
				
				echo '<div class="gpf-row  zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
				    	<div class="zm-start-columnsCheck">
				      		<span class="prefix radius">';
				echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$product->ID.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
				echo '</span>
						</div>';
				
				echo '<div class="zm-start-columns1">';
				echo '<input type="text" id="numb'.$product->ID.'-e" class="zm-end-value" name="zm-ac-data['.$product->ID.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
				echo '<input type="text" id="date'.$product->ID.'-e" class="zm-end-dp-value" name="zm-ac-data['.$product->ID.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';
				
				echo '</div>';
				
				echo '<div class="zm-start-columns2"><div class="selectParent">'.$emode.'</div></div></div></td>';
				echo '</tr>';
			}
		}else{
			echo '<tr class="alternate" valign="top"><td colspan="4" align="center">--No Posts--</td></tr>';
		}
		zm_table_close();
		?>
	</div>
	<?php
}

function zm_create_meta_box()
{
  	if ( function_exists( 'add_meta_box' ) ) {
  		add_meta_box('zm_access_meta_box', '<i class="icon-lock"></i> Zaxaa Member - Product Access', 'zm_access_meta_box', 'page', 'normal', 'high');
  		add_meta_box('zm_access_meta_box', '<i class="icon-lock"></i> Zaxaa Member - Product Access', 'zm_access_meta_box', 'post', 'normal', 'high');
  	}
}

function zm_save_meta_box(){
	zm_add('protect', $_POST, 'meta');
}

add_action( 'admin_menu', 'zm_create_meta_box' );
add_action( 'post_updated', 'zm_save_meta_box' );