<?php
$process = zm_isset($_GET['process']);

switch ( $process ) {
	case 'add':
	case 'edit':
		zm_add_product_form();
		break;
	
	case 'delete':
		zm_delete('product', $_GET['id']);
		break;
		
	case 'clone':
		zm_clone('product', $_GET['id']);
		break;
	default:
		zm_manage_products();
}

function zm_manage_products() {
	$site_name = get_bloginfo('name');
	$general = get_option('zm_general_option');
	
	$start = isset($_GET['p']) ? $_GET['p'] : 1;
	$limit = 10;
	
	$params = array('zm_cre_time' => isset($_GET['time']) ? $_GET['time'] : '7daysago');
	$params['zm_from'] = isset($_GET['f']) ? $_GET['f'] : '';
	$params['zm_to'] = isset($_GET['t']) ? $_GET['t'] : '';
	$params['zm_product'] = isset($_GET['product']) ? $_GET['product'] : 'all';
	$params['zm_ptype'] = isset($_GET['ptype']) ? $_GET['ptype'] : 'all';
	$params['zm_op'] = isset($_GET['op']) ? $_GET['op'] : 'all';
	$params['zm_od'] = isset($_GET['od']) ? $_GET['od'] : 'desc';
	$params['start'] = $start;
	$params['limit'] = $limit;
	$data = zm_get_all('product', $params);
	$data_count = zm_get_count('product', $params);
	
	$conditions = '&time='.$params['zm_cre_time'];
	
	//$tt = strtotime('2014-09-01 07:41:39 UTC', zm_time());
	//var_dump(date('Y M d h:i:s', $tt));
	
	if ($params['zm_cre_time'] == 'exactdate'){
		$conditions .= '&f='.$params['zm_from'];
		$conditions .= '&t='.$params['zm_to'];
	}
	
	if ($product = zm_isset($params['zm_product'])){
		$conditions .= '&product='.$product;
	}
	
	if ($type = zm_isset($params['zm_ptype'])){
		$conditions .= '&ptype='.$type;
	}
	
	if ($op = zm_isset($params['zm_op'])){
		$conditions .= '&op='.$op;
	}
	
	if ($od = zm_isset($params['zm_od'])){
		$conditions .= '&od='.$od;
	}
	
	$paginations = '';
	if (ceil($data_count/$limit) > 1){
		$paginations = zm_set_pagination(admin_url('admin.php?page=zm-admin&mode=products'.$conditions), $data_count, $start, $limit, 'Zaxaa Member Products &lsaquo; '.$site_name, 'sem-products');
	}
	
	$picon = $params['zm_op'] == 'desc' ? '<i class="icon-sort-by-alphabet-alt"></i> ' : '<i class="icon-sort-by-alphabet"></i>';
	$dicon = $params['zm_od'] == 'desc' ? '<i class="icon-sort-by-order-alt"></i> ' : '<i class="icon-sort-by-order"></i>';
	$psort = '<i class="zm-sortable zm-p-name-sortable '.$params['zm_op'].'">'.$picon.' Product Name</i>';
	$dsort = '<i class="zm-sortable zm-p-date-sortable '.$params['zm_od'].'">'.$dicon.' Date Created</i>';
	
	do_action('zm_message');
	?>

<div id="zm-products"><!-- ajax load wrapper -->
	<form class="custom" method="post">
	<div class="zm-biglabel"><i class="icon-briefcase"></i> Manage Products / Membership Levels&nbsp;&nbsp;&nbsp;<?php if (!zm_isset($data) ) echo '<span id="zm-start-here"></span>'; ?><span style="margin:0 !important;" class="gpf-button radius tiny zm-add-new" data-url="<?php echo admin_url('admin.php?page=zm-admin&mode=products&process=add');?>" data-mode="productsadd" data-title="Zaxaa Member Products &lsaquo; <?php echo $site_name; ?>"><i class="icon-plus"></i> add new</span>&nbsp;&nbsp;<?php echo '<span style="margin:0 !important;" data-type="product" class="gpf-button radius disabled tiny alert zm-delete-all"><i class="icon-trash"></i> delete ALL products</span>'; ?></div>
	<div class="gpf-row collapse">
		<div class="large-2 gpf-columns">
		  <span class="prefix radius"><?php _e('Product', 'zm'); ?></span>
		</div>
		<div class="large-10 gpf-columns">
			<input type="text" name="zm-p-product" id="zm-p-product" value="<?php echo $params['zm_product'] == 'all' ? '' : $params['zm_product']; ?>" />
		</div>
		<div class="large-2 gpf-columns" style="display:none">
		  <span class="prefix radius"><?php _e('Payment Type', 'zm'); ?></span>
		</div>
		<div class="large-4 gpf-columns" style="display:none">
			<select name="zm-p-type" id="zm-p-type">
				<option value="all" <?php echo $params['zm_ptype'] == 'all' ? 'selected="selected"' : ''; ?>>All</option>
				<option value="onetime" <?php echo $params['zm_ptype'] == 'onetime' ? 'selected="selected"' : ''; ?>>One-time Payment</option>
				<option value="subscription" <?php echo $params['zm_ptype'] == 'subscription' ? 'selected="selected"' : ''; ?>>Recurring Billing</option>
			</select>
		</div>
	</div>
	<div class="gpf-row collapse">
		<div class="large-2 gpf-columns">
		  <span class="prefix radius"><?php _e('Date Created', 'zm'); ?></span>
		</div>
		<div class="large-<?php echo $params['zm_cre_time'] == 'exactdate' ? '3' : '9'; ?> gpf-columns" id="zm_cre_time_parent">
			<select name="zm_p_txn_time" id="zm-p-txn-time">
				<option value="all" <?php echo $params['zm_cre_time'] == 'all' ? 'selected="selected"' : ''; ?>>All</option>
				<option value="today" <?php echo $params['zm_cre_time'] == 'today' ? 'selected="selected"' : ''; ?>>Today</option>
				<option value="yesterday" <?php echo $params['zm_cre_time'] == 'yesterday' ? 'selected="selected"' : ''; ?>>Yesterday</option>
				<option value="7daysago" <?php echo $params['zm_cre_time'] == '7daysago' ? 'selected="selected"' : ''; ?>>Last 7 Days</option>
				<option value="30daysago" <?php echo $params['zm_cre_time'] == '30daysago' ? 'selected="selected"' : ''; ?>>Last 30 Days</option>
				<option value="exactdate" <?php echo $params['zm_cre_time'] == 'exactdate' ? 'selected="selected"' : ''; ?>>Use Exact Date</option>
			</select>
		</div>
		<div class="large-3 gpf-columns zm-p-exact-search" <?php echo $params['zm_cre_time'] == 'exactdate' ? '' : 'style="display:none;"'; ?>>
			<input type="text" name="zm_from" id="zm-p-start-exact-search" value="<?php echo isset($_GET['f']) ? $_GET['f'] : date("m/d/Y"); ?>" />
		</div>
		<div class="large-3 gpf-columns zm-p-exact-search" <?php echo $params['zm_cre_time'] == 'exactdate' ? '' : 'style="display:none;"'; ?>>
			<input type="text" name="zm_to" id="zm-p-until-exact-search" value="<?php echo isset($_GET['t']) ? $_GET['t'] : date("m/d/Y", strtotime("tomorrow")); ?>" />
		</div>
		<div class="large-1 gpf-columns">
		  <span data-title="Zaxaa Member Products &lsaquo; <?php echo $site_name; ?>" data-url="<?php echo admin_url('admin.php?page=zm-admin&mode=products'); ?>" id="zm-search-product"><a class="gpf-button radius postfix"><i class="icon-search"></i> Search</a></span>
		</div>
	</div>
	<div id="sem-products">
		<div id="zm-<?php echo isset($_GET['p']) ? zm_generate_mode(admin_url('admin.php?page=zm-admin&mode=products'.$conditions)).'p'.$_GET['p'] : 'default'; ?>"><!-- ajax load wrapper -->
			<?php
			//OPEN TABLE
			//zm_table_open(array($psort, 'Payment Type', 'Price', 'Payment Processor', $dsort, ''));
			zm_table_open(array($psort, $dsort, ''));
			
			if ( zm_isset($data) ) {
				foreach ( $data as $row ){
					$payment_proc = '';
					
					if ($row->type == 'onetime'){
						$price = $row->ot_price;
					}else if ($row->type == 'subscription'){
						$price = $row->rc_price.' '.zm_format_recurring($row->subs_num, $row->subs_mode);
					}
					
					$type = zm_payment_type_is($row->type);
					
					/*
					$payment_proc_temp = maybe_unserialize($row->metadata);
					if ( $payment_proc_temp ) {
						$payment_proc_temp = array_reverse($payment_proc_temp);
						foreach ( $payment_proc_temp as $key => $value ) {
							if ($value['enable'] == 'on'){
								if ($payment_proc) $payment_proc .= ' '.$key;
								else $payment_proc .= $key;
							}
						}
					} else {
						$payment_proc = '- None Selected -';
					}
					*/
					
					echo '<tr class="zm-row">';
					echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select" type="checkbox" name="zm_product[]" value="'.$row->ID.'"></th>';
					echo '<td><a class="zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=products&process=edit&id='.$row->ID.'" title="Edit &quot;'.$row->title.'&quot;" data-mode="productsedit'.$row->ID.'" data-title="'.$row->title.' &lsaquo; '.$site_name.'">'.$row->title.'</a></td>';

					//echo '<td>'.$type.'</td>';
					//echo '<td>'.$price.'</td>';
					//echo '<td>'.$payment_proc.'</td>';
					
					echo '<td>'.date('M d, Y, H:i A', $row->date).'</td>';
					echo '<td style="text-align:right;"><div class="button-group">';
					echo '<a class="button zm-edit-form" href="'.admin_url('admin.php').'?page=zm-admin&mode=products&process=edit&id='.$row->ID.'" title="edit" data-mode="productsedit'.$row->ID.'" data-title="'.$row->title.' &lsaquo; '.$site_name.'"><i class="icon-pencil"></i></a>';
					echo '<a class="button zm-clone-product" href="#" id="'.$row->ID.'" title="duplicate"><i class="icon-copy"></i></a>';
					
					echo '<a class="button zm-delete-item" href="#" id="product|'.$row->ID.'" title="delete"><i class="icon-trash"></i></a>';
					echo '</div></td>';
					
					echo '</tr>';
				}
			}else{ ?>
			<tr class="alternate" valign="top">
				<td colspan="4" align="center">--No products--</td>
			</tr>
			<?php }
			zm_table_close();
			//CLOSE TABLE
			?>
			<br>
			<div class="gpf-row collapse">
				<div class="large-3 gpf-columns">
					<select name="zm_action_1" >
						<option value="-1" selected="selected">Bulk Actions</option>
						<option value="del">Delete</option>
					</select>
				</div>
				<div class="large-1 gpf-columns">
				<input type="submit" name="" id="doaction" class="gpf-button action postfix" value="Apply">
				</div>
				<div class="large-6 gpf-columns">
					<div style="text-align: right;">
						<?php echo $paginations; ?>
					</div>
				</div>
			</div>
		</div>
	</div>
	</form>
</div><!-- ajax load wrapper -->
<?php
}

function zm_add_product_form(){
	$site_name = get_bloginfo('name');
	$id = zm_isset($_GET['id'], 0 , true);
	$step = zm_isset($_GET['step'], 0 , true);
	
	$data = (object) array();
	$pr = zm_get_product($id);
	if ( $id ) {
		// GET DATA
		$data = zm_get_row('product', $id);
		$data->metadata = maybe_unserialize($data->metadata);
		$data->autoresponder = maybe_unserialize($data->autoresponder);
		$data->gotowebinar = maybe_unserialize($data->gotowebinar);
		//die(var_dump($data));
	}
	
	$general = get_option('zm_general_option');
	$token_gtw = false;
	
	if (zm_isset($general['gtw_enable']) == 'on') $token_gtw = get_option('zm_gtw_token');
	$token_gtw = get_option('zm_gtw_token');
	$posts = get_posts( array('numberposts' => 9999, 'post_status' => 'publish') );
	$pages = get_pages( array('post_status' => 'publish') );
	
	do_action('zm_message');
	?>
	<div id="<?php echo ($id) ? 'zm-productsedit'.$id : 'zm-productsadd'; ?>">
		<div class="zm-biglabel"><?php echo ($id) ? '<i class="icon-pencil"></i> Edit' : '<i class="icon-plus"></i> Add'; ?> Product / Membership Level</div>
		<div id="zm-wrapper" style="padding-bottom:20px">
			<a href="http://www.zaxaablog.com/tutorial/zaxaa-member/creating-a-productmembership-level/" target="_blank"><span class="gpf-label round">Click here</span></a> to learn how to integrate with Zaxaa.
			<hr>
			<form class="custom zm-required" method="post">
			<input type="hidden" name="zm-nonce" value="<?php echo $id ? $id : md5('add_product'); ?>" />
				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Product / Level Name', 'zm'); ?></span>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<input class="required" type="text" name="zm-product-name" id="zm-product-name" value="<?php echo zm_isset($data->title, '', true); ?>" />
				    </div>
				</div>
			
				<input name="zm-payment-type-main" id="zm-payment-type-paid" type="hidden" value="paid" />
				
				<div class="gpf-row collapse">
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('Download Page', 'zm'); ?></span>
				    </div>
				    <div class="large-6 gpf-columns">
				    	<select class="required" name="zm-download-page" id="zm-download-page">
				    		<?php $download_id = zm_isset($data->download_id); ?>
				    		<option value="">[ -- Select a post or page -- ]</option>
				    		<option value="-1" <?php echo ($download_id == '-1') ? 'selected="selected"' : '' ?>>[ -- External URL -- ]</option>
							<option DISABLED>Posts</option>
							<?php
							if ( $posts ) {
								foreach ( $posts as $post ) {
									$selected = ( zm_isset($download_id, '', true) == $post->ID ) ? ' selected="selected"' : '';
									echo "<option value='{$post->ID}'{$selected}>$post->post_title</option>";
								}
							}
							?>
							<option DISABLED>Pages</option>
							<?php
							if ( $pages ) {
								foreach ( $pages as $page ) {
									$selected = ( zm_isset($download_id, '', true) == $page->ID ) ? ' selected="selected"' : '';
									echo "<option value='{$page->ID}'{$selected}>$page->post_title</option>";
								}
							}
							?>
							
			      		</select>
				    </div>
				    <div class="large-1 gpf-columns"><span class="prefix">OR</span></div>
				    <div class="large-2 gpf-columns"><span for="zm-download-page" class="gpf-button prefix zm-create-page"><i class="icon-plus"></i> Create one for me</span></div>
				    <div class="large-1 gpf-columns"><span for="zm-download-page" data-url="<?php echo admin_url('post.php?post='); ?>" class="gpf-button radius postfix zm-edit-page"><i class="icon-pencil"></i> Edit</span></div>
				</div>
				
				<div class="gpf-row collapse" id="zm-external-url" <?php echo ($download_id == '-1') ? '' : 'style="display:none;"' ?>>
				    <div class="large-2 gpf-columns">
				      <span class="prefix radius"><?php _e('External URL', 'zm'); ?></span>
				    </div>
				    <div class="large-10 gpf-columns">
				    	<input <?php echo ($download_id == '-1') ? 'class="required url"' : '' ?> type="text" name="zm-thanks-url" id="zm-thanks-url" value="<?php echo zm_isset($data->thanks_url, '', true); ?>" placeholder="http://" />
				    </div>
				</div>
				<fieldset class="zm-payment-processor-box" style="display:none">
		    		<legend><?php _e('Payment Type', 'zm'); ?></legend>
		    		<div class="gpf-row collapse">
					    <div class="large-2 gpf-columns">
					      <span class="prefix radius"><?php _e('Payment Type', 'zm'); ?></span>
					    </div>
					    <div class="large-10 gpf-columns" id="zm-price-col">
					    	<select name="zm-payment-type" class="zm-payment-type">
					    		<option value="onetime" <?php echo zm_isset($data->type, 'onetime', true) == 'onetime' ? 'selected="selected"' : ''; ?>>One-time Payment</option>
					    		<option value="subscription" <?php echo zm_isset($data->type, 'onetime', true) == 'subscription' ? 'selected="selected"' : ''; ?>>Recurring Billing</option>
					    	</select>
					    </div>
				    </div>
			    	<div class="gpf-row collapse zm-payment-type-o" <?php echo zm_isset($data->type, 'onetime', true) == 'onetime' ? '' : 'style="display:none"'; ?>>
					    <div class="large-2 gpf-columns">
					      <span class="prefix radius"><?php _e('Price', 'zm'); ?></span>
					    </div>
					    <div class="large-10 gpf-columns" id="zm-price-col">
					      <input type="text" class="required" name="zm-price-o" id="zm-price-o" value="<?php echo stripslashes(zm_isset($data->ot_price)); ?>" placeholder="0.00" />
					    </div>
				    </div>
			    	<div class="gpf-row collapse zm-payment-type-r" <?php echo zm_isset($data->type, 'onetime', true) == 'subscription' ? '' : 'style="display:none"'; ?>>
						<div class="gpf-row collapse">
						    <div class="large-2 gpf-columns">
						      <span class="prefix radius"><?php _e('Price', 'zm'); ?></span>
						    </div>
						    <div class="large-1 gpf-columns" id="zm-price-col">
						      <input type="text" class="required" name="zm-price-r" id="zm-price-r" value="<?php echo stripslashes(zm_isset($data->rc_price)); ?>" placeholder="0.00" />
						    </div>
						    <div class="large-2 gpf-columns ">
						      <span class="prefix"><?php _e('Every', 'zm'); ?></span>
						    </div>
						    <div class="large-1 gpf-columns">
						      <input type="text" class="required" name="zm-subscription-duration" id="zm-subscription-duration" value="<?php echo zm_isset($data->subs_num, 1, true); ?>" />
						    </div>
						    <div class="large-2 gpf-columns">
						      	<select name="zm-subscription-duration-for" id="zm-subscription-duration-for">
									<option value="D" <?php echo zm_isset($data->subs_mode, 'M', true) == 'D' ? 'selected="selected"' : ''; ?>>Day(s)</option>
									<option value="W" <?php echo zm_isset($data->subs_mode, 'M', true) == 'W' ? 'selected="selected"' : ''; ?>>Week(s)</option>
									<option value="M" <?php echo zm_isset($data->subs_mode, 'M', true) == 'M' ? 'selected="selected"' : ''; ?>>Month(s)</option>
									<option value="Y" <?php echo zm_isset($data->subs_mode, 'M', true) == 'Y' ? 'selected="selected"' : ''; ?>>Year(s)</option>
					      		</select>
						    </div>
						    <div class="large-2 gpf-columns">
						     <span class="prefix"><?php _e('Recurrence', 'zm'); ?><span data-tooltip class="zm-help tip-top" title="The number of times the payment will be made. Leave empty for unlimited recurrence."></span></span>
						    </div>
						    <div class="large-1 gpf-columns">
						    	<input type="text" name="zm-rebill-times" id="zm-rebill-times" value="<?php echo zm_isset($data->rebill_times) ? $data->rebill_times : ''; ?>" />
						    </div>
						    <div class="large-1 gpf-columns">
						      <span class="postfix radius"><?php _e('times', 'zm'); ?></span>
						    </div>
						</div>
						<table class="zm-table-switch">
							<tr>
								<td style="width: 90px">
								<div class="gpf-switch" id="zm-is-trial">
								  <input id="zm-is-trial-off" name="zm-is-trial" value="off" type="radio" <?php echo (zm_isset($data->is_trial, false, true) ? '' : 'checked') ?>>
								  <label for="zm-is-trial-off" class="zm-switch">No</label>
								  <input id="zm-is-trial-on" name="zm-is-trial" value="on" type="radio" <?php echo (zm_isset($data->is_trial, false, true) ? 'checked' : '') ?>>
								  <label for="zm-is-trial-on" class="zm-switch">Yes</label>
								  <span></span>
								</div>
								</td>
								<td>Use Trial</td>
							</tr>
						</table>
						<br>
						<div class="gpf-row collapse" id="zm-is-trial_field" <?php echo (zm_isset($data->is_trial, false, true) ? '' : 'style="display:none;"') ?>>
						    <div class="large-2 gpf-columns">
						      <span class="prefix radius"><?php _e('Trial Price', 'zm'); ?></span>
						    </div>
						    <div class="large-2 gpf-columns">
						      <input type="text" class="required" name="zm-trial-price" id="zm-trial-price" value="<?php echo zm_isset($data->trial_price); ?>" placeholder="0.00" />
						    </div>
						    <div class="large-2 gpf-columns">
						      <span class="prefix"><?php _e('Trial Duration', 'zm'); ?></span>
						    </div>
						    <div class="large-2 gpf-columns">
						      <input type="text" class="required" name="zm-trial-duration" id="zm-trial-duration" value="<?php echo zm_isset($data->trial_num, 1, true); ?>" />
						    </div>
						    <div class="large-4 gpf-columns">
						      	<select name="zm-trial-duration-for" id="zm-trial-duration-for">
									<option value="D" <?php echo zm_isset($data->trial_mode, 'M', true) == 'D' ? 'selected="selected"' : ''; ?>>Day(s)</option>
									<option value="W" <?php echo zm_isset($data->trial_mode, 'M', true) == 'W' ? 'selected="selected"' : ''; ?>>Week(s)</option>
									<option value="M" <?php echo zm_isset($data->trial_mode, 'M', true) == 'M' ? 'selected="selected"' : ''; ?>>Month(s)</option>
									<option value="Y" <?php echo zm_isset($data->trial_mode, 'M', true) == 'Y' ? 'selected="selected"' : ''; ?>>Year(s)</option>
					      		</select>
						    </div>
			  			</div>
			  		</div>
			  	</fieldset>
				<table class="zm-table-switch">
					<?php do_action('zm_get_payment_module', zm_isset($data->metadata, false), $id); ?>
				</table>
				<div class="post-meta-box">
					<input type="hidden" name="zm_submit_form" value="save_product" />
					<input type="submit" value="Save Product" class="zm_submit_form radius gpf-button" />
				</div>
			</form>
		</div>
	</div>
<?php
}
