<?php
$site_name = get_bloginfo('name');
$products = zm_get_all('product');
$step = zm_isset($_GET['step'], 0 , true);

$id = zm_isset($_GET['id']) ? $_GET['id'] : 0;
$p_type = false;

do_action('zm_message');

if ($step) echo '<div class="alert-box success" style="margin:10px 0"><p>Finally, specify the content protection for this product / level.</p></div>';

$post_types = get_post_types();

unset($post_types['post']);
unset($post_types['page']);
unset($post_types['attachment']);
unset($post_types['revision']);
unset($post_types['nav_menu_item']);

?>
<div id="zm-protect"><!-- ajax load wrapper -->
<form class="custom">
	<div class="zm-biglabel"><i class="icon-lock"></i> Product Access</div>
	<?php if ($products){ ?>
	<div class="gpf-row collapse">
	    <div class="large-2 gpf-columns">
	      <span class="prefix radius">Product / Level</span>
	    </div>
    	<div class="large-10 gpf-columns">
    	<select data-url="<?php echo admin_url('admin.php?page=zm-admin&mode=protect')?>" data-mode="protect" data-title="ZM Access &lsaquo; <?php echo $site_name; ?>" class="custom" name="zm-ac-product" id="zm-ac-product">
    		<option value="">[--Select Product--]</option>
    		<?php
    		foreach ($products as $product){
    			$selected = ($product->ID == $id) ? 'selected="selected"' : '';
				$p_type = $p_type ? $p_type : (($product->ID == $id) ? $product->type : false);
    			echo '<option value="'.$product->ID.'" '.$selected.'>'.$product->title.'</option>';
    		}
    		?>
    	</select>
    	</div>
    	<div class="large-12 gpf-columns"><p style="font-size: 14px">To prevent your content and files from unauthorized access, simply select the post/page/file you want to protect. You can also drip feed your content and files from this page.<br><a href="http://www.zaxaablog.com/tutorial/zaxaa-member/content-file-protection/protecting-content-files-drip-feeding/" target="_blank"><span class="gpf-label round">Click here</span></a> if you're still unsure and want to learn more.</p></div>
	</div>
	<?php }else{
		echo '<div class="large-12 gpf-columns alert-box alert" style="margin:10px 0px"><p>Can\'t find any product. Please create at least one product <a href="'.admin_url('admin.php?page=zm-admin&mode=products&process=add').'" target="_blank">here</a></p></div>';
	}?>
</form>
    <div id="sem-access">
<?php if ($id) :

$posts = get_posts( array('numberposts' => 9999, 'post_status' => 'publish') );
$pages = get_pages( array('post_status' => 'publish') );
$args=array(
  'orderby' => 'name',
  'order' => 'ASC'
);
$categories=get_categories($args);
$protects = zm_get_all('protect', $id);

$protect_data = array();
foreach ($protects as $protect){
	if ($protect->post_id > 0){
		$protect_data[$protect->post_id] = array(
			'enable' => true,
			'start' => array('mode' => $protect->d_start_mode,
							'value' => $protect->d_start),
			'end' => array('mode' => $protect->d_end_mode,
							'value' => $protect->d_end,
							'used' => $protect->d_end_used),
			'expired' => $protect->is_expired
		);
	}else{
		$protect_data[$protect->filename] = array(
			'enable' => true,
			'start' => array('mode' => $protect->d_start_mode,
							'value' => $protect->d_start),
			'end' => array('mode' => $protect->d_end_mode,
							'value' => $protect->d_end,
							'used' => $protect->d_end_used),
			'expired' => $protect->is_expired
		);
	}
}

$table_header = array('Title',
					  'Drip Start <span data-tooltip class="zm-help tip-top" title="If you want your content/file to be immediately available for members, enter &quot;0&quot;"></span>',
					  'Drip End');
//die(var_dump($protect_data));
?>

<div id="zm-<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : 'default'; ?>">
	<form class="zm-required" method="post">
		<input type="hidden" name="zm-access-product-id" value="<?php echo $id; ?>">
		<input type="hidden" name="zm-step" value="<?php echo isset($_GET['step']) ? 1 : 0; ?>">
		<input type="hidden" name="zm-ptype" value="<?php echo isset($_GET['step']) ? $p_type : 0; ?>">
		<div id="zm-tabs-container">
			<ul class="zm-tabs-menu-nestedception">
				<li id="posts<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>" class="zm-tabs-active"><?php _e('Posts', 'zm'); ?></li>
				<li id="pages<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>"><?php _e('Pages', 'zm'); ?></li>
				<li id="categories<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>"><?php _e('Categories', 'zm'); ?></li>
				<li id="files<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>"><?php _e('Files', 'zm'); ?></li>
				<li id="s3files<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>"><?php _e('Amazon S3 Files', 'zm'); ?></li>

				<?php
				foreach ($post_types as $k => $v){
				    echo '<li id="'.$k.(isset($_GET['id']) ? 'protect'.$_GET['id'] : '').'">'.ucwords(str_replace(array('-', '_'), ' ', $v)).'</li>';
				}
				?>
			</ul>
			<span class="zm-tabs-clear"></span>
			<div class="zm-tabs-content-nestedception posts<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>">
			<?php
			//OPEN TABLE
			zm_table_open($table_header, 'post');
			if ($posts){
				foreach ( $posts as $post ) {
					$row = array(
						'enable' => false,
						'start' => array('mode' => 'D',
										'value' => 0),
						'end' => array('mode' => 'D',
									   'value' => 30,
									   'used' => 0));

					if (isset($protect_data[$post->ID])){
						$row = $protect_data[$post->ID];
					}

					$smode = zm_drip_options('start', $post->ID, $row['start']['mode'], $row['enable']);

					$is_e_used = ($row['end']['used']) ? 'checked' : '';

					$is_expired = '';
					if ($is_e_used){
						if ($row['expired'] == 1){
							$is_expired = '<em class="zm_exp">(expired)</em>';
						}
					}

					$emode = zm_drip_options('end', $post->ID, $row['end']['mode'], $is_e_used);

					echo '<tr valign="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
					echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectpost" type="checkbox" name="zm-ac-post[]" value="'.$post->ID.'" '.($row['enable'] ? 'checked' : '').'></th>';
					echo '<td id="title-'.$post->ID.'">'.$post->post_title.' '.$is_expired.'</td>';

					echo '<td>';

					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns">
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-7 gpf-columns">';
					$is_exact = ($row['start']['mode'] == 'X') ? true : false;
					echo '<input type="text" id="numb'.$post->ID.'-s" class="zm-start-value required digits" name="zm-ac-data['.$post->ID.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$post->ID.'-s" class="zm-start-dp-value" name="zm-ac-data['.$post->ID.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';

					echo '<td>';

					$is_exact = ($row['end']['mode'] == 'X') ? true : false;
					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns" >
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-3 gpf-columns">
					      		<span class="prefix radius">';
					echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$post->ID.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
					echo '</span>
							</div>';

					echo '<div class="large-4 gpf-columns">';
					echo '<input type="text" id="numb'.$post->ID.'-e" class="zm-end-value required digits" name="zm-ac-data['.$post->ID.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$post->ID.'-e" class="zm-end-dp-value" name="zm-ac-data['.$post->ID.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';

					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
					echo '</tr>';
				}
			}else{
				echo '<tr class="alternate" valign="top"><td colspan="4" align="center">--No Posts--</td></tr>';
			}
			zm_table_close();
			//CLOSE TABLE
			?>
			</div>
			<div class="zm-tabs-content-nestedception pages<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>" style="display:none;">
			<?php
			$limit = 20;
			$i = 1;
			$class = 1;

			//OPEN TABLE
			zm_table_open($table_header, 'page');
			if ($pages){
				foreach ( $pages as $post ) {
					$row = array(
						'enable' => false,
						'start' => array('mode' => 'D',
										'value' => 0),
						'end' => array('mode' => 'D',
									   'value' => 30,
									   'used' => 0));

					if (isset($protect_data[$post->ID])){
						$row = $protect_data[$post->ID];
					}

					$smode = zm_drip_options('start', $post->ID, $row['start']['mode'], $row['enable']);

					$is_e_used = ($row['end']['used']) ? 'checked' : '';
					$is_expired = '';
					if ($is_e_used){
						if ($row['expired'] == 1){
							$is_expired = '<em class="zm_exp">(expired)</em>';
						}
					}

					$emode = zm_drip_options('end', $post->ID, $row['end']['mode'], $is_e_used);

					echo '<tr valign="top" class="zm-page-row-all zm-row '.($row['enable'] ? 'zm-row-selected' : '').' zm-page-row-'.$class.'" '.($class == 1 ? '' : 'style="display:none;"').'>';
					echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectpage" type="checkbox" name="zm-ac-post[]" value="'.$post->ID.'" '.($row['enable'] ? 'checked' : '').'></th>';
					echo '<td id="title-'.$post->ID.'">'.$post->post_title.' '.$is_expired.'</td>';

					echo '<td>';
					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns" >
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-7 gpf-columns">';

					$is_exact = ($row['start']['mode'] == 'X') ? true : false;
					echo '<input type="text" id="numb'.$post->ID.'-s" class="zm-start-value required digits" name="zm-ac-data['.$post->ID.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$post->ID.'-s" class="zm-start-dp-value" name="zm-ac-data['.$post->ID.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';

					echo '<td>';
					$is_exact = ($row['end']['mode'] == 'X') ? true : false;
					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns" >
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-3 gpf-columns">
					      		<span class="prefix radius">';
					echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$post->ID.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
					echo '</span>
							</div>';

					echo '<div class="large-4 gpf-columns">';
					echo '<input type="text" id="numb'.$post->ID.'-e" class="zm-end-value required digits" name="zm-ac-data['.$post->ID.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$post->ID.'-e" class="zm-end-dp-value" name="zm-ac-data['.$post->ID.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';

					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
					echo '</tr>';

					if ($i == $limit){
						$i=1;
						$class++;
					}else{
						$i++;
					}
				}
			}else{
				echo '<tr class="alternate" valign="top"><td colspan="4" align="center">--No Posts--</td></tr>';
			}
			zm_table_close();
			//CLOSE TABLE
			?>
			<br>
			<div class="gpf-row collapse">
				<div class="large-8 gpf-columns">
				</div>
				<div class="large-4 gpf-columns">
					<?php if (ceil(count($pages)/$limit) > 1): ?>
					<input type="hidden" id="zm-page-row-total" value="<?php echo $pages ? ceil(count($pages)/$limit) : 1;?>">
					<input type="hidden" id="zm-page-row-current" value="1">
					<div style="text-align: right;">
						<div class="gpf-row gpf-goto-pagination">
							<div class="large-12 gpf-columns"><span class="zm-displaying-num"><?php echo count($pages); ?> items</span>
								<div class="gpf-button-group radius gpf-right">
									<a key="zm-page-row" class="zm-first-page gpf-button secondary" title="Go to the first page" href="#"><i class="icon-double-angle-left"></i></a>
									<a key="zm-page-row" class="zm-prev-page gpf-button secondary" title="Go to the previous page" href="#"><i class="icon-angle-left"></i></a>
									<span class="zm-page-row-status gpf-button secondary"><i class="icon-"></i>1 of <?php echo $pages ? ceil(count($pages)/$limit) : 1;?></span>
									<a key="zm-page-row" class="zm-next-page gpf-button secondary" title="Go to the next page" href="#"><i class="icon-angle-right"></i></a>
									<a key="zm-page-row" class="zm-last-page gpf-button secondary" title="Go to the last page" href="#"><i class="icon-double-angle-right"></i></a>
								</div>
							</div>
						</div>
					</div>
					<?php endif; ?>
				</div>
			</div>
			<br>
			</div>
			<div class="zm-tabs-content-nestedception categories<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>" style="display:none;">
			<?php
			//OPEN TABLE
			zm_table_open($table_header, 'category');

			if ($categories){
				foreach ( $categories as $post ) {
					$row = array(
						'enable' => false,
						'start' => array('mode' => 'D',
										'value' => 0),
						'end' => array('mode' => 'D',
									   'value' => 30,
									   'used' => 0));

					$f_id='category_'.$post->cat_ID;

					if (isset($protect_data[$f_id])){
						$row = $protect_data[$f_id];
					}

					$smode = zm_drip_options('start', $f_id, $row['start']['mode'], $row['enable']);

					$is_e_used = ($row['end']['used']) ? 'checked' : '';
					$is_expired = '';
					if ($is_e_used){
						if ($row['expired'] == 1){
							$is_expired = '<em class="zm_exp">(expired)</em>';
						}
					}

					$emode = zm_drip_options('end', $f_id, $row['end']['mode'], $is_e_used);

					echo '<tr valign="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
					echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectcategory" type="checkbox" name="zm-ac-post[]" value="'.$f_id.'" '.($row['enable'] ? 'checked' : '').'></th>';
					echo '<td id="title-'.$f_id.'">'.$post->cat_name.' '.$is_expired.'</td>';

					echo '<td>';
					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns" ">
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-7 gpf-columns">';

					$is_exact = ($row['start']['mode'] == 'X') ? true : false;
					echo '<input type="text" id="numb'.$f_id.'-s" class="zm-start-value required digits" name="zm-ac-data['.$f_id.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$f_id.'-s" class="zm-start-dp-value" name="zm-ac-data['.$f_id.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';

					echo '<td>';
					$is_exact = ($row['end']['mode'] == 'X') ? true : false;
					echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
						<div class="large-12 gpf-columns" >
						<i class="icon-user"></i> Public Access
						</div>
						</div>';

					echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
					    	<div class="large-3 gpf-columns">
					      		<span class="prefix radius">';
					echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$f_id.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
					echo '</span>
							</div>';

					echo '<div class="large-4 gpf-columns">';
					echo '<input type="text" id="numb'.$f_id.'-e" class="zm-end-value required digits" name="zm-ac-data['.$f_id.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
					echo '<input type="text" id="date'.$f_id.'-e" class="zm-end-dp-value" name="zm-ac-data['.$f_id.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';

					echo '</div>';

					echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
					echo '</tr>';
				}
			}else{
				echo '<tr class="alternate" valign="top"><td colspan="4" align="center">--No Posts--</td></tr>';
			}
				zm_table_close();
				//CLOSE TABLE
			?>
			</div>
			<div class="zm-tabs-content-nestedception files<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>" style="display:none;">
				<div class="gpf-row collapse" id="zm-files-load">
		    		<div class="large-12 gpf-columns"><i class="icon-refresh icon-spin"></i> retrieving files...</div>
				</div>
			</div>
			<div class="zm-tabs-content-nestedception s3files<?php echo isset($_GET['id']) ? 'protect'.$_GET['id'] : ''; ?>" style="display:none;">
				<div class="gpf-row collapse" id="zm-s3files-load">
		    		<div class="large-12 gpf-columns"><i class="icon-refresh icon-spin"></i> retrieving files...</div>
				</div>
			</div>

			<?php
			foreach ($post_types as $k => $v){
			    ?>
			    <div class="zm-tabs-content-nestedception <?php echo $k.(isset($_GET['id']) ? 'protect'.$_GET['id'] : ''); ?>" style="display:none;">
			        <?php
                    //OPEN TABLE
                    zm_table_open($table_header, 'post');
                    $posts = get_posts( array('numberposts' => 9999, 'post_status' => 'publish', 'post_type' => $k) );
                    if ($posts){
                        foreach ( $posts as $post ) {
                            $row = array(
                                'enable' => false,
                                'start' => array('mode' => 'D',
                                                'value' => 0),
                                'end' => array('mode' => 'D',
                                               'value' => 30,
                                               'used' => 0));

                            if (isset($protect_data[$post->ID])){
                                $row = $protect_data[$post->ID];
                            }

                            $smode = zm_drip_options('start', $post->ID, $row['start']['mode'], $row['enable']);

                            $is_e_used = ($row['end']['used']) ? 'checked' : '';

                            $is_expired = '';
                            if ($is_e_used){
                                if ($row['expired'] == 1){
                                    $is_expired = '<em class="zm_exp">(expired)</em>';
                                }
                            }

                            $emode = zm_drip_options('end', $post->ID, $row['end']['mode'], $is_e_used);

                            echo '<tr valign="top" class="zm-row '.($row['enable'] ? 'zm-row-selected' : '').'">';
                            echo '<th scope="row" class="zm-check-column"><input data-customforms="disabled" class="zm-select zm-selectpost" type="checkbox" name="zm-ac-post[]" value="'.$post->ID.'" '.($row['enable'] ? 'checked' : '').'></th>';
                            echo '<td id="title-'.$post->ID.'">'.$post->post_title.' '.$is_expired.'</td>';

                            echo '<td>';

                            echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
                                <div class="large-12 gpf-columns">
                                <i class="icon-user"></i> Public Access
                                </div>
                                </div>';

                            echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
                                    <div class="large-7 gpf-columns">';
                            $is_exact = ($row['start']['mode'] == 'X') ? true : false;
                            echo '<input type="text" id="numb'.$post->ID.'-s" class="zm-start-value required digits" name="zm-ac-data['.$post->ID.'][start][value]" value="'.($is_exact ? 1 : $row['start']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($row['enable'] ? '' : 'disabled').'/>';
                            echo '<input type="text" id="date'.$post->ID.'-s" class="zm-start-dp-value" name="zm-ac-data['.$post->ID.'][start][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['start']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($row['enable'] ? '' : 'disabled').'/>';
                            echo '</div>';

                            echo '<div class="large-5 gpf-columns">'.$smode.'</div></div></td>';

                            echo '<td>';

                            $is_exact = ($row['end']['mode'] == 'X') ? true : false;
                            echo '<div class="gpf-row collapse zm-public-access" '.($row['enable'] ? 'style="display:none;"' : '').'>
                                <div class="large-12 gpf-columns" >
                                <i class="icon-user"></i> Public Access
                                </div>
                                </div>';

                            echo '<div class="gpf-row collapse zm-private-access" '.($row['enable'] ? '' : 'style="display:none;"').'>
                                    <div class="large-3 gpf-columns">
                                        <span class="prefix radius">';
                            echo '<input data-customforms="disabled" type="checkbox" value="1" name="zm-ac-data['.$post->ID.'][end][used]" class="zm-ac-use-end" '.$is_e_used.'/><span data-tooltip class="zm-help tip-top" title="If you want your content/file to be available forever (for your grandchildren for example), uncheck this box"></span>';
                            echo '</span>
                                    </div>';

                            echo '<div class="large-4 gpf-columns">';
                            echo '<input type="text" id="numb'.$post->ID.'-e" class="zm-end-value required digits" name="zm-ac-data['.$post->ID.'][end][value]" value="'.($is_exact ? 1 : $row['end']['value']).'" '.($is_exact ? 'style="display:none"' : '').' '.($is_e_used ? '' : 'disabled').'/>';
                            echo '<input type="text" id="date'.$post->ID.'-e" class="zm-end-dp-value" name="zm-ac-data['.$post->ID.'][end][value-dp]" value="'.($is_exact ? date("m/d/Y", $row['end']['value']) : date("m/d/Y")).'" '.($is_exact ? '' : 'style="display:none"').' '.($is_e_used ? '' : 'disabled').'/>';

                            echo '</div>';

                            echo '<div class="large-5 gpf-columns">'.$emode.'</div></div></td>';
                            echo '</tr>';
                        }
                    }else{
                        echo '<tr class="alternate" valign="top"><td colspan="4" align="center">--No Custom Post--</td></tr>';
                    }
                    zm_table_close();
                    //CLOSE TABLE
                    ?>
                </div>
                <?php
			}
			?>
		</div>
		<input type="hidden" name="zm_submit_form" value="save_access">
		<input type="submit" value="Save Changes" class="radius gpf-button zm_submit_form" name="zm-submit-ac"/>
		<div id="zm-download-url-box" style="display: none;"><input type="text" value="" id="zm-download-url" onclick="this.focus();this.select()" readonly="readonly" style="font-family:courier; margin-bottom: 0px !important;"></div>
		<input type="hidden" value="<?php echo site_url()?>" id="zm_site_url" />
		<?php if ($step): ?> <input type="hidden" value="true" id="zm-step" /> <?php endif; ?>
	</form>
</div>
<?php endif; ?>
</div>
</div><!-- ajax load wrapper -->
