<?php
add_action('admin_menu', 'zm_add_admin');
function zm_add_admin() {
	$zm = add_menu_page('Zaxaa Member', 'Zaxaa Member', 'manage_options', 'zm-admin', 'zm_admin', ZM_URL . 'favicon.ico', '30.183456');

	add_action( "admin_print_scripts-$zm", 'zm_admin_scripts' );
	add_action( "admin_print_styles-$zm", 'zm_admin_styles' );

	add_action("admin_print_scripts-post.php", 'zm_admin_scripts');
	add_action("admin_print_scripts-post-new.php", 'zm_admin_scripts');
	add_action("admin_print_styles-post.php", 'zm_admin_styles');
	add_action("admin_print_styles-post-new.php", 'zm_admin_styles');
}

add_action('admin_head', 'zm_admin_head', 11);
function zm_admin_head() {
	if ( !isset($_GET['page']) ) return;
	if ( !stristr($_GET['page'], 'zm') ) return;
?>
<link rel="icon" type="image/ico" href="<?php echo ZM_URL . 'favicon.ico'; ?>">
<?php
}

function zm_admin_scripts() {
	wp_enqueue_script('jquery');
	if ( isset($_GET['page']) && $_GET['page'] == 'zm-admin' ) {
		// wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-history', ZM_URL . 'js/jquery.history.js', array('jquery'));
		wp_enqueue_script('jquery-validation', ZM_URL . 'js/jquery.validate.min.js', array('jquery'));
		wp_enqueue_script('zm-gpf-min', ZM_URL . 'js/gpf.min.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-custom-modernizr', ZM_URL . 'js/custom.modernizr.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-chosen', ZM_URL . 'js/chosen.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-datepicker', ZM_URL . 'js/foundation.datepicker.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-colorbox', ZM_URL . 'js/jquery.colorbox-min.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-admin', ZM_URL . 'js/admin.js', array('jquery'), '1.0.0', true);
		//zm_load_jqplot();
	} else {
		wp_enqueue_script('zm-admin-post', ZM_URL . 'js/admin-post.js', array('jquery'), '1.0.0', true);
		wp_enqueue_script('zm-datepicker', ZM_URL . 'js/foundation.datepicker.js', array('jquery'), '1.0.0', true);
	}
}

function zm_admin_styles() {
	// load css for admin page
	if ( isset($_GET['page']) && $_GET['page'] == 'zm-admin' ) {
		wp_enqueue_style('zm-admin', ZM_URL . 'css/admin.css');       
		wp_enqueue_style('zm-gpf-normalize', ZM_URL . 'css/normalize.css');
		wp_enqueue_style('zm-gpf-main', ZM_URL . 'css/gpf-main.css');
		wp_enqueue_style('zm-foundation-icons-min', ZM_URL . 'css/foundation-icons.css');
        wp_enqueue_style('zm-font-awesome-min', ZM_URL . 'css/font-awesome.min.css');
        //wp_enqueue_style('zm-font-awesome-ie7', ZM_URL . 'css/font-awesome-ie7.min.css');
		wp_enqueue_style('zm-chosen', ZM_URL . 'css/chosen.css');
		wp_enqueue_style('zm-tabs', ZM_URL . 'css/tabs.css');
		wp_enqueue_style('zm-colorbox', ZM_URL . 'css/colorbox.css');
		
	} else {
		wp_enqueue_style('zm-admin', ZM_URL . 'css/admin-post.css');
		wp_enqueue_style('zm-font-awesome-min', ZM_URL . 'css/font-awesome.min.css');
        //wp_enqueue_style('zm-font-awesome-ie7', ZM_URL . 'css/font-awesome-ie7.min.css');
	}
}

function zm_load_jqplot(){
	wp_enqueue_script('zm-jqplot', ZM_URL . 'js/jqplot/jquery.jqplot.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-highlighter', ZM_URL . 'js/jqplot/plugins/jqplot.highlighter.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-cursor', ZM_URL . 'js/jqplot/plugins/jqplot.cursor.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-canvasTextRenderer', ZM_URL . 'js/jqplot/plugins/jqplot.canvasTextRenderer.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-canvasAxisTickRenderer', ZM_URL . 'js/jqplot/plugins/jqplot.canvasAxisTickRenderer.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-categoryAxisRenderer', ZM_URL . 'js/jqplot/plugins/jqplot.categoryAxisRenderer.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-categoryAxislabelRenderer', ZM_URL . 'js/jqplot/plugins/jqplot.canvasAxisLabelRenderer.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('zm-jqplot-barRenderer', ZM_URL . 'js/jqplot/plugins/jqplot.barRenderer.min.js', array('jquery'), '1.0.0', true);
	wp_enqueue_style('zm-jqplot', ZM_URL . 'js/jqplot/jquery.jqplot.min.css');
	
}

//add_action('admin_footer', 'zm_jqplot_script', 20);

function zm_jqplot_script() {
	if ( isset($_GET['page']) && $_GET['page'] == 'zm-admin' ) {
		$sales_graph = array();
		$member_graph = array();
		
		for ( $i = 30-1; $i >= 0; $i-- ) {
		    $sales_graph[date('d M', strtotime($i . " days ago"))] = 0;
			$member_graph[date('d M', strtotime($i . " days ago"))] = 0;
		}

		$sales = zm_get_all('payment', '', '30days');
		$members = zm_get_all('member', '', '30days');

		if ( $sales ) {
		    foreach ( $sales as $row ) {
		        $txn_pay_time = date('d M', $row->txn_date);
		        if ( array_key_exists($txn_pay_time, $sales_graph) )
		            $sales_graph[$txn_pay_time] += $row->amount;
		    }
		}

		if ( $members ) {
		    foreach ( $members as $row ) {
		        $register_date = date('d M', $row->date);
		        if ( array_key_exists($register_date, $member_graph) )
		            $member_graph[$register_date] += 1;
		    }
		}
?>
	<script type="text/javascript">
		jQuery(document).ready(function($){
			$('body').on("zm_load_chart", function(e){
				var line1 = [<?php foreach ( $sales_graph as $key => $val ) echo "['". $key . "'," . floatval($val) . "],"; ?>];
				var line2 = [<?php foreach ( $member_graph as $key => $val ) echo "['". $key . "'," . floatval($val) . "],"; ?>];
				
			  	var plot1 = $.jqplot('zm-chart', [line1, line2], {
					series:[
						{
							renderer:$.jqplot.BarRenderer,
							rendererOptions: {barWidth: 10},
							label:'Revenue',
							showLabel:true,
							color: '#669900',
							highlighter: {
								sizeAdjust:7.5,
								formatString: '%.2f',
							},
						},
						{
							xaxis:'xaxis',
							yaxis:'y2axis',
							label:'New Members',
							showLabel:true,
							color: '#6ba6b7',
							fill:true,
							fillAndStroke:true,
							fillColor: '#6ba6b7',
							fillAlpha:0.25,
							shadow:false,
							highlighter: {
								formatString: '%d',
							},
						}
					],
					axes: {
						xaxis: {
						  renderer:$.jqplot.CategoryAxisRenderer,
						  tickRenderer: $.jqplot.CanvasAxisTickRenderer,
						  tickOptions: {
			                angle: -50,
			                fontBold:false,
			                fontSize:'8pt',
			              }
						},
						yaxis: {
							autoscale:true,
							padMin:0,
							tickOptions:{
								formatString:'%.2f',
							},
							labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
							label:'Revenue',
							labelOptions: {
								fontFamily:'Verdana',
								fontSize:'10pt',
								fontBold:true,
								textColor:'#669900',
							}
						},
						y2axis: {
							//tickInterval:10,
							autoscale:true,
							
							padMin:0,
							tickOptions:{
								formatString:'%d',
							},
							labelRenderer: $.jqplot.CanvasAxisLabelRenderer,
							label:'New Members',
							labelOptions: {
								fontFamily:'Verdana',
								fontSize:'10pt',
								fontBold:true,
								textColor:'#6ba6b7',
								angle:90,
							}
						}
					},
					
					highlighter: {
						show:true,
						tooltipAxes:'y',
						bringSeriesToFront:false,
					},
					
					legend: {
						show:true,
						location:'nw',
						placement:'outsideGrid',
					},
					
					grid: {
						drawGridlines:false,
						borderWidth:0.10,
						shadow:true,
					}
				});
				
				plot1.replot();
			});
			
			//Make sure target has been there
			if ($('#zm-chart').length){
				$(window).load(function(){
					$('body').trigger("zm_load_chart");
				});
			}
		});
	</script>
<?php
	}
}

function zm_admin_navigation(){
	echo '<div class="admin-menu">
			<div class="header-text">This membership plugin only works with Zaxaa</div>
            <ul class="gpf-inline-list">
            	<li class="zm-icon-x"><a href="' . zaxaa_referral_url() . '" target="_blank">Sign up for a Zaxaa account here</a>.</li>
                <li class="zm-icon-1"><a href="http://www.zaxaablog.com/tutorial/zaxaa-member/" target="_blank">Tutorial</a></li>
                <li class="zm-icon-2"><a href="' . zaxaa_referral_url('https://www.zaxaa.com/user/referral_commission') . '" target="_blank">Zaxaa Referral Program</a></li>
                <li class="zm-icon-3"><a href="http://support.zaxaa.com/" target="_blank">Support</a></li>
            </ul>
        </div>';
}

function zm_admin() {
		
	//check wizard (will be updated next)
	if ( get_option('zm_wizard_completed') ) {
		$mode = 'products';
		
		if (isset($_GET['mode'])){
			$mode = $_GET['mode'];
		}
	?>
		<span class="zm-topbar-home"></span>
        <div class="zm-menu-main">
            <ul class="gpf-side-nav">
                <?php require ('admin-menu.php')?>
            </ul> 
        </div>
		<div class="gpf-row">
        <div class="large-12 gpf-columns">
                    	<p class="admin-version"><?php echo ZM_VERSION; ?></p>
				    	<a href="<?php zaxaa_referral_url(); ?>" target="_blank">
                        <i class="zm-shake" id="zm-logo"></i>
                        </a>
				       <div class="admin-menu">
				       		<div class="header-text">This membership plugin only works with Zaxaa</div> 
				            <ul class="gpf-inline-list">
				            	<li class="zm-icon-x"><a href="<?php zaxaa_referral_url(); ?>" target="_blank">Sign up for a Zaxaa account here</a>.</li>
				                <li class="zm-icon-1"><a href="http://www.zaxaablog.com/tutorial/zaxaa-member/" target="_blank">Tutorial</a></li>
				                <li class="zm-icon-2"><a href="<?php zaxaa_referral_url('https://www.zaxaa.com/user/referral_commission'); ?>" target="_blank">Zaxaa Referral Program</a></li>
				                <li class="zm-icon-3"><a href="http://support.zaxaa.com/" target="_blank">Support</a></li>
				            </ul>
				        </div>
	            <br/>
							</div><!-- GPF columns -->
	    </div><!-- GPF row -->
				<!-- <center> // Please do not use <center> as this tag is deprecated and about to be removed -->
				<div id="sem-content">
					<?php
					switch ( $mode ) {
						case 'members';
							require_once('admin-members.php');
							break;
					
						case 'payments';
							require_once('admin-payments.php');
							break;
							
						case 'report';
							require_once('admin-report.php');
							break;
							
						case 'config';
							require_once('admin-config.php');
							break;
						
						case 'protect';
							require_once('admin-protect.php');
							break;
							
						case 'import';
							require_once('admin-import.php');
							break;
					
						case 'products':
						default:
							require_once('admin-products.php');
					}
					?>
				</div><!-- sem-content -->
	    <div class="gpf-clear"></div>
	    
	    <div id="zm-hidden-content" style="display: none; visibility: hidden"></div>
		<?php
	}else{
		$mode = 'config_general';
		
		if (isset($_GET['mode'])){
			$mode = $_GET['mode'];
		}
		//Wizard
		?>
		<br/>
        <article class="zm-topbar">
		<div class="gpf-row">
        	<div class="small-12 gpf-columns" style="position:relative;">
            <p class="admin-version"><?php echo ZM_VERSION ?></p>
		    	<a href="<?php zaxaa_referral_url(); ?>" target="_blank">
                <i class="zm-shake" id="zm-logo"></i>
                </a>
		       <div class="admin-menu">
		       		<div class="header-text">This membership plugin only works with Zaxaa</div>
		            <ul class="gpf-inline-list">
		            	<li class="zm-icon-x"><a href="<?php zaxaa_referral_url(); ?>" target="_blank">Sign up for a Zaxaa account here</a>.</li>
		                <li class="zm-icon-1"><a href="http://www.zaxaablog.com/tutorial/zaxaa-member/" target="_blank">Tutorial</a></li>
		                <li class="zm-icon-2"><a href="<?php zaxaa_referral_url('https://www.zaxaa.com/user/referral_commission'); ?>" target="_blank">Zaxaa Referral Program</a></li>
		                <li class="zm-icon-3"><a href="http://support.zaxaa.com/" target="_blank">Support</a></li>
		            </ul>
		        </div>
            </div>
        </div>
        </article>
        <br/>
        <div class="wrap">
		<div class="gpf-row zm-wizard-bar">
			<div class="large-12 gpf-columns zm-wizard-topbar">
		    	<span><i class="fi-wrench large"></i> Getting Started is EASY &amp; QUICK!</span>
		    </div>
		    <div class="large-12 gpf-columns zm-wizard-bottombar">
		    	<div class="gpf-row">
				    <div class="large-4 gpf-columns zm-wizard-nav-config_general <?php echo ($mode == 'config_general') ? 'active' : ''; ?>">
				    	<h3 class="zm-circle">1</h3><p>Setup your<br>Membership Pages</p>
				    </div>
				    <div class="large-4 gpf-columns zm-wizard-nav-config_payment <?php echo ($mode == 'config_payment') ? 'active' : ''; ?>">
				    	<h3 class="zm-circle">2</h3><p>Setup your<br>Zaxaa API Signature</p>
				    </div>
				    <div class="large-4 gpf-columns zm-wizard-nav-config_email <?php echo ($mode == 'config_email') ? 'active' : ''; ?>">
				    	<h3 class="zm-circle">3</h3><p>Setup your<br>Email Templates</p>
				    </div>
			   	</div>
		  	</div>
		</div>
		<form class="custom" method="post" action="">
			<div id="sem-content">
				<?php
					require_once('admin-wizard.php');
				?>
			</div>
		</form>
		</div><!-- wrap -->
		<div id="zm-hidden-content" style="display: none; visibility: hidden"></div>
		<?php
	}
}

add_action('zm_get_payment_module', 'zm_payment_module', 10, 2);
function zm_payment_module( $data, $product_id) {
	if ( $modules = zm_available_payments() ) {
		
		$processor = array('zaxaa' => 'Zaxaa');
						   
		foreach ( $modules as $file => $module ) {
			?>
			<input id="zm-payment-<?php echo $module; ?>-on" value="on" name="zm-payment-processor[<?php echo $module; ?>][enable]" type="hidden" />
			<tr>
			<td colspan="2"><?php do_action('zm_payment_settings_' . $module, $product_id, $data); ?></td>
			</tr>
			<?php
		}
	}
}

if ( is_admin() ) add_action('admin_init', 'zm_admin_master');
function zm_admin_master() {
	if ( isset($_GET['page']) && $_GET['page'] == 'zm-admin' ) {
		global $wpdb;
		if ( isset($_GET['zm_admin']) && $_GET['zm_admin'] == 'logs' ) {
			if ( isset($_POST['zmmaster_action']) && $_POST['zmmaster_action'] == 'check_ipn' ) {
				$sql = "SELECT * FROM `{$wpdb->prefix}zm_ipn_log` WHERE 1";
				if ( $_POST['paysys'] != 'all' )
					$sql .= " AND `paysys` = '{$_POST['paysys']}'";
				
				if ( $_POST['status'] == 'un' )
					$sql .= " AND `status` = 0";
				else if ( $_POST['status'] == 'pro' )
					$sql .= " AND `status` = 1";
				
				$sql .= " ORDER BY `log_id` DESC LIMIT 100";
				if ( $logs = $wpdb->get_results($sql) ) {
					foreach ( $logs as $log ) {
						if ( isset($log->postdata) )
							$log->postdata = maybe_unserialize(str_replace('\'', '\\\'',$log->postdata));
						
						zm_dump($log);
					}
				} else {
					echo "No log data found.";
				}
				
			} else if ( isset($_POST['zmmaster_action']) && $_POST['zmmaster_action'] == 'check_error' ) {
				$sql = "SELECT * FROM `{$wpdb->prefix}zm_error_log` WHERE 1";
				if ( $_POST['type'] == 'ipn' )
					$sql .= " AND `type` = 'ipn'";
				else if ( $_POST['type'] == 'non' )
					$sql .= " AND `type` <> 'ipn'";
				
				$sql .= " ORDER BY `log_id` DESC LIMIT 100";
				if ( $logs = $wpdb->get_results($sql) ) {
					foreach ( $logs as $log ) {
						zm_dump($log);
					}
				} else {
					echo "No log data found.";
				}
			}
?>
<h2>Check IPN Log</p>
<form name="check_ipn_log" method="post">
	<input type="hidden" name="zmmaster_action" value="check_ipn" />
	<p>
		<select name="paysys" id="paysys">
			<option value="zaxaa">Zaxaa</option>
		</select>
		<select name="status" id="status">
			<option value="all"> -- All Statuses -- </option>
			<option value="un">Unprocessed</option>
			<option value="pro">Processed</option>
		</select>
		<input type="submit" id="zmmaster_ipn_submit" value="GO" />
</form>
<h2>Check Error Log</p>
<form name="check_error_log" method="post">
	<input type="hidden" name="zmmaster_action" value="check_error" />
	<p>
		<select name="type" id="type">
			<option value="all"> -- All Errors -- </option>
			<option value="ipn">IPN Errors</option>
			<option value="non">Non-IPN Errors</option>
		</select>
		<input type="submit" id="zmmaster_error_submit" value="GO" />
</form>
<?php
			exit;
		}
	}
}

add_action('zm_message', 'zm_message_box', 11);
function zm_message_box(){
	$mode = '';
	if (zm_isset($_GET['mode']) == 'products')
		$mode = 'Product / Level';
	else if (zm_isset($_GET['mode']) == 'members')
		$mode = 'Member';
	else if (zm_isset($_GET['mode']) == 'config')
		$mode = 'Configuration';
	else if (zm_isset($_GET['mode']) == 'coupons')
		$mode = 'Coupon';
			
	if (zm_isset($_GET['added']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>'.$mode.' added.';
		if ( zm_isset($_GET['mode']) == 'products' )
			echo ' Please complete the settings below.';
		echo '</p></div>';
	}else if (zm_isset($_GET['added']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p>'.$mode.' add failed.</p></div>';
	}else if (zm_isset($_GET['payment']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Payment added.</p></div>';
	}else if (zm_isset($_GET['payment']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p>Payment add failed.</p></div>';
	}else if (zm_isset($_GET['payment']) == 'updated'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Payment updated.</p></div>';
	}else if (zm_isset($_GET['updated']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>'.$mode.' updated.</p></div>';
	}else if (zm_isset($_GET['deleted']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>'.$mode.' deleted.</p></div>';
	}else if (zm_isset($_GET['cloned']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>'.$mode.' cloned.</p></div>';
	}else if (zm_isset($_GET['cloned']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p>'.$mode.' clone failed.</p></div>';
	}else if (zm_isset($_GET['saved']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Settings Saved.</p></div>';
	}else if (zm_isset($_GET['saved']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p>Save Failed.</p></div>';
	}else if (zm_isset($_GET['aweber']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Your Aweber account has been connected with this site.</p></div>';
	}else if (zm_isset($_GET['aweber']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p> Error! Can\'t connect to your Aweber account.</p></div>';
	}else if (zm_isset($_GET['icontact']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Your iContact account has been connected with this site.</p></div>';
	}else if (zm_isset($_GET['icontact']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p><b>Error!</b> Can\'t connect to your iContact account.</p></div>';
	}else if (zm_isset($_GET['gotowebinar']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Your GoToWebinar account has been connected with this site.</p></div>';
	}else if (zm_isset($_GET['gotowebinar']) == 'false'){
		echo '<div class="alert-box alert" style="margin:10px 0"><p><b>Error!</b> Can\'t connect to your GoToWebinar account.</p></div>';
	}else if (zm_isset($_GET['wizard']) == 'complete'){
		if (zm_isset($_GET['type']) == 'free'){
			echo '<div class="alert-box success" style="margin:10px 0"><p>Product created. You can get the Free Registration Form below.</p></div>';
		}else{
			echo '<div class="alert-box success" style="margin:10px 0"><p>Product created. You can get the Order URL below.</p></div>';
		}	
	}else if (zm_isset($_GET['imported']) == 'true'){
		echo '<div class="alert-box success" style="margin:10px 0"><p>Members data has been successfully imported.</p></div>';
	}
}

function zm_table_open($data, $select='', $checkbox=true){
	
	$th = '';
	foreach ($data as $row){
		$th .= '<th><span>'.$row.'</span></th>'."\n";
	}
	
	$class = 'gpf-table';
	if ($select == 'meta'){
		$class = 'zm-meta-table';
	}
	
	$elm = '<table class="'.$class.'" cellspacing="0">
				<thead>
				<tr>';
				
	if ($checkbox) $elm .= '<th><input class="zm-select-all'.$select.' zm-select'.$select.'" type="checkbox" data-customforms="disabled"/></th>';
	
	$elm .= $th.'
				</tr>
				</thead>
				<tfoot>
				<tr>';
				
	if ($checkbox) $elm .= '<th><input class="zm-select-all'.$select.' zm-select'.$select.'" type="checkbox" data-customforms="disabled"/></th>';
	
	$elm .= $th.'
				</tr>
				</tfoot>
				<tbody id="the-list">';
	
	echo $elm;
}

function zm_table_close(){
	echo '</tbody></table>';
}

function zm_set_pagination($url, $data, $start, $limit, $title, $parent='sem-content'){
	$total = ceil($data/$limit);
	$param_prev = ($start > 1) ? $start-1 : 1;
	$param_next = ($start < $total) ? $start+1: $total;
	
    $mode = zm_generate_mode($url);
    
    if ($parent == 'sem-members'){
        $mode = substr($mode, 7);
        
        $first = 'members'.zm_generate_history_id($mode.'p1');
        $prev = 'members'.zm_generate_history_id($mode.'p'.$param_prev);
        $next = 'members'.zm_generate_history_id($mode.'p'.$param_next);
        $last = 'members'.zm_generate_history_id($mode.'p'.($total > 0 ? $total : 1));
        
    }else{
    
        $first = $mode.'p1';
        $prev = $mode.'p'.$param_prev;
        $next = $mode.'p'.$param_next;
        $last = $mode.'p'.($total > 0 ? $total : 1);
    }
	
	$paginations = '<div class="gpf-row gpf-goto-pagination">';
	$paginations .= '<div class="large-12 gpf-columns"><span class="zm-displaying-num">'.$data.' items</span>';
	$paginations .= '<div class="gpf-button-group radius gpf-right">';
	$paginations .= '<a data-parent="'.$parent.'" data-mode="'.$first.'" data-title="'.$title.'" class="zm-pagination gpf-button secondary" title="Go to the first page" href="'.$url.'&p=1"><i class="icon-double-angle-left"></i></a>';
	$paginations .= '<a data-parent="'.$parent.'" data-mode="'.$prev.'" data-title="'.$title.'" class="zm-pagination gpf-button secondary" title="Go to the previous page" href="'.$url.'&p='.$param_prev.'"><i class="icon-angle-left"></i></a>';
	$paginations .= '<div class="gpf-button secondary"><i class="icon-"></i>'.$start.' of '.($total > 0 ? $total : 1).'</div>';
	$paginations .= '<a data-parent="'.$parent.'" data-mode="'.$next.'" data-title="'.$title.'" class="zm-pagination gpf-button secondary" title="Go to the next page" href="'.$url.'&p='.$param_next.'"><i class="icon-angle-right"></i></a></a>';
	$paginations .= '<a data-parent="'.$parent.'" data-mode="'.$last.'" data-title="'.$title.'" class="zm-pagination gpf-button secondary" title="Go to the last page" href="'.$url.'&p='.($total > 0 ? $total : 1).'"><i class="icon-double-angle-right"></i></a>';
	$paginations .= '</div></div>';
	$paginations .= '</div>';
	
	//for($i=1; $i<=$total; $i++){
	//	$paginations .= '<span>'.$i.'</span>';
	//}
	
	return $paginations;
}

function zm_generate_mode($url){
	$mode = str_replace(admin_url('admin.php?page=zm-admin&mode='), '', $url);
	$mode = str_replace('&', '', $mode);
	$mode = str_replace('=', '', $mode);
	$mode = str_replace('/', '', $mode);
	
	return $mode;
}

function zm_lbl_payment_type($type){
	if ($type == 'paypal'){
		return '<span class="gpf-label round">PayPal</span>';
	}else if ($type == 'zaxaa'){
		return '<span class="gpf-label success round">'.ucwords($type).'</span>';
	}else if ($type == 'clickbank'){
		return '<span class="gpf-label alert round">'.ucwords($type).'</span>';
	}else if ($type == '1shoppingcart'){
		return '<span class="gpf-label blue round">1ShoppingCart</span>';
	}else if ($type == 'jvzoo'){
		return '<span class="gpf-label secondary round">JVZoo</span>';
	}else if ($type == 'infusionsoft'){
		return '<span class="gpf-label softgreen round">InfusionSoft</span>';
	}else{
		return '<span class="gpf-label secondary round">'.ucwords($type).'</span>';
	}
}

function zm_columns_head($defaults) {
	$defaults['zm_access'] = 'Zaxaa Member Access';
	return $defaults;
}

function zm_columns_content( $column_name, $post_ID ) {
	if ( $column_name == 'zm_access' ) {
		if ( zm_is_protected($post_ID) ) {
			echo 'Members Only';
		} else {
			echo 'Public';
		}
	}
}

add_action('admin_notices', 'zm_check_requirement');
function zm_check_requirement()
{
	$errormsg    = '';
	$wp_dir      = ABSPATH . '/wp-content/uploads/';

	if ( is_dir($wp_dir) ) {
		if ( !is_writeable( $wp_dir ) ) {
			$errormsg .= '<p style="line-height:16px"><span style="color:#cc0000"><strong>' . str_replace('//', '/', $wp_dir) . '</strong> is NOT writeable.</span> Please chmod it to <strong>777</strong>.</p>';
		}
	}

	if ( $errormsg != '' ) {
		echo '<div class="error fade"><p><strong>WARNING:</strong></p>' . $errormsg . '<p><a href="http://www.youtube.com/watch?v=GWBwqlUhQOM" target="_blank">Click here</a> to learn more about how to chmod a file or directory (hint: You can do this in less than a minute).</div>';
	}
}

function zm_get_icon($filename){
	$temp_file = explode('.', $filename);
	$file_type = $temp_file[count($temp_file)-1];
				
	$icon = 'icon-file';
	
	if ($file_type == 'pdf')
		$icon = 'zm-icon-pdf';
	else if ($file_type == 'avi')
		$icon = 'zm-icon-vid';
	else if ($file_type == 'mp4')
		$icon = 'zm-icon-vid';
	else if ($file_type == 'mkv')
		$icon = 'zm-icon-vid';
	else if ($file_type == 'flv')
		$icon = 'zm-icon-vid';
	else if ($file_type == 'mov')
		$icon = 'zm-icon-vid';
	else if ($file_type == '3gp')
		$icon = 'zm-icon-vid';
	else if ($file_type == 'doc')
		$icon = 'zm-icon-doc';
	else if ($file_type == 'docx')
		$icon = 'zm-icon-doc';
	else if ($file_type == 'xls')
		$icon = 'zm-icon-xls';
	else if ($file_type == 'xlsx')
		$icon = 'zm-icon-xls';
	else if ($file_type == 'zip')
		$icon = 'zm-icon-zip';
	else if ($file_type == 'rar')
		$icon = 'zm-icon-zip';
	else if ($file_type == '7zip')
		$icon = 'zm-icon-zip';
	else if ($file_type == 'gz')
		$icon = 'zm-icon-zip';
	else if ($file_type == 'js')
		$icon = 'zm-icon-code';
	else if ($file_type == 'css')
		$icon = 'zm-icon-code';
	else if ($file_type == 'html')
		$icon = 'zm-icon-code';
	else if ($file_type == 'mp3')
		$icon = 'zm-icon-mp3';
	else if ($file_type == 'php')
		$icon = 'zm-icon-php';
	else if ($file_type == 'txt')
		$icon = 'zm-icon-txt';
	else if ($file_type == 'psd')
		$icon = 'zm-icon-psd';
	else if ($file_type == 'ai')
		$icon = 'zm-icon-ai';
	else if ($file_type == 'swf')
		$icon = 'zm-icon-swf';
	else if ($file_type == 'jpg')
		$icon = 'zm-icon-img';
	else if ($file_type == 'png')
		$icon = 'zm-icon-img';
	else if ($file_type == 'jpeg')
		$icon = 'zm-icon-img';
	else if ($file_type == 'gif')
		$icon = 'zm-icon-img';
		
	return $icon;
}

function zm_get_raw_login_form(){
	$general = get_option('zm_general_option');
	$login_id = zm_isset($general['login_page']);
	
	$elm = '';
	$elm .= '<!-- Zaxaa Member Login Form -->'."\n";
	$elm .= '<style type="text/css">'."\n";
	$elm .= ".zm-external-form{max-width:80%;border:1px solid #ddd;-webkit-border-radius:3px;border-radius:3px;font-family:'Segoe UI', Helvetica, sans-serif;margin:0;padding:15px}\n";
	$elm .= ".zm-input{background-color:#FFF;font-family:inherit;border:1px solid #ccc;-webkit-box-shadow:inset 0 1px 2px rgba(0,0,0,0.1);box-shadow:inset 0 1px 2px rgba(0,0,0,0.1);color:rgba(0,0,0,0.75);font-size:.875em;height:40px!important;width:100%!important;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box;-webkit-transition:all .15s linear;-moz-transition:all .15s linear;transition:all .15s linear;-webkit-border-radius:0!important;border-radius:0!important;margin:0 auto 12px!important;padding:0 6px!important}\n";
	$elm .= ".zm-button{width:60%;height:40px;font-size:18px!important;zoom:1;margin-bottom:0;text-align:center;cursor:pointer;word-spacing:.25em;font-weight:400;line-height:20px;vertical-align:middle;display:inline-block;text-decoration:none;-webkit-box-shadow:0 2px 3px rgba(0,0,0,0.35), inset 0 1px 0 rgba(255,255,255,0.35), inset 0 10px 20px rgba(255,255,255,0.12), inset 0 -10px 30px rgba(0,0,0,0.12)!important;-moz-box-shadow:0 2px 3px rgba(0,0,0,0.35), inset 0 1px 0 rgba(255,255,255,0.35), inset 0 10px 20px rgba(255,255,255,0.12), inset 0 -10px 30px rgba(0,0,0,0.12)!important;box-shadow:0 2px 3px rgba(0,0,0,0.35), inset 0 1px 0 rgba(255,255,255,0.35), inset 0 10px 20px rgba(255,255,255,0.12), inset 0 -10px 30px rgba(0,0,0,0.12);color:#fff!important;text-shadow:0 -1px 0 rgba(0,0,0,0.25)!important;background-color:#4197f3!important;background-image:linear-gradient(tobottom,#4197f3,#3d8ce1)!important;background-repeat:repeat-x!important;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff4197f3',endColorstr='#ff3d8ce1',GradientType=0)!important;border-color:rgba(0,0,0,0.1) rgba(0,0,0,0.1) rgba(0,0,0,0.25)!important;padding:4px 12px!important}\n";
	$elm .= "</style>"."\n";
	$elm .= '<form action="'.site_url().'" method="post">'."\n";
	$elm .= '<input type="hidden" name="zm-login-page" value="' . $login_id . '" />'."\n";
	$elm .= '<div id="zm-login-form" style="margin-top:15px">'."\n";
	$elm .= '<input type="text" id="zm-username" name="zm-username" class="zm-input" placeholder="username or email" /><input type="password" id="zm-password" name="zm-password" class="zm-input" placeholder="password" />'."\n";
	$elm .= '</div>'."\n";
	$elm .= '<p class="login-submit">'."\n";
	$elm .= '<input type="submit" name="zm-login" id="zm-login" class="zm-button" value="Login" style="width:100%" />'."\n";
	$elm .= '</p>'."\n";
	$elm .= '<p class="login-remember"><label><input name="zm-remember" type="checkbox" value="1" /> Remember Me</label></p>'."\n";
	$elm .= '</form>'."\n";
	$elm .= '<!-- Zaxaa Member Login Form -->'."\n";
			
	return $elm;
}

function zm_get_info($ip){
	
	$url = "http://freegeoip.net/xml/".$ip;
	$xml = @simplexml_load_file($url);
	
	return $xml;
}

function zm_city($info){
	return $info->City;
}

function zm_country($info){
	return $info->CountryName;
}

/* creates a compressed zip file */
function zm_create_zip($files = array(), $destination = '', $overwrite = false) {
	//if the zip file already exists and overwrite is false, return false
	if(file_exists($destination) && !$overwrite) { return false; }
	
	$valid_files = array();
	
	//if files were passed in...
	if(is_array($files)) {
		//cycle through each file
		foreach($files as $key=>$file) {
			//make sure the file exists
			if(file_exists($file)) {
				$valid_files[$key] = $file;
			}
		}
	}
	
	//if we have good files...
	if(count($valid_files)) {
		//create the archive
		$zip = new ZipArchive();
		if($zip->open($destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
			return false;
		}
		
		//add the files
		foreach($valid_files as $key=>$file) {
			$zip->addFile($file, $key);
		}
		
		//close the zip -- done!
		$zip->close();
		
		//check to make sure the file exists
		return file_exists($destination);
	}
	else
	{
		return false;
	}
}
// POSTS/PAGES COLUMN HOOKS
add_filter('manage_posts_columns', 'zm_columns_head');
add_action('manage_posts_custom_column', 'zm_columns_content', 10, 2);
add_filter('manage_pages_columns', 'zm_columns_head');
add_action('manage_pages_custom_column', 'zm_columns_content', 10, 2);