(function($) {
    var History = window.History;
    var ancestor = $('#sem-content');

    if ( History.enabled ) {
        State = History.getState();
        // set initial state to first page that was loaded
        History.pushState({urlPath: window.location.pathname, mode:'dashboard'}, $("title").text(), State.urlPath);
    } else {
        return false;
    }

    var loadAjaxContent = function(target, urlBase, selector) {
        $(target).load(urlBase + ' ' + selector, function(){
            $(selector).trigger("zm_init_here");
        });
    };

    var updateContent = function(State) {
        var semSelector = '#zm-' + State.data.mode;
        var parent = State.data.parent;

        if ( $(semSelector).length ) { //content is already in #hidden_content
            $(parent).children().appendTo('#zm-hidden-content');
            $(semSelector).appendTo(parent);
        } else {
            if (parent != '#sem-access') $(parent).children().clone().appendTo('#zm-hidden-content');
            $(parent).html('<div class="zm-content-loading">Loading...</div>');
            loadAjaxContent(parent, State.url, semSelector);
        }

        if ( State.data.mode == 'dashboard' ) {
            $('body').trigger("zm_load_chart");
        }
    };

    // Content update and back/forward button handler
      History.Adapter.bind(window, 'statechange', function() {
        updateContent(History.getState());
    });

    $('body').on('click', 'a.zm-main-nav', function(e) {
        var urlPath = $(this).attr('href');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);

        $(this).parent().parent().find('.zm-active').removeClass('zm-active');
        $(this).parent().addClass('zm-active');

        e.preventDefault();
    });

    //Wizard
    $('body').on('click', '.zm-wizard-nav', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        var nextbutton = $(this);

        if (nextbutton.html() == '<i class="icon-double-angle-left"></i> Back'){
            History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);

            $('.zm-wizard-bottombar').find('.active').removeClass('active');
            $('.zm-wizard-nav-'+mode).addClass('active');

            return false;
        }

        if (mode == 'config_dashboard'){
            History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);

            $('.zm-wizard-bottombar').find('.active').removeClass('active');
            $('.zm-wizard-nav-'+mode).addClass('active');

        }else if (mode == 'config_general'){
            //submit licese data here
            var status = $('#zm-lk-status').val();

            if (status == 1){
                History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);
                $('.zm-wizard-bottombar').find('.active').removeClass('active');
                $('.zm-wizard-nav-'+mode).addClass('active');
            }else{
                nextbutton.html('<i class="icon-refresh icon-spin"></i> Activating...');
                setTimeout(function(){
                    var data = {
                        action: 'zm_activate_me',
                        key: $('#zm_license_key').val(),
                    };

                    $.post(ajaxurl, data, function(response) {
                        nextbutton.html('Next <i class="icon-double-angle-right"></i>');
                        if (response == 'success'){
                            $('.zm-lk-next').hide();
                            $('.zm-lk-message-row-success').fadeIn('fast');
                            $('.zm-lk-message-row').hide();
                            $('.zm-lk-field').hide();
                            $('#zm-lk-status').val(1);
                            setTimeout(function(){
                                History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);
                                $('.zm-wizard-bottombar').find('.active').removeClass('active');
                                $('.zm-wizard-nav-'+mode).addClass('active');
                            }, 500);
                        }else{
                            $('.zm-lk-message').html('<p><b>Error!</b> '+response+'</p>');
                            $('.zm-lk-message-row').fadeIn('fast');
                        }
                    });
                }, 500);
            }
        }else if (mode == 'config_payment'){
            nextbutton.html('<i class="icon-refresh icon-spin"></i> Saving...');
            setTimeout(function(){
                var data = {
                    action: 'zm_config_general',
                    login: $('#zm-login-page').val(),
                    welcome: $('#zm-after-login-page').val(),
                    error: $('#zm-access-error-page').val(),
                    unavailable: $('#zm-unavailable-page').val(),
                    expired: $('#zm-expired-page').val(),
                    profile: $('#zm-profile-page').val(),
                    logout: $('#zm-logout-page').val(),
                };

                $.post(ajaxurl, data, function(response) {
                    nextbutton.html('Next <i class="icon-double-angle-right"></i>');
                    if (response == 'success'){
                        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);
                        $('.zm-wizard-bottombar').find('.active').removeClass('active');
                        $('.zm-wizard-nav-'+mode).addClass('active');
                    }else{
                        alert('Network connection error. Please try again.');
                    }
                });
            }, 500);
        }else if (mode == 'config_email'){
            nextbutton.html('<i class="icon-refresh icon-spin"></i> Saving...');
            setTimeout(function(){
                var data = {
                    action: 'zm_config_payment',
                    za_api: $('#zm-zaxaa-api').val(),
                    pp_email: $('#zm-ppal-email').val(),
                    pp_sandbox: $('#zm-sandbox-off').is(':checked') ? 'off' : 'on',
                    pp_sandbox_email: $('#zm-ppal-sandbox').val(),
                    jv_key: $('#zm-jvzoo-key').val(),
                    cb_key: $('#zm-clickbank-key').val(),
                    os_id: $('#zm-1shoppingcart-id').val(),
                    os_key: $('#zm-1shoppingcart-key').val()
                };

                $.post(ajaxurl, data, function(response) {
                    nextbutton.html('Next <i class="icon-double-angle-right"></i>');
                    if (response == 'success'){
                        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);
                        $('.zm-wizard-bottombar').find('.active').removeClass('active');
                        $('.zm-wizard-nav-'+mode).addClass('active');
                    }else{
                        alert('Network connection error. Please try again.');
                    }
                });
            }, 500);
        }
        e.preventDefault();
    });

    ancestor.delegate('#zm-reset-license', 'click', function(e){
        if (confirm('Are you sure want to reset your license?')){
            $(this).html('<i class="icon-refresh icon-spin"></i> Resetting...');
            return;
        }else{
            e.preventDefault();
            return false;
        }
    });

    ancestor.delegate('.zm-wizard-finish', 'click', function(){
        var url = $(this).data('url');

        $(this).html('<i class="icon-refresh icon-spin"></i> Saving...');
        setTimeout(function(){
            var data = {
                action: 'zm_config_email',
                name: $('#zm-from-name').val(),
                email: $('#zm-from-email').val(),
                mailer: $('#zm-mailer').val(),
                host: $('#zm-smtp-host').val(),
                port: $('#zm-smtp-port').val(),
                encryption: $('#zm-smtp-enc').val(),
                auth: $('#zm-is-auth-off').is(':checked') ? 'off' : 'on',
                username: $('#zm-smtp-username').val(),
                password: $('#zm-smtp-password').val(),
                w_admin: $('#zm-wemail-admin-on').is(':checked') ? 'on' : 'off',
                w_subject: $('#zm-wemail-subject').val(),
                w_body: $('#zm-wemail-body').val(),
                f_subject: $('#zm-femail-subject').val(),
                f_body: $('#zm-femail-body').val()
            };

            $.post(ajaxurl, data, function(response) {
                if (response == 'success'){
                    window.location = url;
                }else{
                    $('.zm-wizard-finish').html('Finish <i class="icon-double-angle-right"></i>');
                    alert('Network connection error. Please try again.');
                }
            });
        }, 500);
    });

    //Pagination
    ancestor.on('click', 'a.zm-pagination', function(e) {
        var urlPath = $(this).attr('href');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        var parent = $(this).data('parent');

        History.pushState({urlPath: urlPath, mode: mode, parent: '#'+parent}, title, urlPath);

        e.preventDefault();
    });

    // SALES REPORT
    ancestor.on('click', '#zm-search-report', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');

        var product = $('#zm_rpt_product').val();
        var status = $('#zm_rpt_txn_status').val();
        var time = $('#zm_rpt_txn_time').val();
        var currency = $('#zm_rpt_txn_currency').val();

        var conditions = '&time='+time;
        var mode = 'reporttime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-rpt-start-exact-search').val();
            var until = $('#zm-rpt-until-exact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&f='+start;
            start = start.replace(find, '');
            mode += 'f'+start;

            conditions += '&t='+until;
            until = until.replace(find, '');
            mode += 't'+until;
        }

        conditions += '&product='+product+'&status='+status+'&currency='+currency+'&p=1';
        mode += 'product'+product+'status'+status+'currency'+currency+'p1';

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-report'}, title, urlPath+conditions);

        e.preventDefault();
    });

    // PERFORMANCE REPORT
    ancestor.on('click', '#zm-search-preport', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');

        var time = $('#zm_txn_ptime').val();

        var conditions = '&ptime='+time;
        var mode = 'reportptime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-start-pexact-search').val();
            var until = $('#zm-until-pexact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&pf='+start;
            start = start.replace(find, '');
            mode += 'pf'+start;

            conditions += '&pt='+until;
            until = until.replace(find, '');
            mode += 'pt'+until;
        }

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-preport'}, title, urlPath+conditions);

        e.preventDefault();
    });

    // ENGAGEMENT REPORT
    ancestor.on('click', '#zm-search-ereport', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');

        var time = $('#zm_txn_etime').val();

        var conditions = '&etime='+time;
        var mode = 'reportetime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-start-eexact-search').val();
            var until = $('#zm-until-eexact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&ef='+start;
            start = start.replace(find, '');
            mode += 'ef'+start;

            conditions += '&et='+until;
            until = until.replace(find, '');
            mode += 'et'+until;
        }

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-ereport'}, title, urlPath+conditions);

        e.preventDefault();
    });

    //ADD FORM
    ancestor.on('click', '.zm-add-new', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);

        e.preventDefault();
    });

    //EDIT FORM
    ancestor.on('click', '.zm-edit-form', function(e) {
        var urlPath = $(this).attr('href');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);

        e.preventDefault();
    });

    //SAVE FORM
    ancestor.on('click', '.zm-save-form', function(e) {
        e.preventDefault();
        var button = $(this);
        var is_valid = jQuery('.zm-required').valid();

        if (is_valid){
            button.html('<i class="icon-refresh icon-spin"></i> Saving...');
            var data = {
                action: 'zm_save_product_wizard',
                pname: $('#zm-product-name').val().replace('"', ''),
                ptype: $('#zm-payment-type-paid').is(':checked') ? 'onetime' : 'free',
                pdownload: $('#zm-download-page').val(),
                pthanksurl: $('#zm-thanks-url').val()
            };

            $.post(ajaxurl, data, function(response) {
                if (response){
                    var urlPath = button.data('url')+response;
                    var title = button.data('title');
                    var mode = button.data('mode')+response;
                    button.html('Next <i class="icon-double-angle-right"></i>');
                    $('#zm-product-name').val('');
                    $('#zm-products').remove();
                    History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-content'}, title, urlPath);
                }else{
                    button.html('Next <i class="icon-double-angle-right"></i>');
                }
            });
        }
    });

    // MEMBER
    ancestor.on('click', '#zm-search-member', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');

        var email = $('#zm-m-email').val();
        var username = $('#zm-m-username').val();
        var lock = $('#zm-m-lock').val();
        var status = $('#zm-m-status').val();
        var time = $('#zm-m-txn-time').val();

        email = email ? email : 'all';
        username = username ? username : 'all';

        var conditions = '&time='+time;
        if (time == 'exactdate'){
            var start = $('#zm-m-start-exact-search').val();
            var until = $('#zm-m-until-exact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&f='+start;
            start = start.replace(find, '');

            conditions += '&t='+until;
            until = until.replace(find, '');
        }

        conditions += '&e='+email+'&u='+username+'&l='+lock+'&m='+status+'&p=1';
        var mode = zm_generate_history_id(conditions);

        mode = 'members'+mode;

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-members'}, title, urlPath+conditions);

        e.preventDefault();
    });

    // PRODUCT
    ancestor.on('click', '#zm-search-product', function(e) {
        var urlPath = $(this).data('url');
        var title = $(this).data('title');

        var product = $('#zm-p-product').val();
        var type = $('#zm-p-type').val();
        var time = $('#zm-p-txn-time').val();
        var op = 'all';
        var od = 'desc';

        product = product ? product : 'all';

        var conditions = '&time='+time;
        var mode = 'productstime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-p-start-exact-search').val();
            var until = $('#zm-p-until-exact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&f='+start;
            start = start.replace(find, '');
            mode += 'f'+start;

            conditions += '&t='+until;
            until = until.replace(find, '');
            mode += 't'+until;
        }

        conditions += '&product='+product+'&ptype='+type+'&op='+op+'&od='+od+'&p=1';
        mode += 'product'+product+'ptype'+type+'op'+op+'od'+od+'p1';

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-products'}, title, urlPath+conditions);

        e.preventDefault();
    });

    //SORTER IN PRODUCT NAME
    ancestor.on('click', '.zm-p-name-sortable', function(e) {
        var urlPath = $('#zm-search-product').data('url');
        var title = $('#zm-search-product').data('title');
        var button = $(this);

        var product = $('#zm-p-product').val();
        var type = $('#zm-p-type').val();
        var time = $('#zm-p-txn-time').val();

        var op = 'all';
        var od = 'desc';

        if (button.hasClass('asc')){
            op = 'desc';
        }else{
            op = 'asc';
        }

        product = product ? product : 'all';

        var conditions = '&time='+time;
        var mode = 'productstime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-p-start-exact-search').val();
            var until = $('#zm-p-until-exact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&f='+start;
            start = start.replace(find, '');
            mode += 'f'+start;

            conditions += '&t='+until;
            until = until.replace(find, '');
            mode += 't'+until;
        }

        conditions += '&product='+product+'&ptype='+type+'&op='+op+'&od='+od+'&p=1';
        mode += 'product'+product+'ptype'+type+'op'+op+'od'+od+'p1';

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-products'}, title, urlPath+conditions);

        e.preventDefault();
    });

    ancestor.on('click', '.zm-p-date-sortable', function(e) {
        var urlPath = $('#zm-search-product').data('url');
        var title = $('#zm-search-product').data('title');
        var button = $(this);

        var product = $('#zm-p-product').val();
        var type = $('#zm-p-type').val();
        var time = $('#zm-p-txn-time').val();

        var op = 'all';
        var od = 'desc';

        if (button.hasClass('asc')){
            od = 'desc';
        }else{
            od = 'asc';
        }

        product = product ? product : 'all';

        var conditions = '&time='+time;
        var mode = 'productstime'+time;
        if (time == 'exactdate'){
            var start = $('#zm-p-start-exact-search').val();
            var until = $('#zm-p-until-exact-search').val();

            var find = new RegExp('/', 'g');

            conditions += '&f='+start;
            start = start.replace(find, '');
            mode += 'f'+start;

            conditions += '&t='+until;
            until = until.replace(find, '');
            mode += 't'+until;
        }

        conditions += '&product='+product+'&ptype='+type+'&op='+op+'&od='+od+'&p=1';
        mode += 'product'+product+'ptype'+type+'op'+op+'od'+od+'p1';

        History.pushState({urlPath: urlPath+conditions, mode: mode, parent: '#sem-products'}, title, urlPath+conditions);

        e.preventDefault();
    });

    // ACCESS CONTENT
    ancestor.delegate('#zm-ac-product', 'change', function(e){
        var urlPath = $(this).data('url');
        var title = $(this).data('title');
        var mode = $(this).data('mode');
        var val= $(this).val();

        if (val != ''){
            urlPath += '&id='+val;
            mode += val;
        }else{
            return;
            e.preventDefault();
        }

        History.pushState({urlPath: urlPath, mode: mode, parent: '#sem-access'}, title, urlPath);
        e.preventDefault();
    });

    $(document).on("zm_init_here", function(e){
        $(this).foundation();

        $('#zm_coupon_apply').chosen();

        $.validator.addMethod("alphanumeric", function(value, element) {
            return this.optional(element) || /^\w+$/i.test(value);
        }, "Please enter only letters, numbers, and underscores");

        $.validator.addMethod("password", function( value, element ) {
            var result = this.optional(element) || /^[A-Za-z0-9`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]{6,50}$/.test(value);
            if ( !result )
                element.focus();
            return result;
        }, "Password must be at least 6 characters, and must not include white space.");

        $('.zm-required').validate({
            submitHandler: function(form) {
               form.submit();
            }, rules: {
                zm_username: {
                    required: true,
                    alphanumeric: true,
                    remote: {
                        url: ajaxurl + '?callback=?&action=zm_checkusername',
                    }
                },

                zm_email: {
                    required: true,
                    email: true,
                    remote: {
                        url: ajaxurl + '?callback=?&action=zm_checkemail&old_email=' + $('#zm_cache_email').val() + '&id=' + $('#zm-nonce').val(),
                    }
                },

                zm_password: {
                    password: true
                },

                zm_repassword: {
                    equalTo: "#zm_password"
                }
            }
        });
    });

    $(window).load(function(){
        $(document).trigger("zm_init_here");
    });

    function zm_number_only(event){
        // Allow: backspace, delete, tab, escape, and enter
        if ( event.keyCode == 46 || event.keyCode == 8 || event.keyCode == 9 || event.keyCode == 27 || event.keyCode == 13 ||
             // Allow: Ctrl+A
            (event.keyCode == 65 && event.ctrlKey === true) ||
             // Allow: home, end, left, right
            (event.keyCode >= 35 && event.keyCode <= 39)) {
                 // let it happen, don't do anything
                 return;
        }
        else {
            // Ensure that it is a number and stop the keypress
            if (event.shiftKey || (event.keyCode < 48 || event.keyCode > 57) && (event.keyCode < 96 || event.keyCode > 105 )) {
                event.preventDefault();
            }
        }
    }

    ancestor.delegate('.zm-create-page', 'click', function(){
        var parent = $(this);
        var id = parent.attr('for');
        var ptitle = $('#zm-product-name').val();
        parent.html('<i class="icon-refresh icon-spin"></i> creating..');

        setTimeout(function(){
            var data = {
                action: 'zm_create_page',
                id: id,
                title: ptitle
            };
            $.post(ajaxurl, data, function(response) {
                setTimeout(function(){
                    //process response here
                    var obj = $.parseJSON(response);
                    $('#'+id).append('<option value="'+obj[0]+'">'+obj[1]+'</option>');
                    $('#'+id).val(obj[0]).attr('selected',true);
                    $('#'+id).change();
                    parent.html('<i class="icon-plus"></i> Create one for me');
                }, 200);
            });
        }, 500);
    });

    ancestor.delegate('.zm-edit-page', 'click', function(){
        var parent = $(this).attr('for');
        var id = $('#'+parent).val();
        var url = $(this).data('url');

        if (id == '-1' || id == ''){
            alert('Please select the post/page within your wordpress.');
        }else{
            window.open(url+''+id+'&action=edit', '_blank');
        }
    });

    ancestor.delegate('.zm-accordion-title', 'click', function(e){
        e.preventDefault();

        //console.log('test');
        var section = $(this).parent().find('.zm-accordion-content');
        var psection = $(this);
        section.slideToggle('fast', function(){
            if (section.is(':hidden')){
                psection.removeClass('active');
            }else{
                psection.addClass('active');
                section.css('overflow', '');
            }
        });
    });

    ancestor.delegate('#zm-coupon-code-type', 'change', function(){
        var value = Number($(this).val());

        if (value == 1){
            $('#zm-coupon-code-type-select-custom').hide();
            $('#zm-coupon-code-type-select').removeClass('large-3');
            $('#zm-coupon-code-type-select').addClass('large-10');
        }else{
            $('#zm-coupon-code-type-select').removeClass('large-10');
            $('#zm-coupon-code-type-select').addClass('large-3');
            $('#zm-coupon-code-type-select-custom').show();
        }
    });

    ancestor.delegate('#zm-addproducts', 'click', function(e){
        e.preventDefault();
        window.location.href = $(this).attr('url');
    });

    ancestor.delegate('#zm-addmember', 'click', function(e){
        e.preventDefault();
        window.location.href = $(this).attr('url');
    });

    ancestor.delegate('#zm-coupon-valid-type', 'change', function(){
        var value = Number($(this).val());

        if (value == 1){
            $('.zm-coupon-valid-type-select-duration').hide();
            $('#zm-coupon-valid-type-select').removeClass('large-4');
            $('#zm-coupon-valid-type-select').addClass('large-10');
        }else{
            $('#zm-coupon-valid-type-select').removeClass('large-10');
            $('#zm-coupon-valid-type-select').addClass('large-4');
            $('.zm-coupon-valid-type-select-duration').show();
        }
    });

    ancestor.delegate('.zm-first-page', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('key');
        var total = Number($('#'+id+'-total').val());
        $('#'+id+'-current').val(1);

        $('.'+id+'-all').hide();
        $('.'+id+'-1').fadeIn();
        $('.'+id+'-status').html('<i class="icon-"></i>1 of '+total);
    });

    ancestor.delegate('.zm-prev-page', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('key');
        var current = Number($('#'+id+'-current').val());
        var total = Number($('#'+id+'-total').val());

        if (current > 1){
            $('#'+id+'-current').val(current-1);

            $('.'+id+'-all').hide();
            $('.'+id+'-'+(current-1)).fadeIn();
            $('.'+id+'-status').html('<i class="icon-"></i>'+(current-1)+' of '+total);
        }
    });

    ancestor.delegate('.zm-next-page', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('key');
        var current = Number($('#'+id+'-current').val());
        var total = Number($('#'+id+'-total').val());

        if (current < total){
            var current = current+1;

            $('#'+id+'-current').val(current);

            $('.'+id+'-all').hide();
            $('.'+id+'-'+current).fadeIn();
            $('.'+id+'-status').html('<i class="icon-"></i>'+current+' of '+total);
        }
    });

    ancestor.delegate('.zm-last-page', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('key');
        var total = Number($('#'+id+'-total').val());
        $('#'+id+'-current').val(total);

        $('.'+id+'-all').hide();
        $('.'+id+'-'+total).fadeIn();
        $('.'+id+'-status').html('<i class="icon-"></i>'+total+' of '+total);
    });

    ancestor.delegate('#zm-autoresponder-provider', 'change', function(){
        $('#zm-autoresponder-list').val('');
        if ($(this).val() == 'custom'){
            $('#zm-nocustom-ar').hide();
            $('#zm-custom-ar').show();
        }else{
            $('#zm-custom-ar').hide();
            $('#zm-nocustom-ar').show();
        }
    });

    ancestor.delegate('#zm-autoresponder-getlist', 'click', function(e){
        e.preventDefault();
        var parent = $(this);
        var prov = $('#zm-autoresponder-provider').val();

        parent.html('<i class="icon-refresh icon-spin"></i> loading..');

        setTimeout(function(){
            if ($('#zm_box_'+prov).length > 0){
                $('.zm-autoresponder-list-box').hide();
                setTimeout(function(){
                    $('#zm_box_'+prov).fadeIn('fast');
                    parent.html('<i class="icon-download-alt"></i> Get List');
                }, 400);
            }else{
                var data = {
                    action: 'zm_autoresponder_get_list',
                    provider: prov
                };
                $.post(ajaxurl, data, function(response) {
                    $('.zm-autoresponder-list-box').hide();
                    setTimeout(function(){
                        //process response here
                        $('#zm-autoresponder-box').append(response);
                        parent.html('<i class="icon-download-alt"></i> Get List');
                    }, 200);
                });
            }
        }, 500);
    });

    ancestor.delegate('.zm-select-list', 'click', function(e){
        e.preventDefault();
        var list = $(this).attr('id');
        $('#zm-autoresponder-list').val(list);
    });

    ancestor.delegate('.zm-create-fr', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('id');
        var url = $(this).data('url');

        $.colorbox({
            opacity: '0.7',
               width: 920,
            href: '#zm-create-fr-box',
            height : "75%",
            fixed :true,
            inline: true,
            onComplete: function(){
                $('#zm-create-fr-box').show();
                $('#zm-rc-product-id').val(id);
                $('#zm-rc-confirmation-text').val(url);
              },
            onClosed: function(){
                $('#zm-create-fr-box').hide();
               }
        });
    });

    ancestor.delegate('#zm_rpt_txn_time', 'change', function(){
        var val = $(this).val();
        var parent = $('#zm_txn_time_parent');

        if (val == 'exactdate'){
            parent.removeClass('large-9');
            parent.addClass('large-3');
            $('.zm-exact-search').show();
        }else{
            if (parent.hasClass('large-3')) parent.removeClass('large-3');
            if (!parent.hasClass('large-9')) parent.addClass('large-9');

            $('.zm-exact-search').hide();
        }
    });

    ancestor.delegate('#zm_txn_ptime', 'change', function(){
        var val = $(this).val();
        var parent = $('#zm_txn_ptime_parent');

        if (val == 'exactdate'){
            parent.removeClass('large-9');
            parent.addClass('large-3');
            $('.zm-pexact-search').show();
        }else{
            if (parent.hasClass('large-3')) parent.removeClass('large-3');
            if (!parent.hasClass('large-9')) parent.addClass('large-9');

            $('.zm-pexact-search').hide();
        }
    });

    ancestor.delegate('#zm_txn_etime', 'change', function(){
        var val = $(this).val();
        var parent = $('#zm_txn_etime_parent');

        if (val == 'exactdate'){
            parent.removeClass('large-9');
            parent.addClass('large-3');
            $('.zm-eexact-search').show();
        }else{
            if (parent.hasClass('large-3')) parent.removeClass('large-3');
            if (!parent.hasClass('large-9')) parent.addClass('large-9');

            $('.zm-eexact-search').hide();
        }
    });

    ancestor.delegate('#zm-m-txn-time', 'change', function(){
        var val = $(this).val();
        var parent = $('#zm_reg_time_parent');

        if (val == 'exactdate'){
            parent.removeClass('large-9');
            parent.addClass('large-3');
            $('.zm-m-exact-search').show();
        }else{
            if (parent.hasClass('large-3')) parent.removeClass('large-3');
            if (!parent.hasClass('large-9')) parent.addClass('large-9');

            $('.zm-m-exact-search').hide();
        }
    });

    ancestor.delegate('#zm-p-txn-time', 'change', function(){
        var val = $(this).val();
        var parent = $('#zm_cre_time_parent');

        if (val == 'exactdate'){
            parent.removeClass('large-9');
            parent.addClass('large-3');
            $('.zm-p-exact-search').show();
        }else{
            if (parent.hasClass('large-3')) parent.removeClass('large-3');
            if (!parent.hasClass('large-9')) parent.addClass('large-9');

            $('.zm-p-exact-search').hide();
        }
    });

    $('body').delegate('#zm-fr-generate', 'click', function(e){
        e.preventDefault();
        var color = $('#zm-rc-template-color').val();
        var headline = $('#zm-rc-headline-text').val();
        var e_firstname = $('#zm-rc-firstname-on').is(':checked');
        var e_lastname = $('#zm-rc-lastname-on').is(':checked');
        var e_username = $('#zm-rc-username-on').is(':checked');
        var e_password = $('#zm-rc-password-on').is(':checked');
        var e_confirmation = $('#zm-rc-confirmation-on').is(':checked');
        var e_recaptcha = $('#zm-rc-recaptcha-on').is(':checked');
        var firstname = $('#zm-rc-firstname-text').val();
        var lastname = $('#zm-rc-lastname-text').val();
        var username = $('#zm-rc-username-text').val();
        var email = $('#zm-rc-email-text').val();
        var button = $('#zm-rc-button-text').val();
        var policy = $('#zm-rc-policy-text').val();
        var powered = $('#zm-rc-powered').val();
        var id = $('#zm-rc-product-id').val();
        var site = $('#zm-rc-site-url').val();
        var public_key = $('#zm-rc-public-key').val();
        var confirmation = e_confirmation ? '&confirmation=true' : '';
        var thankyou = $('#zm-thankyou-page').val();
        var thankyouUrl = $('#zm-thankyou-url').val();

        if (thankyou == ''){
            alert('Please select your Thank You Page');
            return false;
        }

        if (thankyou == 'external' && thankyouUrl.trim() == ''){
            alert('Please input your Thank You Page External URL');
            return false;
        }

        var tmp = '<!-- Easy Quick Member Registration Form Generator 1.0 -->'+"\n"+
        '<style type="text/css">'+"\n"+
        '.semform-field{background:#f1f1f1;color:#555;font-family:"Open Sans", "Helvetica Neue", Helvetica, Helvetica, Arial, sans-serif;font-weight:400;font-style:normal;line-height:1;max-width:400px;-webkit-border-radius:2px;-moz-border-radius:2px;-khtml-border-radius:2px;border-radius:2px;-webkit-box-shadow:0 1px 0 rgba(255,255,255,0.5) inset;box-shadow:0 1px 0 rgba(255,255,255,0.5) inset;border:1px solid #e7e7e7;position:relative;margin:auto;padding:80px 20px 20px !important;}'+"\n"+
        '.semform-head{font-size:18px;font-weight:600;text-align:center;position:absolute;top:0;left:0;right:0;border-bottom:1px solid #fff !important;margin:auto;padding:20px 10px !important;}'+"\n"+
        '.semform-foot{font-size:12px;font-style:italic;text-align:center}'+"\n"+
        '.semform input[type=text], .semform input[type=password]{background-color:#FFF;border:1px solid #ccc;-webkit-box-shadow:inset 0 1px 2px rgba(0,0,0,0.1);box-shadow:inset 0 1px 2px rgba(0,0,0,0.1);display:block;font-size:.875em;height:2.3125em;width:100%;font-family:"Helvetica Neue", Helvetica, Helvetica, Arial, sans-serif;color:#666;-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box;-webkit-transition:0 .45s border-color .45s ease-in-out;-moz-transition:0 .45s border-color .45s ease-in-out;transition:box-shadow .45s border-color .45s ease-in-out;-webkit-border-radius:2px;-moz-border-radius:2px;-khtml-border-radius:2px;border-radius:2px;margin:0 0 1em;padding:.5em .5em .5em 2.9em}'+"\n"+
        '.semform-first_name{background:url(http://74d6fc0293239e6cdc12-1f679650b695f912abd0bf742e7571e7.r95.cf2.rackcdn.com/icon-first_name.png) no-repeat left center}'+"\n"+
        '.semform-last_name{background:url(http://74d6fc0293239e6cdc12-1f679650b695f912abd0bf742e7571e7.r95.cf2.rackcdn.com/icon-last_name.png) no-repeat left center}'+"\n"+
        '.semform-user_name{background:url(http://74d6fc0293239e6cdc12-1f679650b695f912abd0bf742e7571e7.r95.cf2.rackcdn.com/icon-username.png) no-repeat left center}'+"\n"+
        '.semform-password{background:url(http://74d6fc0293239e6cdc12-1f679650b695f912abd0bf742e7571e7.r95.cf2.rackcdn.com/icon-password.png) no-repeat left center}'+"\n"+
        '.semform-email{background:url(http://74d6fc0293239e6cdc12-1f679650b695f912abd0bf742e7571e7.r95.cf2.rackcdn.com/icon-email.png) no-repeat left center}'+"\n"+
        '.semform-submit{-webkit-box-shadow:0 1px 0 rgba(255,255,255,0.5) inset;box-shadow:0 1px 0 rgba(255,255,255,0.5) inset;-webkit-transition:background-color 300ms ease-out;-moz-transition:background-color 300ms ease-out;transition:background-color 300ms ease-out;border:0;width:100%;font-family:Oswald, sans-serif;text-transform:uppercase;font-size:24px;-webkit-border-radius:2px;-moz-border-radius:2px;-khtml-border-radius:2px;border-radius:2px;color:#333;background:#ddd;cursor:pointer;padding:10px 20px}'+"\n"+
        '.semform-submit:hover{background:#666!important}'+"\n"+
        '.semform-submit.blue,.semform-head.blue{color:#fff;background:#008ECA}'+"\n"+
        '.semform-submit.red,.semform-head.red{color:#fff;background:#FF4344}'+"\n"+
        '.semform-submit.green,.semform-head.green{color:#fff;background:#1F7E5C}'+"\n"+
        '.semform-submit.orange,.semform-head.orange{color:#fff;background:#FFB528}'+"\n"+
        '.semform-submit.black,.semform-head.black{color:#fff;background:#252525}'+"\n"+
        '</style>'+"\n";

        if (e_recaptcha){
            tmp += '<script type="text/javascript" src="http://www.google.com/recaptcha/api/js/recaptcha_ajax.js"></script>';
            tmp += '<script>jQuery(document).ready(function(){'+"\n"+
                'Recaptcha.create("'+public_key+'",'+"\n"+
                    '"zm_recaptcha_div",{'+"\n"+
                        'theme: "clean",'+"\n"+
                        'callback: Recaptcha.focus_response_field,'+"\n"+
                        'tabindex : 4'+"\n"+
                        '}'+"\n"+
                    ');'+"\n"+
                '});</script>';
        }

        tmp += '<link href="//fonts.googleapis.com/css?family=Oswald:400,700,300" rel="stylesheet" type="text/css">'+"\n"+
        '<div class="semform-field">'+"\n"+
        '<p class="semform-head '+color+'">'+headline+'</p>'+"\n"+
        '<form class="semform" action="?mode=register&type=free'+confirmation+'" method="POST">'+"\n"+
        '<input type="hidden" name="product_id" value="'+id+'"/>'+"\n";

        if (thankyou){
            if (thankyou == 'external') tmp += '<input type="hidden" name="thanks-url" value="'+thankyouUrl+'"/>'+"\n";
            else tmp += '<input type="hidden" name="thanks-url" value="'+thankyou+'"/>'+"\n";

        }

        if (e_firstname)
            tmp += '<input type="text" name="first_name" class="semform-first_name" placeholder="'+firstname+'"/>'+"\n";

        if (e_lastname)
            tmp += '<input type="text" name="last_name" class="semform-last_name" placeholder="'+lastname+'"/>'+"\n";

        if (e_username)
            tmp += '<input type="text" name="user_name" class="semform-user_name" placeholder="'+username+'"/>'+"\n";

        tmp += '<input type="text" name="email" class="semform-email" placeholder="'+email+'"/>'+"\n";

        if (e_password)
            tmp += '<input type="password" name="password" class="semform-password"/>'+"\n";

        if (e_recaptcha) tmp += '<div id="zm_recaptcha_div"></div>';

        tmp += '<input type="submit" class="semform-submit '+color+'" name="submit" value="'+button+'"/>'+"\n"+
        '</form>'+"\n"+
        '<p class="semform-foot">'+policy+'</p>'+"\n";

        if (powered != 'off')
            tmp += '<p class="semform-foot">powered by <a href="'+powered+'" target="_blank" style="text-decoration:underline;">Easy Quick Member</a></p>'+"\n";

        tmp += '</div>'+"\n"+
        '<!-- /Easy Quick Member Registration Form Generator 1.0 -->';

        var sc_tmp = '[eqm_registration_form id="'+id+'" color="'+color+'" headline="'+headline+'" ';
        if (e_firstname) sc_tmp += 'firstname="'+firstname+'" ';
        if (e_lastname) sc_tmp += 'lastname="'+lastname+'" ';
        if (e_username) sc_tmp += 'username="'+username+'" ';
        sc_tmp += 'email="'+email+'" ';
        if (e_password) sc_tmp += 'password="true" ';
        sc_tmp += 'button="'+button+'" policy="'+policy+'" ';
        if (e_confirmation) sc_tmp += 'confirmation="true" ';
        if (e_recaptcha) sc_tmp += 'recaptcha="true" ';

        if (thankyou){
            if (thankyou == 'external') sc_tmp += 'thanksurl="'+thankyouUrl+'"';
            else sc_tmp += 'thanksurl="'+thankyou+'"';
        }

        sc_tmp += ']';

        setTimeout(function(){
            $('#zm-rc-code').val(tmp);
            $('#zm-sc-code').val(sc_tmp);
        }, 200);
    });

    ancestor.delegate('#zm-add-payment', 'click', function(){
        $.colorbox({
            opacity: '0.7',
               width: 860,
            href: '#zm-edit-payment-box',
            height : "450px",
            fixed :true,
            inline: true,
            onOpen: function(){
                var type = $('#zm-list-product').val();

                if (type){
                    type.split('#');

                    if (type[0]== 'subscription'){
                        $('#zm-subscription').show();
                    }else{
                        $('#zm-subscription').hide();
                    }

                    $('#zm-edit-payment-box .zm-biglabel').html('Add Payment/Subscription');
                    $('#zm-edit-id').val('-1');
                    $('#zm-amount').val('');
                    $('#zm-status-product option[value=1]').attr('selected', true);
                    $('#zm-status-product').change();
                    $('#zm-receipt').val('');
                    $('#zm-currency option[value="USD"]').attr('selected', true);
                    $('#zm-currency').change();
                    $('#zm-submit-payment').val('Add');
                }
            },
            onLoad: function(){
                $('#zm-current-edit-box').hide();
                $('#zm-list-product-box').show();
                $('#zm-edit-payment-box').show();
                $('#zm-is-subscription-box').show();
              },
            onClosed: function(){
                $('#zm-edit-payment-box').hide();
            }
        });
    });

    $('body').delegate('#zm-is-subscription', 'change', function(){
        if ($(this).is(':checked')){
            $('#zm-subscription').show();
        }else{
            $('#zm-subscription').hide();
        }
    });

    $('body').delegate('#is_subscription', 'change', function(){
        if ($(this).is(':checked')){
            $('#zm-subscription').show();
        }else{
            $('#zm-subscription').hide();
        }
    });

    ancestor.delegate('.zm-edit-payment', 'click', function(e){
        e.preventDefault();
        var button = $(this);
        var id = button.attr('id');

        button.html('<i class="icon-spin icon-refresh"></i>');
        var data = {
            action: 'zm_edit_payment',
            id: id
        };
        $('#zm-edit-payment-box .zm-biglabel').html('Edit Payment/Subscription');
        $.post(ajaxurl, data, function(response) {
            button.html('<i class="icon-pencil"></i>');
            if (response != 'false'){
                $.colorbox({
                    opacity: '0.7',
                       width: 860,
                    href: '#zm-edit-payment-box',
                    height : "450px",
                    fixed :true,
                    inline: true,
                    onOpen: function(){
                        var obj = $.parseJSON(response);
                        $('#zm-list-product-box').hide();

                        $('#zm-current-edit').val($('#zm-product-'+id).html());

                        $('#zm-current-edit-box').show();
                        if (obj.type == 'free'){
                            $('#zm-subscription').hide();
                            $('#zm-not-free').hide();
                        }else{
                            $('#zm-is-subscription-box').hide();

                            if (obj.type == 'subscription'){
                                $('#zm-is-subscription').prop('checked', 'checked');
                                $('#zm-subscription').show();
                                $('.zm-begin').val(obj.begin_date);
                                $('.zm-expired').val(obj.expired_date);
                            }else{
                                $('#zm-subscription').hide();
                            }
                            $('#zm-edit-id').val(obj.type+'#'+id);
                            $('#zm-amount').val(obj.amount);
                            $('#zm-status-product option[value='+obj.status+']').attr('selected', true);
                            $('#zm-status-product').change();
                            $('#zm-payment option[value='+obj.paysys+']').attr('selected', true);
                            $('#zm-payment').change();
                            $('#zm-currency option[value='+obj.currency+']').attr('selected', true);
                            $('#zm-currency').change();
                            $('#zm-receipt').val(obj.receipt);
                            $('#zm-submit-payment').val('Save Changes');
                            $('#zm-not-free').show();
                        }
                    },
                    onLoad: function(){
                        $('#zm-edit-payment-box').show();
                      },
                    onClosed: function(){
                        $('#zm-edit-payment-box').hide();
                       }
                });
            }
        });
    });

    $('body').delegate('.gpf-switch', 'click', function(){
        var id = $(this).attr('id');
        if ($('#'+id+'-on').is(":checked")){
            $('#'+id+'-off').attr('checked', false);
            $('#'+id+'-on').attr('checked', true);
            $('#'+id+'_field').fadeIn('fast');
        }else if ($('#'+id+'-off').is(":checked")){
            $('#'+id+'-on').attr('checked', false);
            $('#'+id+'-off').attr('checked', true);
            $('#'+id+'_field').fadeOut('fast');
        }
    });

    ancestor.delegate('.zm-payment-type', 'change', function(){
        var value = $(this).val();

        if (value == 'onetime'){
            $('.zm-payment-type-r').fadeOut('fast');
            setTimeout(function(){$('.zm-payment-type-o').fadeIn('fast');}, 200);
        }else if (value == 'subscription'){
            $('.zm-payment-type-o').fadeOut('fast');
            setTimeout(function(){$('.zm-payment-type-r').fadeIn('fast');}, 200);
        }
    });

    ancestor.delegate('.zm-payment-type-main', 'click', function(){
        var value = $(this).find('input').val();

        if (value == 'free'){
            $('.zm-payment-processor-box').slideUp('fast');
        }else{
            $('.zm-payment-processor-box').slideDown('fast');
        }
    });

    ancestor.delegate('#zm-download-page', 'change', function(){
        var value = $(this).val();

        if (value == '-1'){
            $('#zm-external-url').slideDown();
            $('#zm-thanks-url').addClass("required url");
        }else{
            $('#zm-external-url').slideUp();
            $('#zm-thanks-url').removeClass("required url");
        }
    });

    $('body').delegate('#zm-thankyou-page', 'change', function(){
        var value = $(this).val();
        if (value == 'external'){
            $('#zm-thankyou-url-box').slideDown();
        }else{
            $('#zm-thankyou-url-box').slideUp();
        }
    });

    ancestor.delegate('.zm-select-all', 'click', function(){
        var parent = $(this).parent().parent().parent().parent();

        if ($(this).is(":checked")){
            $('.zm-select').attr('checked', true);
            var tr = parent.find('tr');
            tr.each(function(){
                if ($(this).hasClass('zm-row')) $(this).addClass('zm-row-selected');
            });
        }else{
            $('.zm-select').attr('checked', false);
            var tr = parent.find('tr');
            tr.each(function(){
                if ($(this).hasClass('zm-row')) $(this).removeClass('zm-row-selected');
            });
        }
    });

    var select_type = ["post", "page", "category", "file", "s3"];

    $.each( select_type, function( key, value ) {
        ancestor.delegate('.zm-select-all'+value, 'click', function(){
            var parent = $(this).parent().parent().parent().parent();
            var pa;

            if ($(this).is(":checked")){
                parent.find('.zm-select'+value).attr('checked', true);
                var tr = parent.find('tr');
                tr.each(function(){
                    pa = $(this).find('.zm-private-access');

                    if ($(this).hasClass('zm-row')) {
                        $(this).addClass('zm-row-selected');
                        $(this).find('.zm-public-access').hide();
                        pa.find('div:eq(1) select').prop('disabled', '');
                        pa.find('.zm-ac-use-end').attr('checked', false);
                        pa.find('.zm-ac-use-end').prop('disabled', '');
                        pa.find('input.zm-start-value').prop('disabled', '');
                        pa.find('select.zm-start-dp-value').prop('disabled', '');

                        pa.show();
                    }
                });
            }else{
                parent.find('.zm-select'+value).attr('checked', false);
                var tr = parent.find('tr');
                tr.each(function(){
                    pa = $(this).find('.zm-private-access');

                    if ($(this).hasClass('zm-row')) {
                        $(this).removeClass('zm-row-selected');
                        pa.hide();
                        pa.find('.zm-ac-use-end').attr('checked', false);
                        pa.find('input').prop('disabled', 'disabled');
                        pa.find('select').prop('disabled', 'disabled');

                        $(this).find('.zm-public-access').show();
                    }
                });
            }
        });
    });

    ancestor.delegate('.zm-select', 'click', function(){
        var parent = $(this).parent().parent();
        var pa = parent.find('.zm-private-access');

        if (parent.hasClass('zm-row')){
            if ($(this).is(":checked")){
                parent.addClass('zm-row-selected');
                parent.find('.zm-public-access').hide();
                pa.find('div:eq(1) select').prop('disabled', '');
                pa.find('.zm-ac-use-end').attr('checked', false);
                pa.find('.zm-ac-use-end').prop('disabled', '');
                pa.find('input.zm-start-value').prop('disabled', '');
                pa.find('select.zm-start-dp-value').prop('disabled', '');

                pa.show();
            }else{
                parent.removeClass('zm-row-selected');
                pa.hide();
                pa.find('.zm-ac-use-end').attr('checked', false);
                pa.find('input').prop('disabled', 'disabled');
                pa.find('select').prop('disabled', 'disabled');
                parent.find('.zm-public-access').show();
            }
        }
    });

    ancestor.delegate('.zm-lock', 'click', function(e){
        e.preventDefault();
        var mid = $(this).attr('mid');
        var stat = $(this).attr('status');

        $(this).attr('status', ((stat == '1') ? 0 : 1));

        (stat == '1') ? $(this).attr('title', 'unlock this member') : $(this).attr('title', 'lock this member');
        (stat == '1') ? $(this).html('<i class="icon-unlock"></i>') : $(this).html('<i class="icon-lock"></i>');

        var data = {
            action: 'zm_lock',
            id: mid,
            status : (stat == '1') ? 0 : 1
        };

        $.post(ajaxurl, data, function(response) {
            if (response == 'success'){
                if (stat == '1'){
                    $('#zm-status-'+mid).removeClass('icon-ok');
                    $('#zm-status-'+mid).attr('title', 'locked');
                    $('#zm-status-'+mid).parent().removeClass('success');
                    $('#zm-status-'+mid).addClass('icon-lock');
                    $('#zm-status-'+mid).parent().addClass('alert');
                }else{
                    $('#zm-status-'+mid).attr('title', 'active');
                    $('#zm-status-'+mid).removeClass('icon-lock');
                    $('#zm-status-'+mid).parent().removeClass('alert');
                    $('#zm-status-'+mid).addClass('icon-ok');
                    $('#zm-status-'+mid).parent().addClass('success');
                }
            }
        });
    });

    ancestor.delegate('.zm-resend', 'click', function(e){
        e.preventDefault();
        var btn = $(this);
        var id = btn.data('rid');

        btn.html('<i class="icon-refresh icon-spin"></i>');
        var data = {
            action: 'zm_resend',
            id: id,
        };

        $.post(ajaxurl, data, function(response) {
            if (response == 'success'){
                alert('Email sent!');
            }
            btn.html('<i class="icon-envelope"></i>');
        });
    });

    ancestor.delegate('.zm-start-value', 'keydown', function(event) {
        zm_number_only(event);
    });

    ancestor.delegate('.zm-end-value', 'keydown', function(event) {
        zm_number_only(event);
    });



    /* CONFIGURATION JS */
    ancestor.delegate('#zm-mailer', 'change', function(){
        var mailer = $(this).val();

        if (mailer == 'php') $('#zm-mailer-smtp').slideUp('fast');
        else $('#zm-mailer-smtp').slideDown('slow');
    });

    $('body').delegate(".zm-tabs-menu li", 'click', function(e){
        var id = $(this).attr('id');
        var menu = $(this).parent();
        $(menu).find('li').removeClass('zm-tabs-active');
        $(menu).parent().find('div.zm-tabs-content').hide();

        $(this).addClass('zm-tabs-active');
        $('div.' + id).show();

        $.cookie('zm_tabs_menu', id, { expires: 7, path: '/' });

        if ( id == 'creator' )
            $('#zm-submit').val('Create Page(s)');
        else
            $('#zm-submit').val('Save Changes');
        e.preventDefault();
    });

    ancestor.delegate(".zm-tabs-menu-nested li", 'click', function(){
        var id = $(this).attr('id');
        var menu = $(this).parent();
        $(menu).find('li').removeClass('zm-tabs-active');
        $(menu).parent().find('div.zm-tabs-content-nested').hide();

        $(this).addClass('zm-tabs-active');
        $('div.' + id).show();

        $.cookie('zm_tabs_menu_nested', id, { expires: 7, path: '/' });

        return false;
    });

    ancestor.delegate(".zm-tabs-menu-nestedception li", 'click', function(){
        var id = $(this).attr('id');
        var menu = $(this).parent();
        $(menu).find('li').removeClass('zm-tabs-active');
        $(menu).parent().find('div.zm-tabs-content-nestedception').hide();

        $(this).addClass('zm-tabs-active');
        $('div.' + id).show();

        var s3regex = new RegExp('s3filesprotect');
        var filereges = new RegExp('filesprotect');

        if (s3regex.test(id)){
            if ($('#zm-table-'+id).length > 0){
                return false;
            }else{
                var data = {
                    action: 'zm_az_getlists',
                    id: $('#zm-ac-product').val()
                };

                $.post(ajaxurl, data, function(response) {
                    if (response != 'failed'){
                        $('#zm-s3files-load').hide();
                        $('.'+id).prepend(response);
                        //$('.'+id).trigger("zm_init_here");
                    }
                });
            }
        }else if (filereges.test(id)){
            if ($('#zm-table-'+id).length > 0){
                return false;
            }else{
                var data = {
                    action: 'zm_local_getfiles',
                    id: $('#zm-ac-product').val()
                };

                $.post(ajaxurl, data, function(response) {
                    if (response != 'failed'){
                        $('#zm-files-load').hide();
                        $('.'+id).html(response);
                    }
                });
            }
        }
        $.cookie('zm_tabs_menu_nestedception', id, { expires: 7, path: '/' });
        return false;
    });

    $('body').delegate('#zm-list-product', 'change', function(){
        var ptype = $(this).val();

        ptype = ptype.split('#');

        if (ptype[0] == 'free'){
            $('#zm-subscription').hide();
            $('#zm-not-free').hide();
        }else{
            if (ptype[0] == 'subscription'){
                $('#zm-subscription').fadeIn('fast');
            }else{
                $('#zm-subscription').hide();
            }

            $('#zm-not-free').fadeIn();
        }
    });

    /*PROTECT CONTENT JS*/
    ancestor.delegate('#zm-az-bucket', 'change', function(){
        var parent = $(this);
        var bucket = parent.val();
        var id = $(this).data('product');


        if (bucket != '-1'){
            $('.bucket-s3').hide();
            $('#zm-s3files-load').show();

            if ($('#bucket-s3-'+bucket).length > 0){
                setTimeout(function(){
                    $('#zm-s3files-load').hide();
                    $('#bucket-s3-'+bucket).show('fast');
                }, 400);
            }else{

                var data = {
                    action: 'zm_az_getfiles',
                    bucket: bucket,
                    id: $('#zm-ac-product').val()
                };

                $.post(ajaxurl, data, function(response) {
                    if (response != 'failed'){
                        $('#zm-s3files-load').hide();
                        $('.'+id).append(response);
                        $('.'+id).trigger("zm_init_here");
                    }
                });
            }
        }
    });

    ancestor.delegate('.zm-get-download-url', 'click', function(e){
        e.preventDefault();

        var id = $(this).attr('id');
        var url = $('#zm_site_url').val();

        $.colorbox({
            opacity: '0.7',
               width: '50%',
            href: '#zm-download-url-box',
            height: 0,
            fixed :true,
            inline: true,
            onComplete: function(){
                $('#zm-download-url-box').show();
                $('#zm-download-url').val(url+'/?mode=download&file='+id);
                $('#cboxClose').hide();
                $.colorbox.resize();
              },
              onClosed: function(){
                  $('#zm-download-url-box').hide();
              }
        });
    });

    ancestor.delegate('.zm-ca-changemode', 'change', function(){
        var ak = $(this).attr('accesskey');
        var val = $(this).val();

        if (val == 'X'){
            $('#numb'+ak).hide();
            $('#date'+ak).removeAttr('disabled');
            $('#date'+ak).show();
        }else{
            $('#date'+ak).hide();
            $('#date'+ak).prop('disabled', 'disabled');
            $('#numb'+ak).show();
        }
    });

    ancestor.delegate('.zm-ac-use-end', 'click', function(){
        if ($(this).is(":checked")){
            $(this).parent().parent().parent().find('input:text').attr('disabled', false);
            $(this).parent().parent().parent().find('select').attr('disabled', false);
        }else{
            $(this).parent().parent().parent().find('input:text').attr('disabled', true);
            $(this).parent().parent().parent().find('select').attr('disabled', true);
        }
    });

    ancestor.delegate('.zm-get-s3-download-url', 'click', function(e){
        e.preventDefault();

        var id = $(this).attr('id');

        $.colorbox({
            opacity: '0.7',
               width: '50%',
            href: '#zm-download-url-box',
            height: 0,
            fixed :true,
            inline: true,
            onComplete: function(){
                $('#zm-download-url-box').show();
                $('#zm-download-url').val($('#zm_site_url').val()+'/?mode=download&file='+id);
                $('#cboxClose').hide();
                $.colorbox.resize();
              },
              onClosed: function(){
                  $('#zm-download-url-box').hide();
              }
        });
    });

    ancestor.delegate('.zm-eng-detail-page', 'click', function(e){
        e.preventDefault();

        var button = $(this);
        var id = button.data('member');
        var lcont = button.html();

        button.html('<i class="icon-spin icon-refresh"></i>');

        var time = $('#zm_txn_etime').val();
        var start = $('#zm-start-eexact-search').val();
        var until = $('#zm-until-eexact-search').val();

        var data = {
            action: 'zm_eng_detail_page',
            id: id,
            time: time,
            f:start,
            t:until
        };

        $.post(ajaxurl, data, function(response) {
            button.html(lcont);

            if (response != 'failed'){
                $.colorbox({
                    opacity: '0.7',
                       width: '50%',
                    href: '#zm-eng-box',
                    height: 0,
                    fixed :true,
                    inline: true,
                    onComplete: function(){
                        $('#zm-eng-box').html(response);
                        $('#zm-eng-box').show();
                        $('#cboxClose').hide();
                        $.colorbox.resize();
                      },
                      onClosed: function(){
                          $('#zm-eng-box').hide();
                      }
                });
            }
        });
    });

    ancestor.delegate('.zm-eng-detail-ip', 'click', function(e){
        e.preventDefault();

        var button = $(this);
        var id = button.data('member');
        var lcont = button.html();

        button.html('<i class="icon-spin icon-refresh"></i>');

        var time = $('#zm_txn_etime').val();
        var start = $('#zm-start-eexact-search').val();
        var until = $('#zm-until-eexact-search').val();
        var geo = $('#zm-eng-geotagging').is(':checked') ? 1 : 0;
        var data = {
            action: 'zm_eng_detail_ip',
            id: id,
            time: time,
            f:start,
            t:until,
            geo:geo
        };

        $.post(ajaxurl, data, function(response) {
            button.html(lcont);

            if (response != 'failed'){
                $.colorbox({
                    opacity: '0.7',
                       width: '50%',
                    href: '#zm-eng-box',
                    height: 0,
                    fixed :true,
                    inline: true,
                    onComplete: function(){
                        $('#zm-eng-box').html(response);
                        $('#zm-eng-box').show();
                        $('#cboxClose').hide();
                        $.colorbox.resize();
                      },
                      onClosed: function(){
                          $('#zm-eng-box').hide();
                      }
                });
            }
        });
    });

    //DATEPICKER
    $('body').delegate('.zm-begin', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    $('body').delegate('.zm-expired', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('.zm-start-dp-value', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('.zm-end-dp-value', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-rpt-start-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-rpt-until-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-start-pexact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-until-pexact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-start-eexact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-until-eexact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-m-start-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-m-until-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-p-start-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-p-until-exact-search', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-coupon-valid-from', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('#zm-coupon-valid-until', 'mouseenter', function(){
        $(this).fdatepicker();
    });

    ancestor.delegate('.zm-show-order-url', 'click', function(e){
        e.preventDefault();
        var id = $(this).attr('id');
        var link = $(this);

        link.html('<i class="icon-refresh icon-spin"></i>');
        if (id > 0){
            var data = {
                action: 'zm_display_order_url',
                id: id
            };

            $.post(ajaxurl, data, function(response) {
                link.html('<i class="icon-link"></i>');
                if (response != 'failed'){
                    $.colorbox({
                        opacity: '0.7',
                           width: 920,
                        href: '#zm_order_url_box',
                        height : "250px",
                        fixed :true,
                        inline :true,
                        onLoad: function(){
                            var obj = $.parseJSON(response);
                            var i=0;
                            for (i=0; i<obj.length; i++){
                                if (obj[i] == 'paypal'){
                                    $('#zm-pp-order-url').val($('#zm-site-url').val()+'/?sem_order=paypal&sem_id='+id);
                                    $('.zm-pp-order-box').show();
                                }else if (obj[i] == 'zaxaa'){
                                    $('.zm-zx-order-box').show();
                                }else if (obj[i] == 'jvzoo'){
                                    $('.zm-jv-order-box').show();
                                }else{
                                    var clickbank = obj[i].split('|');
                                    $('#zm-cb-order-url').val('http://'+clickbank[1]+'.'+clickbank[0]+'.pay.clickbank.net');
                                    $('.zm-cb-order-box').show();
                                }
                            }
                        },
                        onComplete: function(){
                            $('#zm_order_url_box').show();
                            $.colorbox.resize();
                        },
                        onClosed: function(){
                            $('.zm-order-404').hide();
                            $('.zm-pp-order-box').hide();
                            $('.zm-cb-order-box').hide();
                            $('.zm-zx-order-box').hide();
                            $('.zm-jv-order-box').hide();
                            $('#zm_order_url_box').hide();

                        }
                    });
                }else{
                    alert('Network connection error. Please try again.');
                }
            });
        }
    });

    ancestor.delegate('.zm-delete-item', 'click', function (e){
        e.preventDefault();
        var link = $(this);
        var parent = $(this).parent().parent().parent();
        var id = $(this).attr('id');

        link.html('<i class="icon-refresh icon-spin"></i>');
        if(confirm('Are you sure want to delete this?')){
            var data = {
                action : 'zm_delete_item',
                id : id
            };

            $.post(ajaxurl, data, function(response) {
                if (response != 'failed'){
                    parent.fadeOut();
                }else{
                    alert("Can't delete this item. Please try again!");
                    link.html('<i class="icon-trash"></i>');
                    return false;
                }
            });
        }else{
            link.html('<i class="icon-trash"></i>');
            return false;
        }
    });

    ancestor.delegate('.zm-clone-product', 'click', function(e){
        e.preventDefault();
        $(this).html('<i class="icon-refresh icon-spin"></i>');

        var link = $(this);
        var parent = $(this).parent().parent().parent();
        var id = $(this).attr('id');

        var data = {
            action : 'zm_clone_product',
            id : id
        };

        $.post(ajaxurl, data, function(response) {
            if (response != 'failed'){
                location.reload();
            }
        });
    });

    ancestor.delegate('.zm-test-email', 'click', function(e){
        var button = $(this);
        var email = $('#zm-test-email').val();

        if (email.trim() != ''){
            button.html('<i class="icon-refresh icon-spin"></i> Sending...');
            var data = {
                action: 'zm_test_mail',
                email: email
            };

            $.post(ajaxurl, data, function(response) {
                if (response == 'sent'){
                    alert('Please check your inbox (also check your spam/junk folder)!');
                }else{
                    alert('Failed!');
                }
                button.html('<i class="icon-share-alt"></i> Send Test Email');
            });
        }else{
            alert('Please enter your email address on the field given.');
        }
    });

    ancestor.delegate('.zm-get-url', 'click', function(e){
        e.preventDefault();
        var page = $(this).data('id');
        var id = $('#'+page).val();
        var button = $(this);

        button.html('<i class="icon-spin icon-refresh"></i>');
        if (id){
            var data = {
                action: 'zm_get_welcome_url',
                id: id
            };

            $.post(ajaxurl, data, function(response) {
                button.html('<i class="icon-link"></i> Get URL');
                $.colorbox({
                    opacity: '0.7',
                       width: '50%',
                    href: '#zm-welcome-url-box',
                    height: 0,
                    fixed :true,
                    inline: true,
                    onComplete: function(){
                        $('#zm-welcome-url-box').show();
                        $('#zm-welcome-url').val(response);
                        $('#zm-welcome-url').select();
                        $('#cboxClose').hide();
                        $.colorbox.resize();
                      },
                      onClosed: function(){
                          $('#zm-welcome-url-box').hide();
                      }
                });
            });
        }
    });

    //EXPORT/IMPORT
    ancestor.delegate('#zm-import-d', 'click', function(e){
        var button = $(this);
        button.html('<i class="icon-spin icon-refresh"></i> uploading...');
        return;
    });

    ancestor.delegate('#zm-import-m', 'click', function(e){
        var button = $(this);
        button.html('<i class="icon-spin icon-refresh"></i> uploading...');
        return;
    });

    ancestor.delegate('#zm-import-preview', 'click', function (e){
        e.preventDefault();

        var product = $('#zm-product-apply').val(),
            allex = 1,
            button = $(this),
            types = $('select[name="zm_row_type[]"]'),
            fields = new Array(),
            i = 0,
            duplicate = 0,
            fieldsname = {
                fname: 'First Name',
                lname: 'Last Name',
                username: 'Username',
                email: 'Email'
            };

        types.each(function(){
            if($(this).val() != 'ex'){

                if ($(this).val() == 'email') allex = 0;

                if (zm_contains(fields, $(this).val())){
                    alert('Duplicate type: "'+fieldsname[$(this).val()]+'". Please select different type for each column');
                    duplicate = 1;
                    return false;
                }
            }

            fields.push($(this).val());
        });

        if (allex){
            alert('Please specify the type of each column (at least email column must be specified)');
            return;
        }

        if (product == 'x'){
            alert('Please select which product/level will be assigned for imported users');
            return;
        }

        if (duplicate) return;

        var value1 = $('[name="zm_preview_1[]"]');

        value1.each(function(){
            if(fields[i] != 'ex'){
                var elm = '<div class="large-2 gpf-columns"><span class="prefix radius">'+fieldsname[fields[i]]+'</span></div>';
                elm += '<div class="large-10 gpf-columns"><input type="text" name="zm_preview_input" value="'+$(this).val()+'" readonly="readonly"/></div>';

                $('#zm-preview-panel1').append(elm);
            }
            i++;
        });
        var product_elm = '<div class="large-2 gpf-columns"><span class="prefix radius">Assigned to product</span></div>';
        product_elm += '<div class="large-10 gpf-columns"><input type="text" name="zm_preview_input" value="'+$('#zm-product-apply option[value="'+product+'"]').text()+'" readonly="readonly"/></div>';
        $('#zm-preview-panel1').append(product_elm);

        var i = 0;
        var value2 = '';
        if ($('.zm_preview_2').length){
            $('#zm-preview-tape2').show();
            $('#zm-preview-panel2').show();
            value2 = $('[name="zm_preview_2[]"]');
            value2.each(function(){
                if(fields[i] != 'ex'){
                    var elm = '<div class="large-2 gpf-columns"><span class="prefix radius">'+fieldsname[fields[i]]+'</span></div>';
                    elm += '<div class="large-10 gpf-columns"><input type="text" name="zm_preview_input" value="'+$(this).val()+'" readonly="readonly"/></div>';

                    $('#zm-preview-panel2').append(elm);
                }
                i++;
            });
            $('#zm-preview-panel2').append(product_elm);
        }else{
            $('#zm-preview-tape2').hide();
            $('#zm-preview-panel2').hide();
        }

        $('#zm-table-box').hide();
        $('#zm-preview-box').fadeIn();
    });

    ancestor.delegate('#zm-import-back', 'click', function (e){
        $('#zm-preview-box').hide();
        $('#zm-table-box').fadeIn();
        $('#zm-preview-panel1').html('');
        $('#zm-preview-panel2').html('');
    });

    ancestor.delegate('#zm-import-finish', 'click', function(e){
        e.preventDefault();
        if (confirm('Are you sure want to import all members data to Zaxaa Member?')){
            $('body').append('<div class="zm-loading-bg"><i class="icon-spin icon-refresh"></i> Importing...</div>');
            $('#zm-csv-form').submit();
        }

        return;
    });

    // PAGES CREATOR
    var i = 0;
    var n = 1;
    ancestor.delegate('.zm-create-page-form', 'click', function (e){
        e.preventDefault();
        var pages = $('.zm_creator_num').val(),
        title = $('.zm_creator_product').val();
        for ( var l = 0; l < pages; l++ ) {
            $('#zm-parent-fields')
            .clone()
            .appendTo('#zm-creator-placeholder')
            .attr('id', 'zm-parent-fields-' + i)
            .show();

            $('#zm-parent-fields-' + i).find('.parent_num').val(i);
            $('#zm-parent-fields-' + i).find('.zm_page_title').attr('name', 'zm_creator[zm_page_title][]').val(title + ' Module ' + n);
            $('#zm-parent-fields-' + i).find('.zm_page_status').attr('name', 'zm_creator[zm_page_status][]');

            i++; n++;
        }

        $('#zm-creator-main-fields').hide();
        $('#zm-new-page-add').show();
        $('.creator_state').val(1);
    });

    ancestor.delegate('.zm-delete-all', 'click', function (e){
        e.preventDefault();

        var button = $(this);

        if (confirm('Are you sure you want to'+button.text()+'?')){
            if (confirm('Are you really sure you want to'+button.text()+'?')){
                var type = $(this).data('type');
                $('body').append('<div class="zm-loading-bg"><i class="icon-spin icon-refresh"></i> Deleting...</div>');

                var data = {
                    action: 'zm_truncate',
                    id: type
                };

                $.post(ajaxurl, data, function(response) {
                    if(response == 'success'){
                        location.reload();
                    }else{
                        alert('Network connection error. Please try again.');
                        location.reload();
                    }
                });
            }
        }

        return;
    });

    ancestor.delegate('.zm-add-page', 'click', function (e){
        e.preventDefault();
        var title = $('.zm_creator_product').val();
        $('#zm-parent-fields')
            .clone()
            .appendTo('#zm-creator-placeholder')
            .attr('id', 'zm-parent-fields-' + i)
            .show();

        $('#zm-parent-fields-' + i).find('.parent_num').val(i);
        $('#zm-parent-fields-' + i).find('.zm_page_title').attr('name', 'zm_creator[zm_page_title][]').val(title + ' Module ' + n);
        $('#zm-parent-fields-' + i).find('.zm_page_status').attr('name', 'zm_creator[zm_page_status][]');
        i += 1; n += 1;
    });

    var j = 0;
    ancestor.delegate('.zm-add-child-page', 'click', function (e){
        e.preventDefault();
        var parent = $(this).parent().parent(),
        id = parent.attr('id'),
        num = parent.find('.parent_num').val(),
        p = parseInt(num) + 1,
        c = parseInt(parent.find('.child_num').val()) + 1,
        title = $('.zm_creator_product').val();

        $('#zm-child-fields')
            .clone()
            .appendTo('#' + id)
            .attr('id', 'zm-child-fields-' + j)
            .show();

        $('#zm-child-fields-' + j).find('.zm_child_title').attr('name', 'zm_creator[zm_child_title][' + num + '][]').val(title + ' Module ' + p + ' - Content ' + c);
        $('#zm-child-fields-' + j).find('.zm_child_status').attr('name', 'zm_creator[zm_child_status][' + num + '][]');
        parent.find('.child_num').val(c);
        j += 1;
    });

    ancestor.delegate('.zm-remove-page', 'click', function (e){
        e.preventDefault();
        $(this).parent().parent().remove();
    });

    ancestor.delegate('.zm-creator-dismiss', 'click', function (e){
        e.preventDefault();
        $('#zm-creator-success').fadeOut("medium");
    });

    $('body').delegate('.zm_submit_form', 'click', function(){
        var is_valid = jQuery('.zm-required').valid();

        if (is_valid){
            $('body').append('<div class="zm-loading-bg"><i class="icon-spin icon-refresh"></i> Saving...</div>');
            return;
        }
    });

    ancestor.delegate('#zm-1shoppingcart-test', 'click', function(e){
        var button = $(this);
        button.html('<i class="icon-spin icon-refresh"></i>');

        var data = {
            action: 'zm_1shoppingcart_test',
            id: $('#zm-1shoppingcart-id').val(),
            key: $('#zm-1shoppingcart-key').val()
        };

        $.post(ajaxurl, data, function(response) {
            button.html('<i class="icon-external-link"></i> Test');
            if(response == 'success'){
                alert('The test notification successfully sent.');
            }else{
                alert(response);
            }
        });
    });

    $('body').delegate('#zm-pp-wizard', 'change', function(){
        $('.zm-pp-wizard-field').hide();

        var id = $(this).val();
        $('#zm-pp-'+id).fadeIn('fast');
    });
})(jQuery);

function md5 (str) {
      // http://kevin.vanzonneveld.net
      // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
      // + namespaced by: Michael White (http://getsprink.com)
      // +    tweaked by: Jack
      // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // +      input by: Brett Zamir (http://brett-zamir.me)
      // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // -    depends on: utf8_encode
      // *     example 1: md5('Kevin van Zonneveld');
      // *     returns 1: '6e658d4bfcb59cc13f96c14450ac40b9'
      var xl;

      var rotateLeft = function (lValue, iShiftBits) {
        return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
      };

      var addUnsigned = function (lX, lY) {
        var lX4, lY4, lX8, lY8, lResult;
        lX8 = (lX & 0x80000000);
        lY8 = (lY & 0x80000000);
        lX4 = (lX & 0x40000000);
        lY4 = (lY & 0x40000000);
        lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
        if (lX4 & lY4) {
          return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
        }
        if (lX4 | lY4) {
          if (lResult & 0x40000000) {
            return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
          } else {
            return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
          }
        } else {
          return (lResult ^ lX8 ^ lY8);
        }
      };

      var _F = function (x, y, z) {
        return (x & y) | ((~x) & z);
      };
      var _G = function (x, y, z) {
        return (x & z) | (y & (~z));
      };
      var _H = function (x, y, z) {
        return (x ^ y ^ z);
      };
      var _I = function (x, y, z) {
        return (y ^ (x | (~z)));
      };

      var _FF = function (a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(_F(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
      };

      var _GG = function (a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(_G(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
      };

      var _HH = function (a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(_H(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
      };

      var _II = function (a, b, c, d, x, s, ac) {
        a = addUnsigned(a, addUnsigned(addUnsigned(_I(b, c, d), x), ac));
        return addUnsigned(rotateLeft(a, s), b);
      };

      var convertToWordArray = function (str) {
        var lWordCount;
        var lMessageLength = str.length;
        var lNumberOfWords_temp1 = lMessageLength + 8;
        var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
        var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
        var lWordArray = new Array(lNumberOfWords - 1);
        var lBytePosition = 0;
        var lByteCount = 0;
        while (lByteCount < lMessageLength) {
          lWordCount = (lByteCount - (lByteCount % 4)) / 4;
          lBytePosition = (lByteCount % 4) * 8;
          lWordArray[lWordCount] = (lWordArray[lWordCount] | (str.charCodeAt(lByteCount) << lBytePosition));
          lByteCount++;
        }
        lWordCount = (lByteCount - (lByteCount % 4)) / 4;
        lBytePosition = (lByteCount % 4) * 8;
        lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
        lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
        lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
        return lWordArray;
      };

      var wordToHex = function (lValue) {
        var wordToHexValue = "",
          wordToHexValue_temp = "",
          lByte, lCount;
        for (lCount = 0; lCount <= 3; lCount++) {
          lByte = (lValue >>> (lCount * 8)) & 255;
          wordToHexValue_temp = "0" + lByte.toString(16);
          wordToHexValue = wordToHexValue + wordToHexValue_temp.substr(wordToHexValue_temp.length - 2, 2);
        }
        return wordToHexValue;
      };

      var x = [],
        k, AA, BB, CC, DD, a, b, c, d, S11 = 7,
        S12 = 12,
        S13 = 17,
        S14 = 22,
        S21 = 5,
        S22 = 9,
        S23 = 14,
        S24 = 20,
        S31 = 4,
        S32 = 11,
        S33 = 16,
        S34 = 23,
        S41 = 6,
        S42 = 10,
        S43 = 15,
        S44 = 21;

      str = utf8_encode(str);
      x = convertToWordArray(str);
      a = 0x67452301;
      b = 0xEFCDAB89;
      c = 0x98BADCFE;
      d = 0x10325476;

      xl = x.length;
      for (k = 0; k < xl; k += 16) {
        AA = a;
        BB = b;
        CC = c;
        DD = d;
        a = _FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
        d = _FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
        c = _FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
        b = _FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
        a = _FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
        d = _FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
        c = _FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
        b = _FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
        a = _FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
        d = _FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
        c = _FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
        b = _FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
        a = _FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
        d = _FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
        c = _FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
        b = _FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
        a = _GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
        d = _GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
        c = _GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
        b = _GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
        a = _GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
        d = _GG(d, a, b, c, x[k + 10], S22, 0x2441453);
        c = _GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
        b = _GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
        a = _GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
        d = _GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
        c = _GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
        b = _GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
        a = _GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
        d = _GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
        c = _GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
        b = _GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
        a = _HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
        d = _HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
        c = _HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
        b = _HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
        a = _HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
        d = _HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
        c = _HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
        b = _HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
        a = _HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
        d = _HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
        c = _HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
        b = _HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
        a = _HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
        d = _HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
        c = _HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
        b = _HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
        a = _II(a, b, c, d, x[k + 0], S41, 0xF4292244);
        d = _II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
        c = _II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
        b = _II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
        a = _II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
        d = _II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
        c = _II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
        b = _II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
        a = _II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
        d = _II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
        c = _II(c, d, a, b, x[k + 6], S43, 0xA3014314);
        b = _II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
        a = _II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
        d = _II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
        c = _II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
        b = _II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
        a = addUnsigned(a, AA);
        b = addUnsigned(b, BB);
        c = addUnsigned(c, CC);
        d = addUnsigned(d, DD);
      }

      var temp = wordToHex(a) + wordToHex(b) + wordToHex(c) + wordToHex(d);

      return temp.toLowerCase();
}

function utf8_encode (argString) {
      // http://kevin.vanzonneveld.net
      // +   original by: Webtoolkit.info (http://www.webtoolkit.info/)
      // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // +   improved by: sowberry
      // +    tweaked by: Jack
      // +   bugfixed by: Onno Marsman
      // +   improved by: Yves Sucaet
      // +   bugfixed by: Onno Marsman
      // +   bugfixed by: Ulrich
      // +   bugfixed by: Rafal Kukawski
      // +   improved by: kirilloid
      // +   bugfixed by: kirilloid
      // *     example 1: utf8_encode('Kevin van Zonneveld');
      // *     returns 1: 'Kevin van Zonneveld'

      if (argString === null || typeof argString === "undefined") {
        return "";
      }

      var string = (argString + ''); // .replace(/\r\n/g, "\n").replace(/\r/g, "\n");
      var utftext = '',
        start, end, stringl = 0;

      start = end = 0;
      stringl = string.length;
      for (var n = 0; n < stringl; n++) {
        var c1 = string.charCodeAt(n);
        var enc = null;

        if (c1 < 128) {
          end++;
        } else if (c1 > 127 && c1 < 2048) {
          enc = String.fromCharCode(
             (c1 >> 6)        | 192,
            ( c1        & 63) | 128
          );
        } else if (c1 & 0xF800 != 0xD800) {
          enc = String.fromCharCode(
             (c1 >> 12)       | 224,
            ((c1 >> 6)  & 63) | 128,
            ( c1        & 63) | 128
          );
        } else { // surrogate pairs
          if (c1 & 0xFC00 != 0xD800) { throw new RangeError("Unmatched trail surrogate at " + n); }
          var c2 = string.charCodeAt(++n);
          if (c2 & 0xFC00 != 0xDC00) { throw new RangeError("Unmatched lead surrogate at " + (n-1)); }
          c1 = ((c1 & 0x3FF) << 10) + (c2 & 0x3FF) + 0x10000;
          enc = String.fromCharCode(
             (c1 >> 18)       | 240,
            ((c1 >> 12) & 63) | 128,
            ((c1 >> 6)  & 63) | 128,
            ( c1        & 63) | 128
          );
        }
        if (enc !== null) {
          if (end > start) {
            utftext += string.slice(start, end);
          }
          utftext += enc;
          start = end = n + 1;
        }
      }

      if (end > start) {
        utftext += string.slice(start, stringl);
      }

      return utftext;
}

function str_replace (search, replace, subject, count) {
      // http://kevin.vanzonneveld.net
      // +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // +   improved by: Gabriel Paderni
      // +   improved by: Philip Peterson
      // +   improved by: Simon Willison (http://simonwillison.net)
      // +    revised by: Jonas Raoni Soares Silva (http://www.jsfromhell.com)
      // +   bugfixed by: Anton Ongson
      // +      input by: Onno Marsman
      // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // +    tweaked by: Onno Marsman
      // +      input by: Brett Zamir (http://brett-zamir.me)
      // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
      // +   input by: Oleg Eremeev
      // +   improved by: Brett Zamir (http://brett-zamir.me)
      // +   bugfixed by: Oleg Eremeev
      // %          note 1: The count parameter must be passed as a string in order
      // %          note 1:  to find a global variable in which the result will be given
      // *     example 1: str_replace(' ', '.', 'Kevin van Zonneveld');
      // *     returns 1: 'Kevin.van.Zonneveld'
      // *     example 2: str_replace(['{name}', 'l'], ['hello', 'm'], '{name}, lars');
      // *     returns 2: 'hemmo, mars'
      var i = 0,
        j = 0,
        temp = '',
        repl = '',
        sl = 0,
        fl = 0,
        f = [].concat(search),
        r = [].concat(replace),
        s = subject,
        ra = Object.prototype.toString.call(r) === '[object Array]',
        sa = Object.prototype.toString.call(s) === '[object Array]';
      s = [].concat(s);
      if (count) {
        this.window[count] = 0;
      }

      for (i = 0, sl = s.length; i < sl; i++) {
        if (s[i] === '') {
          continue;
        }
        for (j = 0, fl = f.length; j < fl; j++) {
          temp = s[i] + '';
          repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
          s[i] = (temp).split(f[j]).join(repl);
          if (count && s[i] !== temp) {
            this.window[count] += (temp.length - s[i].length) / f[j].length;
          }
        }
      }
      return sa ? s : s[0];
}

function zm_contains(a, obj) {
    var i = a.length;
    while (i--) {
       if (a[i] === obj) {
           return true;
       }
    }
    return false;
}

function zm_generate_history_id(id){
    var mode = str_replace('?', '', id);
    mode = str_replace('&', '', mode);
    mode = str_replace('=', '', mode);
    mode = str_replace('/', '', mode);
    mode = str_replace('-', '', mode);

    return md5(decodeURIComponent(mode));
}
