<?php
function zm_login_form($attr) {
	global $post;
	
	$elm = '';
	
	$general = get_option('zm_general_option');
	$after_login = get_permalink(zm_isset($general['after_login_page']));
	if ( is_zm_logged_in() )
		return '<p>You already logged in. Please <a href="' . $after_login . '">click here</a> to continue to the members area';
	
	$recaptcha = zm_isset($attr['recaptcha'], 'no', true);	
	if ($recaptcha == 'yes'){
		if ($publickey = zm_isset($general['rc_public_key'])){
			$elm .= '<script type="text/javascript" src="http://www.google.com/recaptcha/api/js/recaptcha_ajax.js"></script>';
			$elm .= '<script>jQuery(document).ready(function(){
				Recaptcha.create("'.$publickey.'",
					"zm_recaptcha_div",{
						theme: "clean",
						callback: Recaptcha.focus_response_field,
						tabindex : 4
						}
					);
				});</script>';
		}
	}
	
	$template = zm_isset($attr['template'], 'simple', true);
	
	$elm .= '<form method="post" class="zm-required">';
	if (zm_isset($attr['box']) == 'true')
		$elm .= '<div id="zm-login-box-'.$template.'">';
		
	$elm .= '<div id="zm-login-form">';
	if (zm_isset($_GET['zm_login']) == 'false')
		$elm .= '<div class="zm-login-error alert round"><i class="icon-remove-sign icon-large"></i> Wrong Username/Email and password combination.</div>';
		
	else if (zm_isset($_GET['zm_login']) == 'locked')
		$elm .= '<div class="zm-login-error alert round"><i class="icon-remove-sign icon-large"></i> This account is Locked. You can\'t Log in temporarily. Please wait for 5 minutes.</div>';
		
	else if (zm_isset($_GET['zm_captcha']) == 'false')
		$elm .= '<div class="zm-login-error alert round"><i class="icon-remove-sign icon-large"></i> The reCAPTCHA wasn\'t entered correctly.</div>';
		
	else if (zm_isset($_GET['zm_active']) == 'false')
		$elm .= '<div class="zm-login-error alert round"><i class="icon-remove-sign icon-large"></i> This account is inactive. Please contact site owner.</div>';
	
	else if (zm_isset($_GET['zm_active']) == 'true')
		$elm .= '<div class="zm-login-error success round"><i class="icon-ok-sign icon-large"></i> Welcome. Please login to access membership page</div>';
	else if (zm_isset($_GET['reset_pass']) == 'true')
		$elm .= '<div class="zm-login-error success round"><i class="icon-ok-sign icon-large"></i> You have reset your password. Please take a look your email inbox for your new password.</div>';
	
	$elm .= '<input name="zm-username" type="text" placeholder="username or email" class="zm-input" id="zm-log-username-'.$template.'" tabindex="2">';
	$elm .= '<input name="zm-password" type="password" placeholder="password" class="zm-input" id="zm-log-password-'.$template.'" tabindex="3">';
	
	if ($recaptcha == 'yes') $elm .= '<div id="zm_recaptcha_div"></div>';
	
	
	$elm .= '<ul class="zm-button-group">';
	$elm .= '<li><input name="zm-login" type="submit" value="Login" class="zm-button-'.$template.'" tabindex="4"></li>';
	$elm .= '<li><input name="zm-forgot" id="zm-forgot-button" type="button" value="Forgot Password" class="zm-button-forgot-'.$template.'" tabindex="4"></li>';
	$elm .= '</ul>';
	$elm .= '<br><label for="zm-remember" style="text-align: left;"><input name="zm-remember" type="checkbox" id="zm-remember" tabindex="4"> Remember me.</label>';
	$elm .= '</div>';
	
	$elm .= '<div id="zm-forgot-form" style="display:none">';
	$elm .= '<input name="zm-forgot-email" type="text" placeholder="email" class="zm-input email" id="zm-forgot-email-'.$template.'">';
	$elm .= '<ul class="zm-button-group">';
	$elm .= '<li><button name="zm-forgot-send" id="zm-forgot-send" class="zm-button-'.$template.'">Send Reset Password Email</button></li>';
	$elm .= '<li><button name="zm-forgot-back" id="zm-forgot-back" class="zm-button-forgot-'.$template.'"><i class="icon-caret-left"></i>&nbsp;back</button></li>';
	$elm .= '</ul>';
	$elm .= '</div>';
	
	if ( zm_isset($general['is_powered']) == 'on' ) {
		if ( zm_isset($general['aff_link']) ) {
			$aff_link = $general['aff_link'];
		}else{
			$aff_link = zaxaa_referral_url('https://www.zaxaa.com', false);
		}
		
		$elm .= '<p style="color:#a7a7a7"><small>Powered by <a href="'.$aff_link.'" target="_blank" style="text-decoration: underline !important;">Zaxaa Member</a></small></p>';
	}
	
	if (zm_isset($attr['box']) == 'true')
		$elm .= '</div>';
		
	$elm .= '<input type="hidden" name="zm-login-page" value="'.$post->ID.'" />';
	$elm .= '<input type="hidden" name="zm-login-recaptcha" value="'.$recaptcha.'" />';
	
	$elm .= '</form>';
	
    return $elm;
}

function zm_profile_page($attr){
	$elm = '';
	global $post;
	
	$general = get_option('zm_general_option');
	
	if ( is_zm_logged_in() ){
		$member = zm_get_current_member();
		
		$aff_link = '';
		
		if ( zm_isset($general['is_powered']) == 'on' ) {
			if ( zm_isset($general['aff_link']) ) {
				$link = $general['aff_link'];
			}else{
				$link = zaxaa_referral_url('https://www.zaxaa.com', false);
			}
			
			$aff_link = '<p style="color:#a7a7a7; text-align:right"><small>Powered by <a href="'.$link.'" target="_blank" style="text-decoration: underline !important;">Zaxaa Member</a></small></p>';
		}
		
		if (zm_isset($_GET['updated']) == 'false')
			$elm .= '<div class="zm-login-error alert round"><i class="icon-remove-sign icon-large"></i> Network connection error. Please try again.</div>';
		else if (zm_isset($_GET['updated']) == 'true')
			$elm .= '<div class="zm-login-error success round"><i class="icon-check-sign icon-large"></i> Profile updated.</div>';
		else if (zm_isset($_GET['reset_pass']) == 'true')
			$elm .= '<div class="zm-login-error success round">Please CHANGE your password now on this page and click "Update Account".</div>';
		
		$elm .= '<form class="zm-profile" method="post" action="' . zm_format_url(get_permalink($post->ID), 'mode=membership&action=update') . '">
		<input type="hidden" name="zm-nonce" id="zm-nonce" value="' . $member->ID . '">
		<input type="hidden" name="zm_cache_email" id="zm_cache_email" value="' . $member->email . '">
		<input type="hidden" name="zm_cache_username" value="' . zm_sanitize($member->username) . '" />
		<input type="hidden" name="zm_url" value="' . get_permalink($post->ID) . '" />
		<table class="zm-form-table">
		<tr>
			<th><label for="user_login">Username</label></th>
			<td><input type="text" name="zm_username" id="zm_username" value="' . $member->username . '" disabled="disabled" class="zm-regular-text" /> <span class="zm-description">Username cannot be changed.</span></td>
		</tr>
		<tr>
			<th><label for="user_email">Email</label></th>
			<td><input type="text" name="zm_email" id="zm_email" value="' . $member->email . '" class="required email zm-regular-text" /></td>
		</tr>
		<tr>
			<th><label for="first_name">First Name</label></th>
			<td><input type="text" name="zm_fname" id="zm_fname" value="' . $member->first_name . '" class="zm-regular-text" /></td>
		</tr>
		<tr>
			<th><label for="last_name">Last Name</label></th>
			<td><input type="text" name="zm_lname" id="zm_lname" value="' . $member->last_name . '" class="zm-regular-text" /></td>
		</tr>
		<tr>
			<td colspan="2"><b>Change Password</b><p class="zm-description">If you would like to change the password type a new one. Otherwise leave these blank.</p></td>
		</tr>
		<tr>
			<th><label for="user_login">New Password</label></th>
			<td><input type="password" name="zm_password" id="zm_password" class="zm-regular-text" /> </td>
		</tr>
		<tr>
			<th><label for="user_email">Retype Password</label></th>
			<td><input type="password" name="zm_repassword" id="zm_repassword" class="zm-regular-text" /></td>
		</tr>
		<tr>
			<th></th>
			<td>
				<input type="submit" name="submit" id="submit" value="Update Account" class="zm-submit zm-button-simple" />
				'.$aff_link.'
			</td>
		</tr>
		</table>
		</form>
		';
	}else{
		$elm .= '<div id="zm_protected_box">Please <a href="'.zm_format_url($general['login_page'], 'redir='.$post->ID).'">login here</a> to view your profile page.</div>';
	}

	return $elm;
}

function zm_hosted_video($attr){
	
	$code = md5(zm_isset($attr['mp4']).'-'.zm_isset($attr['webm']).'-'.zm_isset($attr['ogg']));
	
	$elm = '<div id="zm_player_'.$code.'"></div>';
	$elm .= '<script type="text/javascript">jQuery(function () { // ensure DOM is ready
			   // this will install flowplayer into an element with id="player"
			   jQuery("#zm_player_'.$code.'").flowplayer({
			      // one video: a one-member playlist
			      playlist: [
			         // a list of type-url mappings in picking order
			         [
			            { mp4:  "'.$attr['mp4'].'" },
			            { webm: "'.$attr['webm'].'" },
			            { ogg:  "'.$attr['ogg'].'" }
			         ]
			      ],
			      embed: false,
			      adaptiveRatio: true // video with 4:3 aspect ratio
			   });
			 
			});</script>';
			
	return $elm;
}

function zm_s3_video($attr){
	
	$code = md5(zm_isset($attr['mp4']).'-'.zm_isset($attr['webm']).'-'.zm_isset($attr['ogg']));
	
	$elm = '<div id="zm_player_'.$code.'"></div>';
	$elm .= '<script type="text/javascript">jQuery(function () { // ensure DOM is ready
			   // this will install flowplayer into an element with id="player"
			   jQuery("#zm_player_'.$code.'").flowplayer({
			      // one video: a one-member playlist
			      playlist: [
			         // a list of type-url mappings in picking order
			         [
			            { mp4:  "'.html_entity_decode($attr['mp4']).'" },
			            { webm: "'.html_entity_decode($attr['webm']).'" },
			            { ogg:  "'.html_entity_decode($attr['ogg']).'" }
			         ]
			      ],
			      embed: false,
			      adaptiveRatio: true // video with 4:3 aspect ratio
			   });
			 
			});</script>';
			
	return $elm;
}

function zm_protect($attr, $content = ''){
	if ($attr['id'] != ''){
		$access = false;
		$product_list = array();
		
		if ( is_zm_logged_in() ){
			$member = zm_get_current_member();
			
			$metadata = zm_get_all('payment', $member->ID, 'access');
			if ($metadata){
				//collecting product ids
				foreach ($metadata as $meta) {
					if (!in_array($meta->product_id, $product_list)){
						$product_list[] = $meta->product_id;
					}
				}
			}
			
			$protect_ids = explode(',', $attr['id']);
			//$except_ids = array();
			//if (zm_isset($attr['except'], '', true) != '') $except_ids = explode(',', $attr['except']);
			
			//check previlieges
			foreach ($protect_ids as $id){
				if (in_array(trim($id), $product_list)){
					$access = true;
					break;
				}
			}
			
			if ($access){
				//yeah,, i know you should be able to view this page.. but sorry, you are also in except list..
				//foreach($except_ids as $id){
				//	if (in_array(trim($id), $product_list)){
				//		$access = false;
				//		break;
				//	}
				//}
				return $content;
			}
		}

		if (!$access){
			$general = get_option('zm_general_option');
			
			
			$message =  '<div id="zm_protected_box">You do NOT have sufficient permissions to view the rest of the content on this page. <br>You have to <a href="'.zm_isset($attr['uplink']).'" target="_blank">upgrade your membership level/product</a> first.';
			
			if (!is_zm_logged_in()) $message .= '<br>If you have already purchased, <a href="'.get_permalink($general['login_page']).'" target="_blank">login now</a> to view the content</div>';
			else $message .= '</div>';
			
			return $message;
		}
	}else{
		return $content;
	}
}

function zm_history(){
	$elm = '';
	
	$member = zm_get_current_member();
	if ($member){
		$elm .= '<script type="text/javascript" src="'.ZM_URL . 'js/jquery.colorbox-min.js"></script>';
		$elm .= '<link rel="stylesheet" href="'.ZM_URL . 'css/colorbox.css" type="text/css" media="screen">';
		$elm .= '<table class="zm-table-purchase">';
		$elm .= '<tr>';
		$elm .= '<th>No</th>';
		$elm .= '<th>Product Name</th>';
		$elm .= '<th>Amount</th>';
		$elm .= '<th colspan="2">Period</th>';
		$elm .= '<th>Payment Type</th>';
		$elm .= '<th></th>';
		$elm .= '</tr>';
		
		$metadatas = zm_get_all('payment', $member->ID, 'history');
		if ($metadatas){
			$i=1;
			$type = array('free' => 'Free', 'onetime' => 'One Time', 'subscription' => 'Subscription');
			
			foreach ($metadatas as $metadata){
				$elm .= '<tr>';
				$elm .= '<td>'.$i.'.</td>';
				$elm .= '<td>'.($metadata->title ? '<a href="'.zm_get_download_link($metadata->product_id).'" title="Go To Access Page">'.$metadata->title.'</a>' : '-deleted-').'</td>';
				$elm .= '<td>'.($metadata->amount > 0 ? $metadata->amount : 'Free').'</td>';
				
				if ($metadata->type == 'subscription')
					$elm .= '<td>'.date("M d, Y", $metadata->begin_date).'</td><td>'.date("M d, Y", $metadata->expired_date).'</td>';
				else
					$elm .= '<td colspan="2" style="text-align:center">Lifetime</td>';
					
				$elm .= '<td>'.$type[$metadata->type].'</td>';
				$elm .= '<td><a href="#" class="zm-purchase-detail" mid="'.$member->ID.'" id="'.$metadata->product_id.'">detail</a></td>';
				$elm .= '<tr>';
				$i++;
			}
		}else{
			$elm .= '<tr><td colspan="7" style="text-align: center;">No Data</td></tr>';
		}
		
		$elm .= '</table>';
		
		$elm .= "<script>
		jQuery('.zm-purchase-detail').each(function(){
			jQuery(this).click(function(e){
				e.preventDefault();
				
				var id = jQuery(this).attr('id');
				var mid = jQuery(this).attr('mid');
				
				jQuery.colorbox({
			        opacity: '0.7',
			       	width: '75%',
			        href: '".site_url()."/?page=zm_purchase&mode=history&id='+id+'&mid='+mid,
			        height: '75%',
					fixed :true,
					iframe: true
		    	});
			});
		});	
		</script>";
	}else{
		global $post;
		$general = get_option('zm_general_option');
		$elm .= '<div id="zm_protected_box">Please <a href="'.zm_format_url($general['login_page'], 'redir='.$post->ID).'">login here</a> to view your profile page.</div>';
	}

	return $elm;
}

function zm_upgrade_link( $attr, $content = '' ) {
	if ( zm_isset($attr['id']) && zm_isset($attr['url']) ) {
		$ids = explode(',', str_replace(' ', '', $attr['id']));
		$urls = explode(',', str_replace(' ', '', $attr['url']));
		$master = array();
		foreach ( $ids as $key => $value ) {
			$master[$value] = $urls[$key];
		}
		
		$link = '';
		if ( isset($_COOKIE['zm_access_er']) ) {
			$id = $_COOKIE['zm_access_er'];
			$levels = zm_is_protected($id);
			
			if ( $levels ) {
				foreach ( $levels as $level ) {
					if ( isset($master[$level]) ) {
						$link .= '<a href="'.$master[$level].'" target="_blank">' . $content . '</a>';
						break;
					}
				}
				
				return $link;
			}
		}	
	}
	return $content;
}

function zm_purchased_products_links(){
	$elm = '';
	
	$member = zm_get_current_member();
	if($member){
		$metadatas = zm_get_all('payment', $member->ID, 'history');
		if ($metadatas){
			foreach ($metadatas as $metadata){
				$elm .= '<a class="zm-download-links" href="'.zm_get_download_link($metadata->product_id).'">'.$metadata->title.'</a>';
			}
		}
	}else{
		$general = get_option('zm_general_option');
		$elm .= '<div id="zm_protected_box">Please <a href="'.get_permalink($general['login_page']).'">login here</a> to view your purchased products links.</div>';
	}
	
	return $elm;
}

function zm_ajaxurl() {
?>
<!-- ZM ajaxurl -->
<script type="text/javascript">
//<![CDATA[
var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
//]]>
</script>
<?php
}

add_action('wp_head','zm_ajaxurl', 11);
add_shortcode('zm_hosted_video', 'zm_hosted_video');
add_shortcode('zm_login_form', 'zm_login_form');
add_shortcode('zm_profile_page', 'zm_profile_page');
add_shortcode('zm_protect', 'zm_protect');
add_shortcode('zm_s3_video', 'zm_s3_video');
add_shortcode('zm_order', 'zm_order');
add_shortcode('zm_history', 'zm_history');
add_shortcode('zm_upgrade', 'zm_upgrade_link');
add_shortcode('zm_purchased_products_links', 'zm_purchased_products_links');

//enable on widget text
add_filter('widget_text', 'do_shortcode');