<?php
class ZMember_Login extends WP_Widget {
	function ZMember_Login() {
		$instance = array('description' => 'Drag n drop this widget to display a member login form.' );
		parent::WP_Widget(false, 'Zaxaa Member - Login Form', $instance);      
	}

	function widget($args, $instance) {
		extract($args);
		
		echo $before_widget;
		$general = get_option('zm_general_option');
		
		$title = ( $instance['title'] != '' ) ? $instance['title'] : 'Member Login';
		if ( is_zm_logged_in() ) {
			$member = zm_get_current_member();
			
			$display_name = ( !empty($member->first_name) ) ? zm_sanitize($member->first_name) . ' ' . zm_sanitize($member->last_name) : $member->username; 
			echo '<div style="float:left; margin-right:10px">' . get_avatar($member->email, '70') . '</div>';
			echo '<span style="font-weight:bold">Welcome, ' . $display_name . '!</span>';
			echo '<p><a href="'.get_permalink($general['profile_page']).'">Profile</a> | <a href="' . zm_logout_url() . '">Logout</a></p>';
			echo '<div style="clear:left"></div>';
		} else {
			echo '<h5>' . $title . '</h5>';
			$login_id = zm_isset($general['login_page']);
	
			//$nonce = wp_create_nonce('zm-nonce');
			//$proto = ( is_ssl() ) ? 'https://' : 'http://';
			//$redir_url = $proto . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
			
			echo '
			<form name="zm-login-form' . $widget_id . '" id="zm-login-form' . $widget_id . '" method="post">
			<div id="zm-login-form">
				<input type="hidden" name="zm-login-page" value="' . $login_id . '" />
				<div id="zm-login-form" style="margin-top:15px">
					<input type="text" id="zm-username' . $widget_id . '" name="zm-username" class="zm-input zm-widget-log-username" placeholder="username or email" />
					<input type="password" id="zm-password' . $widget_id . '" name="zm-password" class="zm-input zm-widget-log-password" placeholder="password" />
				</div>
				<input name="zm-login" type="submit" value="Login" id="zm-login' . $widget_id . '" class="zm-button-simple" tabindex="4" style="width:100%">
				<p class="login-remember"><label><input name="zm-remember" type="checkbox" value="1" /> Remember Me</label></p>
				<p style="text-align:right;"><a href="javascript:undefined;" id="zm-forgot-button" tabindex="4">Forgot Password&nbsp;<i class="icon-caret-right"></i></a></p>
			</div>
			<div id="zm-forgot-form" style="display:none">
				<br>
				<input name="zm-forgot-email" type="text" placeholder="email" class="zm-input email" id="zm-forgot-email-simple">
				<button name="zm-forgot-send" id="zm-forgot-send" class="zm-button-simple" style="width:100%">Send Reset Password Email</button>
				<br><br>
				<a href="javascript:undefined;" id="zm-forgot-back"><i class="icon-caret-left" ></i>&nbsp;back</a>
			</div>
			</form>
			';
		}
		
		echo $after_widget;
	}

	function update($new_instance, $old_instance) {                
		return $new_instance;
	}

	function form( $instance ) {    
		$title = esc_attr(zm_isset($instance['title']));

		echo '
       	 	<p>
            	<label for="' . $this->get_field_id('title') . '">Title (optional):</label>
            	<input type="text" name="' . $this->get_field_name('title') . '" value="' . $title . '" class="widefat" id="' . $this->get_field_id('title') . '" />
        	</p>
        	';

	}
}

add_action('widgets_init', 'zm_register_widget');
function zm_register_widget() {
	register_widget('ZMember_Login');
}

add_action('wp_head', 'zm_dequeue_style');
function zm_dequeue_style(){
	if (ZM_CURRENT_THEME === 'lumen' || ZM_CURRENT_THEME === 'Icy'){
		wp_dequeue_style('zm-font-awesome-min', ZM_URL . 'css/font-awesome.min.css');
		wp_dequeue_style('zm-font-awesome-ie7', ZM_URL . 'css/font-awesome-ie7.min.css');
	}
}
